unit HDEngine;

{*******************************************************************************
*******************  PLEASE DON'T CHANGE/REMOVE THIS HEADER  *******************
********************************************************************************
*******************************   Original File   ******************************
********************************************************************************
**                                                                            **
**  Hacker Disassembler Engine 32 0.11                                        **
**  Author:    Veacheslav Patkov                                              **
**  E-mail:    patkov-mail@mail.ru                                            **
**  Web-site:  http://patkov-site.narod.ru/eng.html                           **
**  Copyright (c) 2006-2008, Veacheslav Patkov                                **
**  All rights reserved.                                                      **
**                                                                            **
********************************************************************************
*********************************   This File   ********************************
********************************************************************************
**                                                                            **
**	Title:		HDEngine 0.11                                                   **
**	Version:	0.11.1                                                          **
**	Desc:		Hacker Disassembler Engine 0.11 (Pascal/Delphi version)           **
**	Author:		in4matics - in4matics [at] hotmail [d0t] com                    **
**	Www:		AT4RE Team Forum - http://www.at4re.com                           **
**	Date:		2008-03-10                                                        **
**                                                                            **
********************************************************************************
*******************************************************************************}


interface

uses
	Windows;

type
	HDEInstruction = packed record
		len        : byte;     { length of command                             }
		p_rep      : byte;     { rep/repz (0xf3) & repnz (0xf2) prefix         }
		p_lock     : byte;     { lock prefix: 0xf0                             }
		p_seg      : byte;     { segment prefix: 0x2e,0x36,0x3e,0x26,0x64,0x65 }
		p_66       : byte;     { operand-size override prefix: 0x66            }
		p_67       : byte;     { address-size override prefix: 0x67            }
		opcode     : byte;     { opcode                                        }
		opcode2    : byte;     { second opcode (if first opcode is 0x0f)       }
		modrm      : byte;     { ModR/M byte                                   }
		modrm_mod  : byte;     {   mod field of ModR/M                         }
		modrm_reg  : byte;     {   reg field of ModR/M                         }
		modrm_rm   : byte;     {   r/m field of ModR/M                         }
		sib        : byte;     { SIB byte                                      }
		sib_scale  : byte;     {   scale field of SIB                          }
		sib_index  : byte;     {   index field of SIB                          }
		sib_base   : byte;     {   base field of SIB                           }
		imm8       : byte;     { immediate value imm8                          }
		imm16      : word;     { immediate value imm16                         }
//		imm32      : dword;    { immediate value imm32                       }
		inm32      : dword;    { immediate value imm32                         }    // se modifica a inm32 por error en C++
		disp8      : byte;     { displacement disp8                            }
		disp16     : word;     { displacement disp16                           }
		disp32     : dword;    { displacement disp32                           }
		rel8       : byte;     { relative address rel8                         }
		rel16      : word;     { relative address rel16                        }
		rel32      : dword;    { relative address rel32                        }

{i}		imm32_offs : byte;     { immediate value (imm32) offset in code        }
{i}		disp32_offs: byte;     { displacement (disp32) offset in code          }
{i}		rel32_offs : byte;     { relative address (rel32) offset in code       }
	end;

function HDEDisasm(code: pointer; var instruction: HDEInstruction): dword; cdecl;

implementation

function HDEDisasm(code: pointer; var instruction: HDEInstruction): dword; cdecl;
const
	hde32s_size	= $28;

	C_NONE   	= $00;
	C_MODRM  	= $01;
	C_DATA8  	= $02;
	C_DATA16 	= $04;
	C_DATA32 	= $08;
	C_PRE66  	= $10;
	C_REL8   	= $20;
	C_REL32  	= $40;

	data_table :pchar =
	#$89#$83#$89#$83#$89#$83#$89#$83#$89#$83#$89#$83#$89#$83#$89#$83#$85#$85#$85#$85#$85#$85#$85#$85#$87#$85#$93#$85#$9A#$9A#$9A#$9A#$A0#$89#$89#$89#$85#$85#$A7#$85#$90#$85#$83#$85#$80#$80#$90#$90#$AB#$9E#$AF#$CA#$89#$C7#$89#$89#$9A#$80#$97#$85#$85#$87#$85#$87#$49#$45#$45#$79#$49#$49#$4C#$45#$49#$78#$49#$49#$45#$45#$45#$45#$49#$49#$49#$49#$49#$49#$49#$49#$49#$49#$49#$49#$62#$4A#$45#$49#$7D#$7D#$7D#$7D#$49#$49#$49#$49#$46#$74#$46#$81#$49#$49#$8C#$49#$83#$63#$45#$45#$49#$49#$49#$49#$49#$49#$49#$49#$49#$49#$49#$4A#$02#$02#$02#$02#$10#$00#$00#$00#$00#$01#$01#$01#$01#$00#$00#$00#$10#$10#$10#$10#$11#$02#$03#$50#$50#$14#$20#$20#$20#$20#$01#$01#$03#$11#$03#$03#$03#$03#$01#$00#$00#$14#$00#$03#$03#$04#$00#$06#$00#$04#$00#$02#$03#$01#$00#$00#$01#$00#$01#$00#$03#$50#$50#$50#$50#$03#$01#$01#$01#$03#$01#$02#$02#$00#$00#$02#$00#$00#$03#$01#$31#$C0#$40#$C2#$0C#$00;
begin
asm
	pushad

{i}	mov	edi,instruction //[esp+40]
	xor	eax,eax
	xor	ecx,ecx
	xor	ebx,ebx
	cdq
	mov	cl,hde32s_size
	rep	stosb
	sub	edi,dword(hde32s_size)
{i}	mov	esi,code //[esp+36]
@pref:
	lodsb
	cmp	al,$f3
	jz	@pref_rep
	cmp	al,$f2
	jnz	@no_pref_rep
@pref_rep:
	mov	[edi+HDEInstruction.p_rep],al
	jmp @pref
@no_pref_rep:
	cmp	al,$f0
	jnz	@no_pref_lock
	mov	[edi+HDEInstruction.p_lock],al
	jmp	@pref
@no_pref_lock:
	cmp	al,$2e
	jz	@pref_seg
	cmp	al,$36
	jz	@pref_seg
	cmp	al,$3e
	jz	@pref_seg
	cmp	al,$26
	jz	@pref_seg
	cmp	al,$64
	jz	@pref_seg
	cmp	al,$65
	jnz	@no_pref_seg
@pref_seg:
	mov	[edi+HDEInstruction.p_seg],al
	jmp	@pref
@no_pref_seg:
	cmp	al,$66
	jnz	@no_pref_66
	mov	[edi+HDEInstruction.p_66],al
	mov	dl,1
	jmp	@pref
@no_pref_66:
	cmp	al,$67
	jnz	@no_pref_67
	mov	[edi+HDEInstruction.p_67],al
	mov	bl,1
	jmp	@pref
@no_pref_67:
	mov	[edi+HDEInstruction.opcode],al
	mov	bh,al

//	call @get_delta
//@get_delta:
//	pop	ecx
//	add	ecx,$157
{i}	mov ecx, data_table

	cmp	al,$0f
	jnz	@no_opcode2
	lodsb
	mov	[edi+HDEInstruction.opcode2],al
{i}	add	ecx,$40
	jmp	@modrm
@no_opcode2:
	cmp	al,$a0
	jb	@modrm
	cmp	al,$a3
	ja	@modrm
	mov	dl,bl
@modrm:
	mov	dh,al
	and	dh,3
	shr	al,2
	mov	al,[ecx+eax]
	add	al,dh
	mov	cl,[ecx+eax]
	test	cl,C_MODRM
	jz	@imm
	lodsb
	mov	[edi+HDEInstruction.modrm],al
	mov	ch,al
	shr	ch,6
	mov	[edi+HDEInstruction.modrm_mod],ch
	mov	dh,al
	and	dh,7
	mov	[edi+HDEInstruction.modrm_rm],dh
	shl	al,2
	shr	al,5
	mov	[edi+HDEInstruction.modrm_reg],al
	cmp	al,1
	lodsb
	ja	@no_f7
	cmp	bh,$f6
	jnz	@no_f6
	or	cl,C_DATA8
@no_f6:
	cmp	bh,$f7
	jnz	@no_f7
	or	cl,C_PRE66
@no_f7:
	xor	bh,bh
	or	ch,ch
	jnz	@no_mod_0
	or	bl,bl
	jz	@no_p67
	cmp	dh,6
	jnz	@no_mod_0
	mov	bh,2
	jmp	@no_mod_0
@no_p67:
	cmp	dh,5
	jnz	@no_mod_0
	mov	bh,4
@no_mod_0:
	cmp	ch,1
	jnz	@no_mod_1
	mov	bh,1
@no_mod_1:
	cmp	ch,2
	jnz	@no_mod_2
	or	bl,bl
	jz	@no_p67_
	mov	bh,2
	jmp @no_mod_2
@no_p67_:
	mov	bh,4
@no_mod_2:
	cmp	ch,3
	jz	@disp
	cmp	dh,4
	jnz	@disp
	or	bl,bl
	jnz	@disp
	inc	esi
	mov	[edi+HDEInstruction.sib],al
	mov	ah,al
	shr	ah,6
	mov	[edi+HDEInstruction.sib_scale],ah
	mov	ah,al
	shl	ah,2
	shr	ah,5
	mov	[edi+HDEInstruction.sib_index],ah
	and	al,7
	mov	[edi+HDEInstruction.sib_base],al
	cmp	al,5
	jnz	@disp
	or	ch,ch
	jz	@mod_0
	cmp	ch,2
	jnz	@disp
@mod_0:
	mov	bh,4
@disp:
	dec	esi
	cmp	bh,1
	jnz	@no_disp8
	lodsb
	mov	[edi+HDEInstruction.disp8],al
@no_disp8:
	cmp	bh,2
	jnz	@no_disp16
	lodsw
	mov	[edi+HDEInstruction.disp16],ax
@no_disp16:
	cmp	bh,4
	jnz	@imm
	lodsd
	mov	[edi+HDEInstruction.disp32],eax
{i}	mov eax, esi
{i}	sub eax, code
{i}	sub eax, 4
{i}	mov	[edi+HDEInstruction.disp32_offs],al
@imm:
	test	cl,C_PRE66
	jz	@no_pre66
	test	cl,C_REL32
	jz	@no_rel32
	or	dl,dl
	jz	@no_p66
	lodsw
	mov	[edi+HDEInstruction.rel16],ax
	jmp @hde_dasm_end
@no_p66:
	lodsd
	mov	[edi+HDEInstruction.rel32],eax
{i}	mov eax, esi
{i}	sub eax, code
{i}	sub eax, 4
{i}	mov	[edi+HDEInstruction.rel32_offs],al
	jmp @hde_dasm_end
@no_rel32:
	or	dl,dl
	jz	@no_p66_
	lodsw
	mov	[edi+HDEInstruction.imm16],ax
	jmp @no_pre66
@no_p66_:
	lodsd
//	mov	[edi+HDEInstruction.imm32],eax
	mov	[edi+HDEInstruction.inm32],eax
{i}	mov eax, esi
{i}	sub eax, code
{i}	sub eax, 4
{i}	mov	[edi+HDEInstruction.imm32_offs],al
@no_pre66:
	test	cl,C_DATA32
	jz	@no_imm32
	lodsd
//	mov	[edi+HDEInstruction.imm32],eax
	mov	[edi+HDEInstruction.inm32],eax
{i}	mov eax, esi
{i}	sub eax, code
{i}	sub eax, 4
{i}	mov	[edi+HDEInstruction.imm32_offs],al
@no_imm32:
	test	cl,C_DATA16
	jz	@no_imm16
	lodsw
	mov	[edi+HDEInstruction.imm16],ax
@no_imm16:
	test	cl,C_DATA8
	jz	@no_imm8
	lodsb
	mov	[edi+HDEInstruction.imm8],al
@no_imm8:
	test	cl,C_REL32
	jz	@no_rel32_
	lodsd
	mov	[edi+HDEInstruction.rel32],eax
{i}	mov eax, esi
{i}	sub eax, code
{i}	sub eax, 4
{i}	mov	[edi+HDEInstruction.rel32_offs],al
@no_rel32_:
	test	cl,C_REL8
	jz	@hde_dasm_end
	lodsb
	mov	[edi+HDEInstruction.rel8],al
@hde_dasm_end:
	xchg	eax,esi
{i}	sub	eax,code //[esp+36]
	stosb
//	mov	[esp+28],eax
{i}	mov @result, eax

	popad
end;
end;

end.
