unit DbgCLS;

//xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
// TBbgCLS Componente para depuracin en delphi.
// 11/11/2009  V 1.09
// Por stzwei para CracksLatinos
//xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
(*******************************************************************************
// Objetivo del componente:
//**************************
// Implementar un componente que facilite la creacin de loaders / debuggers en delphi.
// El componente aportar los mtodos, propiedades y eventos necesarios para colocar puntos de ruptura,
// leer y escribir en memoria, modificar registros etc. En general, todas las posibilidades que ofrece
// un bucle de depuracin realizado mediante las API WaitForDebugEvent - ContinueDebugEvent
//******************************************************************************)
// Disclaimer
//***********
// Eres libre de hacer lo que quieras con el componente pero siempre bajo tu entera responsabilidad.
// Recuerda que esta es una versin inicial y por tanto es ms que probable que existan errores.
// Todos los comentarios modificaciones o mejoras sern bien recibidas.
// Una mencin a los autores y al grupo al que pertenecen ser apreciada.
//******************************************************************************)
// Contacto
// ********
// stzwei@yahoo.com.ar
//******************************************************************************)
// Agradecimientos
//****************
// A toda la lista CracksLatinos con el maestro Ricardo a la cabeza.
//xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Registry, Dialogs,
  Find, HDEngine, CLSDisasm, PsApi;

const
// Mscaras extraidas del tutorial  SEH - AIRBAG PARA TU CDIGO Por Mr. Silver (BlackFenix)
// http://members.fortunecity.com/blackfenix/seh.html
// Corregido DR1_LEN, DR2_LEN, DR3_LEN respecto original

DR0_LOCAL_EXACT_BPM_ENABLED  = $01;      //                                             1
DR0_GLOBAL_EXACT_BPM_ENABLED = $02;      //                                            10
                                         // bits  3322 2222 2222 1111 1111 1100 0000 0000
                                         //       1098 7654 3210 9876 5432 1098 7654 3210
                                         //       ---------------------------------------
DR0_W                        = $10000;   //                        01 0000 0000 0000 0000
DR0_IO                       = $20000;   //                        10 0000 0000 0000 0000
DR0_RW                       = $30000;   //                        11 0000 0000 0000 0000
DR0_EXECUTION                = $0;       //                        00 0000 0000 0000 0000
                                         // bits  3322 2222 2222 1111 1111 1100 0000 0000
                                         //       1098 7654 3210 9876 5432 1098 7654 3210
                                         //       ---------------------------------------
DR0_LEN1                     = $0;       //                      0000 0000 0000 0000 0000
DR0_LEN2                     = $40000;   //                      0100 0000 0000 0000 0000
DR0_LEN4                     = $C0000;   //                      1100 0000 0000 0000 0000
DR0_LENU                     = $80000;   //                      1000 0000 0000 0000 0000
                                         // bits  3322 2222 2222 1111 1111 1100 0000 0000
                                         //       1098 7654 3210 9876 5432 1098 7654 3210
                                         //       ---------------------------------------
DR1_LOCAL_EXACT_BPM_ENABLED  = $4;       //                                           100
DR1_GLOBAL_EXACT_BPM_ENABLED = $8;       //                                          1000
                                         // bits  3322 2222 2222 1111 1111 1100 0000 0000
                                         //       1098 7654 3210 9876 5432 1098 7654 3210
                                         //       ---------------------------------------
DR1_W                        = $100000;  //                   01 0000 0000 0000 0000 0000
DR1_IO                       = $200000;  //                   10 0000 0000 0000 0000 0000
DR1_RW                       = $300000;  //                   11 0000 0000 0000 0000 0000
DR1_EXECUTION                = $0;       //                   00 0000 0000 0000 0000 0000
                                         // bits  3322 2222 2222 1111 1111 1100 0000 0000
                                         //       1098 7654 3210 9876 5432 1098 7654 3210
                                         //       ---------------------------------------
DR1_LEN1                     = $0;       //                 0000 0000 0000 0000 0000 0000
DR1_LEN2                     = $400000;  //                 0100 0000 0000 0000 0000 0000
DR1_LEN4                     = $C00000;  //                 1100 0000 0000 0000 0000 0000
DR1_LENU                     = $800000;  //                 1000 0000 0000 0000 0000 0000
                                         // bits  3322 2222 2222 1111 1111 1100 0000 0000
                                         //       1098 7654 3210 9876 5432 1098 7654 3210
                                         //       ---------------------------------------
DR2_LOCAL_EXACT_BPM_ENABLED  = $10;      //                                        1 0000
DR2_GLOBAL_EXACT_BPM_ENABLED = $20;      //                                       10 0000
                                         // bits  3322 2222 2222 1111 1111 1100 0000 0000
                                         //       1098 7654 3210 9876 5432 1098 7654 3210
                                         //       ---------------------------------------
DR2_W                       = $1000000;  //              01 0000 0000 0000 0000 0000 0000
DR2_IO                      = $2000000;  //              10 0000 0000 0000 0000 0000 0000
DR2_RW                      = $3000000;  //              11 0000 0000 0000 0000 0000 0000
DR2_EXECUTION               = $0;        //              00 0000 0000 0000 0000 0000 0000
                                         // bits  3322 2222 2222 1111 1111 1100 0000 0000
                                         //       1098 7654 3210 9876 5432 1098 7654 3210
                                         //       ---------------------------------------
DR2_LEN1                    = $0;        //            0000 0000 0000 0000 0000 0000 0000
DR2_LEN2                    = $4000000;  //            0100 0000 0000 0000 0000 0000 0000
DR2_LEN4                    = $C000000;  //            1100 0000 0000 0000 0000 0000 0000
DR2_LENU                    = $8000000;  //            1000 0000 0000 0000 0000 0000 0000
                                         // bits  3322 2222 2222 1111 1111 1110 0000 0000
                                         //       1098 7654 3210 9876 5432 1098 7654 3210
                                         //       ---------------------------------------
DR3_LOCAL_EXACT_BPM_ENABLED = $40;       //                                      100 0000
DR3_GLOBAL_EXACT_BPM_ENABLED= $80;       //                                     1000 0000
                                         // bits  3322 2222 2222 1111 1111 1100 0000 0000
                                         //       1098 7654 3210 9876 5432 1098 7654 3210
                                         //       ---------------------------------------
DR3_W                       = $10000000; //         01 0000 0000 0000 0000 0000 0000 0000
DR3_IO                      = $20000000; //         10 0000 0000 0000 0000 0000 0000 0000
DR3_RW                      = $30000000; //         11 0000 0000 0000 0000 0000 0000 0000
DR3_EXECUTION               = $0;        //         00 0000 0000 0000 0000 0000 0000 0000
                                         // bits  3322 2222 2222 1111 1111 1100 0000 0000
                                         //       1098 7654 3210 9876 5432 1098 7654 3210
                                         //       ---------------------------------------
DR3_LEN1                    = $0;        //       0000 0000 0000 0000 0000 0000 0000 0000
DR3_LEN2                    = $40000000; //       0100 0000 0000 0000 0000 0000 0000 0000
DR3_LEN4                    = $C0000000; //       1100 0000 0000 0000 0000 0000 0000 0000
DR3_LENU                    = $80000000; //       1000 0000 0000 0000 0000 0000 0000 0000

// Bits generales
                                         // bits  3322 2222 2222 1111 1111 1100 0000 0000
                                         //       1098 7654 3210 9876 5432 1098 7654 3210
                                         //       ---------------------------------------
LOCAL_EXACT_BPM_ENABLED     = $100;      //                                   1 0000 0000
LOCAL_EXACT_BPM_DISABLED    = $0;        //                                   0 0000 0000
GLOBAL_EXACT_BPM_ENABLED    = $200;      //                                  10 0000 0000
GLOBAL_EXACT_BPM_DISABLED   = $0;        //                                  00 0000 0000
GENERAL_DETECT_ENABLED      = $2000;     //                             10 0000 0000 0000
RESERVED_BIT10              = $400;      //                                 100 0000 0000 // el tpico 0x400 que nos indica SICE ;)
                                         // bits  3322 2222 2222 1111 1111 1100 0000 0000
                                         //       1098 7654 3210 9876 5432 1098 7654 3210
                                         //       ---------------------------------------
CLEAR_DR0                   = $FFF0FFFC; //       1111 1111 1111 0000 1111 1111 1111 1100
CLEAR_DR1                   = $FF0FFFF3; //       1111 1111 0000 1111 1111 1111 1111 0011
CLEAR_DR2                   = $F0FFFFCF; //       1111 0000 1111 1111 1111 1111 1100 1111
CLEAR_DR3                   = $FFFFF3F;  //       0000 1111 1111 1111 1111 1111 0011 1111

// Mascaras para activar bits de EFlag
// Gracias Spandau por la idea
MSK_CF                      = $1;        //       0000 0000 0000 0000 0000 0000 0000 0001-> Carry Flag -> bit 0
MSK_PF                      = $4;        //       0000 0000 0000 0000 0000 0000 0000 0100-> Parity Flag -> bit 2
MSK_AF                      = $10;       //       0000 0000 0000 0000 0000 0000 0001 0000 -> Adjust Flag -> bit 4
MSK_ZF                      = $40;       //       0000 0000 0000 0000 0000 0000 0100 0000 -> Zero Flag -> bit 6
MSK_SF                      = $80;       //       0000 0000 0000 0000 0000 0000 1000 0000 -> Sign Flag -> bit 7
MSK_TF                      = $100;      //       0000 0000 0000 0000 0000 0001 0000 0000 -> Trap Flag -> bit 8
MSK_IF                      = $200;      //       0000 0000 0000 0000 0000 0010 0000 0000 -> Interrupt enable Flag -> bit 9
MSK_DF                      = $400;      //       0000 0000 0000 0000 0000 0100 0000 0000 -> Direction Flag -> bit 10
MSK_OF                      = $800;      //       0000 0000 0000 0000 0000 1000 0000 0000 -> Overflow Flag -> bit 11
//                          = $10000     //       0000 0000 0000 0001 0000 0000 0000 0000 -> Resume Flag -> bit 16 

N_MSK_CF                    = $FFFFFFFE; //       1111 1111 1111 1111 1111 1111 1111 1110-> Carry Flag -> bit 0
N_MSK_PF                    = $FFFFFFFB; //       1111 1111 1111 1111 1111 1111 1111 1011-> Parity Flag -> bit 2
N_MSK_AF                    = $FFFFFFEF; //       1111 1111 1111 1111 1111 1111 1110 1111 -> Adjust Flag -> bit 4
N_MSK_ZF                    = $FFFFFFBF; //       1111 1111 1111 1111 1111 1111 1011 1111 -> Zero Flag -> bit 6
N_MSK_SF                    = $FFFFFF7F; //       1111 1111 1111 1111 1111 1111 0111 1111 -> Sign Flag -> bit 7
N_MSK_TF                    = $FFFFFEFF; //       1111 1111 1111 1111 1111 1110 1111 1111 -> Trap Flag -> bit 8
N_MSK_IF                    = $FFFFFDFF; //       1111 1111 1111 1111 1111 1101 1111 1111 -> Interrupt enable Flag -> bit 9
N_MSK_DF                    = $FFFFFBFF; //       1111 1111 1111 1111 1111 1011 1111 1111 -> Direction Flag -> bit 10
N_MSK_OF                    = $FFFFF7FF; //       1111 1111 1111 1111 1111 0111 1111 1111 -> Overflow Flag -> bit 11

NAME_DUMP                   = '_dumped.exe';

cOsUnknown = -1;
cOsWin95   = 0;
cOsWin98   = 1;
cOsWin98SE = 2;
cOsWinME   = 3;
cOsWinNT   = 4;
cOsWin2000 = 5;
cOsXP      = 6;
cOsVista   = 7;

Patch1ZwQIP: array[0..5] of byte  = ($68,00,00,00,00,$C3);
Patch2ZwQIP: array[0..63] of byte = ($83,$7C,$24,$08,$07,$74,$0F,$90,$90,$90,$90,$90,$90,$90,$90,$90,$90,$90,$90,$90,$90,$90,$8B,$44,$24,$0C,$83,$F8,$00,$74,$17,$C7,$00,$00,$00,$00,$00,$50,$53,$8B,$44,$24,$18,$8B,$5C,$24,$1C,$83,$FB,$00,$74,$02,$89,$03,$5B,$58,$B8,$00,$00,$00,$00,$C2,$14,$00);
Patch1ZwSIT: array[0..24] of byte = ($83,$7C,$24,$08,$11,$75,$03,$C2,$10,$00,$B8,$E5,$00,$00,$00,$BA,$00,$03,$FE,$7F,$FF,$12,$C2,$10,$00);
Patch1GTC  : array[0..4] of byte  = ($90,$33,$C0,$C3,$90);
Patch1P32N : array[0..4] of byte  = ($33,$C0,$C2,$08,$00);  // XOR EAX,EAX; RET 8


type
  TTrace = Record
    Active     : Boolean;
    TraceOver  : Boolean;
    AddrIni    : DWORD;
    CtxIni     : CONTEXT;
    NIns       : Integer;
    Opcodes    : String;
    Disasm     : String;
    ModifiedReg: String;
    NextAddr   : DWORD;
  end;

  TDasm = Record
    AddrIni    : DWORD;
    Opcodes    : String;
    Disasm     : String;
    NextAddr   : DWORD;
    HDE        : HDEInstruction;
  end;

  TInitDebugEvent      = procedure of object;
  TCreateProcEvent     = procedure of object;
  TBreakBPEvent        = procedure of object;
  TBreakBPMEvent       = procedure of object;
  TBreakHBPEvent       = procedure of object;
  TExitDebugEvent      = procedure of object;
  TOtherEventsEvent    = procedure of object;
  TOtherExceptionEvent = procedure(var CStatus: Integer) of object;
  TBreakSystemBP       = procedure of object;
  TTraceInto           = procedure (var StrucTrace: TTrace) of object;
  TBreakAccessHBPEvent = procedure of object;
  TBreakAllException   = procedure of object;
  TEventWriteLog       = procedure (text: String) of object;


  PRecBP = ^TRecBP;                         // Define puntero a registro de tipo TRecBP
  TRecBP = Record                           // Define registro de BP. Cada BP queda registrado en un elemento de este tipo
    address : DWORD;                        // direccion del BP
    bOrig   : byte;                         // valor original del byte que solaparemos con INT3 (0CCh)
    Module  : String;                       // Si el BP est en una API, indica la dll en la que se encuentra
    API     : String;                       // Si el BP est en una API, da el nombre de la API
    Mode    : Integer;                      // Tipo de BP siempre 0=Ejecucin
    TypeBP  : String;                       // Tipo de BP (Hard, Soft)
    Enable  : Boolean;                      // Bandera utilizada para indicar si est o no habilitado. Usado para pasar la instruccin
  end;


  PRecHBP = ^TRecHBP;                      // Define puntero a registro de tipo TRecBP
  TRecHBP = Record                         // Define registro de BP. Cada BP queda registrado en un elemento de este tipo
    address : DWORD;                       // direccion del HBP
    Mode    : Integer;                     // Tipo de HBP 0=Ejecucin, 1= Acceso, 2=Escritura
    Reg     : Integer;                     // Registro DR en el que se guardar la direccin
    TypeBP  : String;                      // Tipo de BP (Hard, Soft)
  end;


  TRecBPM = Record                         // Define registro de Breakpoint Memory.
    address    : DWORD;                    // Direccion de inicio del bloque de memoria
    Size       : Integer;                  // Tamao del bloque de memoria
    OrgProtect : DWORD;                    // Valor original de proteccin del bloque
    Mode       : Integer;                  // Tipo de BPM 0= Ejecucion, 1= Acceso, 2=Escritura
    Enable     : Boolean;                  // Bandera utilizada para indicar si est o no habilitado
    BaseAddress: DWORD;                    // Direccion base de la pgina que contiene el BPM
  end;


  PSystem_Dll = ^TSystem_Dll;              // Define puntero a registro de tipo TSystem_Dll
  TSystem_Dll = Record                     // Define registro de mdulo dll cargado.
    handle     : hwnd;                     // Manejador del mdulo
    base       : DWORD;                    // Direccion Base Address del mdulo
    name       : String;                   // Nombre del mdulo
    path       : String;                   // Path del mdulo
    Size       : Integer;                  // Tamao del bloque de memoria
  end;

  PImportAPI = ^TImportAPI;                // Define puntero a registro de tipo TImportAPI
  TImportAPI = Record                      // Define registro de funcin importada cargada.
    AddrAPI    : DWORD;                    // Direccion de la funcion
    base       : DWORD;                    // Direccion Base Address del mdulo
    name       : String;                   // Nombre de la funcion
    module     : String;                   // Nombre del mdulo
    Num        : Integer;                  // Numero de orden
    AddrIAT    : DWORD;                    // Direccion de la entrada en la IAT
  end;

  //Gracias a emadicius por la implementacin
  TSetHideDebugger = set of (
    fhIsDebuggerPresent,               // Bandera para indicar si queremos ocultar frente a API IsDebuggerPresent                        
    fhNTGlobalFlag,                    // Bandera para indicar si queremos ocultar frente a NTGlobalFlag
    fhZwQueryInformationProcess,       // Bandera para indicar si queremos ocultar frente a ZwQueryInformationProcess
    fhZwSetInformationThread,          // Bandera para indicar si queremos ocultar frente a API ZwSetInformationThread
    fhGetTickCount,                    // Bandera para indicar si queremos ocultar frente a API GetTickCount                             
    fhINT3Break,                       // Bandera para indicar si queremos pasar las interrupciones INT3 no manejadas (antidebugger)
    fhINT1Break,                       // Bandera para indicar si queremos pasar las interrupciones INT1 no manejadas (antidebugger)
    fhINT68Break,                      // Bandera para indicar si queremos parchear las interrupciones INT68 no manejadas (antidebugger) 
    fhProcess32Next,                   // Bandera para indicar si queremos ocultar frente a proteccion PID <> Explorer.exe
    fhAntiDelHBP                       // Bandera para indicar si queremos evitar proteccion antiHBP                                     
   );

  TRegisters = Record
        EAX:   DWORD;
        EBX:   DWORD;
        ECX:   DWORD;
        EDX:   DWORD;
        ESI:   DWORD;
        EDI:   DWORD;
        ESP:   DWORD;
        EBP:   DWORD;
        EIP:   DWORD;
        segCS: DWORD;
        segDS: DWORD;
        segES: DWORD;
        segFS: DWORD;
        segGS: DWORD;
        segSS: DWORD;
        DR0:   DWORD;
        DR1:   DWORD;
        DR2:   DWORD;
        DR3:   DWORD;
        DR6:   DWORD;
        DR7:   DWORD;
        EFlags:DWORD;
  end;


  TInfoIAT = Record
    InitIAT : DWORD;
    EndIAT  : DWORD;
    SizeIAT : DWORD;
    CountIAT: DWORD;
    Valid   : Boolean;

  end;

// Declara un puntero a funcion para cargar dinmicamente la API DebugSetProcessKillOnExit
// Esta API solo est disponible en XP
// Gracias a Gerardo Richarte por la idea y el cdigo
  TDebugSetProcessKillOnExit= function (KillOnExit: BOOL): BOOL; stdcall;

//**** Habilitar una de las dos posibilidades siguientes
  TDbgCLS = class(TComponent)  // para componente delphi
//  TDbgCLS = class(TWinControl) // para exportar a OCX

  private
    { Private declarations }
    FAbout            : String;                  // String que contiene el texto de about
    FS_info           : STARTUPINFO;             // Estructura STARTUPINFO en la que guardaremos la devuelta por CreateProcess
    FP_info           : PROCESS_INFORMATION;     // Estructura PROCESS_INFORMATION en la que guardaremos la devuelta por CreateProcess
    FD_info           : DEBUG_EVENT;             // Estructura DEBUG_EVENT en la que guardaremos la informacin devuelta por el bucle de depuracin
    FM_Info           : MEMORY_BASIC_INFORMATION;//TMemoryBasicInformation; // Estructura MEMORY_BASIC_INFORMATION para ver atributos de zonas de memoria
    FSys_Info         : SYSTEM_INFO;             // Estructura SYSTEM_INFO. Recoge informacion del sistema
    FExeName          : String;                  // Nombre del ejecutable depurado
    FCtx              : CONTEXT;                 // Estructura CONTEXT donde guardaremos la informacin devuelta por GetThreadContext
    FLog              : String;                  // Nombre del archivo log
    FIsLog            : boolean;                 // Bandera que indica si guardaremos informacin en el Log
    FIsLoopActive     : Boolean;                 // Bandera que indica si el bucle de depuracin est activo
    FdwCStatus        : DWORD;                   // Indica como debe continuar la ejecucin al invocar la API ContinueDebugEvent
    FOverwriteLog     : Boolean;                 // Bandera que indica si se borrar el Log o se aadir al ya creado
    FExceptionInLog   : Boolean;                 // Bandera para decidir si loguear eventos Exception
    FListBP           : TList;                   // Lista de registros de breakpoints software
    FListHBP          : TList;                   // Lista de registros de hardware breakpoints
    FListDll          : TList;                   // Lista de modulos cargados
    FListAPI          : TList;                   // Lista de funciones importadas
    FBP               : PRecBP;                  // Puntero a un registro de tipo RecBP
    FHBP              : PRecHBP;                 // Puntero a un registro de tipo RecHBP
    FBPM              : TRecBPM;                 // Registro de Breakpoint Memory
    FSDll             : PSystem_Dll;             // Puntero aun registro de tipo System_Dll
    FFncAPI           : PImportAPI;              // Puntero a registro de tipo ImportAPI
    FLastException    : DWORD;
    FLastAddr         : DWORD;
    FLastEventCode    : DWORD;
    FAddrOnBPSS       : DWORD;                   // Direccin del BP a restaurar en EXCEPTION_SINGLE_STEP
    FAddrOnHBPSS      : DWORD;                   // Direccin del HBP a restaurar en EXCEPTION_SINGLE_STEP
    FAddrOnBPMSS      : DWORD;                   // Direccin del BPM a restaurar en EXCEPTION_SINGLE_STEP
    FModeHBPOnSS      : Integer;                 // Modo de HBP para restaurar en EXCEPTION_SINGLE_STEP.
    FAddrSystemBP     : DWORD;                   // Contiene la direccin del "System Breakpoint"
    FDelAddrAPI       : String;                  // Para reservar direccin de API
    FDelModAPI        : String;                  // Para reservar modulo que contiene a la API
    FDelayClear       : Boolean;                 // Para borrar un BP despues de ejecutar la instruccin en curso
    FFlagsHideDebugger : TSetHideDebugger;       // Conjunto de banderas para  activar/desactivar Hide debuggers
    FPEB              : DWORD;                   // Contiene direccin del PEB (Process Environment Block)
    FTEB              : DWORD;                   // Contiene direccin del TEB (Thread Environment Block)
    FStartAddress     : DWORD;                   // Contiene direccin del Entry Point
    FTrace            : TTrace;                  // Registro que contiene informacin para el metodo trace
    FAPIKiUserExceptionDispatcher: DWORD;        // Guarda la direccin de la API KiUserExceptionDispatcher
    FAPIZwContinue    : DWORD;                   // Guarda la direccin de la API ZwContinue
    FAPIRetZwContinue : DWORD;                   // Guarda la direccin de retorno de la API ZwContinue
    FAddrInBPM        : DWORD;                   // Direccion de acceso donde se produce la excepcion en BPM
    FModeInBPM        : Integer;                 // Modo de acceso cuando se produce la excepcion en BPM
    FVirtualOffsetCode: DWORD;                   // Virtual Address de la seccin Code
    FVirtualSizeCode  : DWORD;                   // Tamao de la seecion Code
    FBaseOfImage      : DWORD;                   //
    FSizeOfImage      : DWORD;                   // Tamao de la imagen
    FRatioSize        : Single;                  // Relacion entre VirtualSize/RawSize. Da un ndice para saber si el programa est empacado
    FValueHideDbgForX : DWORD;                   // Utilizada para Interface con ActiveX
    FInfoIAT          : TInfoIAT;                // Guarda informacin de la IAT
    R: TRegisters;                               // Estructura similar a CONTEXT para acceder a los registros
    FOnCreateProcEvent: TCreateProcEvent;
    FOnBreakBP        : TBreakBPEvent;
    FOnBreakBPM       : TBreakBPMEvent;
    FOnBreakHBP       : TBreakHBPEvent;
    FOnExitEvent      : TExitDebugEvent;
    FOnOtherEvents    : TOtherEventsEvent;
    FOnOtherException : TOtherExceptionEvent;
    FOnBreakSystemBP  : TBreakSystemBP;
    FOnTraceInto      : TTraceInto;
    FOnBreakAccessHBP : TBreakAccessHBPEvent;
    FOnAllException   : TBreakAllException;
    FOnWriteLog       : TEventWriteLog;
    function   DecodeDEC(DEC: DWORD): String;    // Decodifica dwDebugEventCode
    procedure  GetRegisters;                     // Lee registros de v. privada FCtx y los pone en v. publica R
    procedure  SetRegisters;                     // Lee registros de v.publica R y los pone en v. privada FCtx
    procedure GetContext;                        // Hace una lectura del contenido de la estructura Ctx que contiene el estado de todos los registros cuando se produce un evento.
    procedure SetContext;                        // Escribe el valor del nuevo CONTEXT con los registros modificados.
    function   ExistsBP(Address: DWORD; var indice: Integer): Boolean; // Comprueba si existe un BP en la direccin dada
    function   ExistsHBP(address: DWORD; var indice: Integer): Boolean;// Comprueba si existe un HBP en la direccin dada y devuelve el puntero
    function   ExistsHBPOnAccess(var indice: Integer): Boolean;   // Comprueba si existe un HBP en la direccin dada y devuelve el puntero
    function   ExistsBPM(Address: DWORD; Size: Integer): Boolean; // Comprueba si existe un BPM en la direccin dada y devuelve el puntero
    function   EnableBP(Address: DWORD): boolean;     // Restaura el BP despues de pasar a siguiente instruccin con SINGLE_STEP
    function   DisableBP(Address: DWORD): boolean;    // Elimina temporalmente el BP para ejecutar la instruccin original
    function   EnableHBP(address: DWORD): Boolean;    // Restaura el HBP despues de pasar a siguiente instruccin con SINGLE_STEP
    function   DisableHBP(address: DWORD): Boolean;   // Elimina temporalmente el HBP para ejecutar la instruccin original
    procedure  HideDebugger;                     // Este procedimiento recoge mtodos para ocultar el debugger
    procedure  InfoMemory(Address: DWORD);       // Para conocer la proteccin de memoria
    function   strTrace: String;                 // Devuelve una string con la linea traceada
    procedure  SetTrapFlag;                      // Para ativar traceo paso a paso
    procedure  AddDll(handle: hWnd; BaseAdd: DWORD);  // Aade modulo dll a la lista
    function   DecodeProt(P: DWORD): String;     // Este procedimiento privado decodifica el artibuto de proteccion de memoria
    procedure  DisableAllHBP;                    // Deshabilita temporalmente todos los HBP. Para prot. anti HBP
    procedure  EnableAllHBP;                     // Habilita todos los HBP. Para prot. anti HBP
    procedure  DisableAllBP;                     // Deshabilita todos los BP antes de desattachear
    procedure  StepTrace;                        // Ejecuta codigo asociado a trace
    function   FindIAT(var InfoIAT: TInfoIAT):Boolean; // Busca incio, fin, tamao y entradas de la IAT

  protected
    { Protected declarations }
   public
    { Public declarations }
//    R: TRegisters;                                         // Estructura similar a CONTEXT para acceder a los registros
    property D_Info: DEBUG_EVENT read FD_Info;             // Estructura DEBUG_EVENT publica solo lectura
//    property P_Info: PROCESS_INFORMATION read FP_Info;     // Estructura PROCESS_INFORMATION publica solo lectura
//    property LastException: DWORD read FLastException;     // Cdigo de la ltima excepcion sucedida. Solo lectura
//    property LastEventCode: DWORD read FLastEventCode;     // Cdigo del ltimo evento sucedido. Solo lectura
//    property LastAddr: DWORD read FLastAddr;               // Direccion en la que ocurri la ultima excepcin. Solo lectura
//    property EntryPoint: DWORD read FStartAddress;         // Direccion del Entry Point
//    property AddrInBPM: DWORD read FAddrInBPM;             // Direccin de acceso donde se produce la excepcin en BPM
//    property ModeInBPM: Integer read FModeInBPM;           // Modo de acceso cuando se produce un BPM 0= Lectura; 1= Escritura
//    property VirtualOffsetCode: DWORD read FVirtualOffsetCode;  // Virtual Offset de la seccion code
//    property VirtualSizeCode: DWORD read FVirtualSizeCode;      // Virtual Size de la seccion code
//    property BaseOfImage: DWORD read FBaseOfImage;         // BaseOfImage (normalmente $400000)
//    property SizeOfImage: DWORD read FSizeOfImage;         // Tamao de la imagen
//    property RatioSize: Single read FRatioSize;            // Relacin entre VirtualSize/RawSize
//    property ValueHideDbgForX: DWORD read FValueHideDbgForX;    // Utilizada para Interface con ActiveX
    constructor Create(AOwner : TComponent); override;     // Constructor
    destructor Destroy; override;                          // Destructor
    procedure InitDebug;                         // Arranca el proceso de depurado. Crea el proceso a depurar.
    procedure DebugLoop;                         // Comienza el bucle de depuracin. Bucle WaitForDebugEvent-ContinueDebugEvent
    procedure StopDebug;                         // Detiene el proceso de depurado.
    function SetBP(Address: DWORD): byte;        // Coloca un breakpoint software en la direccin dada.
    function ClearBP(Address:DWORD): byte;       // Borra un breakpoint software de la direccin dada.
    function SetApiBP(NameDll:String; NameAPI:String): DWORD;     // Pone un brekpoint software en la API dada.
    function ClearApiBP(NameDll:String; NameAPI:String): byte;    // Borra un breakpoint software de la API dada.
    function SetBPM(Address: DWORD; Size: Integer; Mode: Integer): Boolean;// Pone un breakpoint de acceso a memoria en la direccin y tamao dado.
    function ClearBPM: Boolean;                        // EN CONSTRUCCION  // Borra el bBreakpoint Memory
    procedure SetHBP(address: DWORD;Mode: Integer);   // Coloca un breakpoint Hardware en la direccin especificada.
    procedure ClearHBP(Address: DWORD);          // Borra un breakpoint software de la direccin dada.
    procedure WriteLog(Remark: String);          // Escribe un mensaje en el archivo Log
    procedure WriteLogNL(Remark: String; Saltos: Integer); // Lo mismo que WriteLog pero anteponiendo tantos saltos de lnea como indique el parmetro saltos
    procedure WriteLogWD(Remark: String);        // Lo mismo que WriteLog pero sin anteponer la fecha
    function  WriteMemoryB(Address: DWORD;Value:Byte):Boolean;  // Escribe el byte Value en la direccin indicada por el parmetro Addr.
    procedure WriteMemoryDW(Address:DWORD; Value: DWORD);  // Escribe el DWord Value en la direccin indicada por el parmetro Addr.
    procedure WriteMemoryStr(Address:DWORD; Value:String); // Escribe la cadena  Value en la direccin indicada por el parmetro Addr.
    function  GetAddrAPI(NameDll:String; NameAPI:String): DWORD;     // Como la API homloga, se encarga de obtener la direccin de la API que especifiquemos.
    procedure LogInfoProcess;                    // Enva al archivo log informacin del proceso depurado.
    procedure LogMemory(Address: DWORD; Size: Integer);    // Enva al archivo log un volcado de memoria.
    function  ReadMemoryB(Address: DWORD): Byte;           // Lee un byte desde la direccin indicada por el parmetro Addr.
    function  ReadMemoryDW(Address:DWORD): DWORD;          // Lee un DWOR desde la direccin indicada por el parmetro Addr.
    function  ReadMemoryStr(Address:DWORD; Size: Integer): String;   // Lee una cadena de texto desde la direccin indicada por el parmetro Addr y tamao = size.
    procedure LogRegisters;                      // Hace un volcado en el Log con el contenido de todos los registros
    procedure LogBP;                             // Hace un volcado de los BP instalados
    procedure LogInfoMemory(Address: DWORD);     // Para loguear las caracterstcas de zona de memoria
    procedure LogStack;                          // Para loguear el contenido del stack pointer
    procedure MSG(text: String);                 // Muestra un MsgBox en pantalla
    function  Find(Address: DWORD; Size: Integer; Pattern: String): DWORD;   // Busca en meomoria
    procedure Trace(N: Integer);                 // Ejecuta paso a paso el N. de instrucciones especificadas
    procedure LogMapMemory;
    function  GetNameDll(Address: DWORD): String;// Devuelve el nombre del mdulo de la direccin especificada, si existe
    procedure SetFlag(Flag: Char);               // Pone a 1 Flag (Gracias SPANDAU por la idea)
    procedure ClearFlag(Flag: Char);             // Pone a 0 Flag
    procedure SetBreakOnEP;                      // Pone un BP en el Entry Point
    function  GetSizeOfCode(Address: DWORD): DWORD;   // Devuelve la longitud del opcode apuntado por la direccin Address
    function  GetSizeOfProc(Address: DWORD): DWORD;   // Devuelve la longitud de la funcion apuntada por la direccin Address
    function  GetRetOfProc(Address: DWORD): DWORD;    // Devuelve la direccin de retorno del procedimeinteo apuntado por la direccin Address
    procedure LogSections(FFile: String);        // Muestra las seeciones de la cabecera del ejecutable
    function  DumpProc:Boolean;                  // Hace un volcado del proceso depurado
    function  FixDump(OEP: DWORD; Raw_Virtual: Boolean): boolean;      // Corrige OEP, RawSize y RawOffset del dumpeado
    procedure LogImports;                        // Muestra informacin de las funciones importadas
    function  GetLastSEH: DWORD;                 // Recoge la direccion del ultimo SEH (Structured Exception Handler) instalado
    function  GetSignatureOEP(OEP: DWORD): String;     // Devuelve un array con los 512 primeros bytes desde el OEP pasado como parmetro
    function  EnableBPM: Boolean;                // Restaura BPM despues de una excepcin GUARD_PAGE
    function  DisAsmAddr(Address: DWORD): String;// Devuelve un string con la instruccion en asm desensamblada
    procedure GetDisAsm(Var I: TDasm);           // Devuelve la instruccion desensamblada en la estructura TDasm
    procedure GetDisAsmX(AddrIni: dword; var Opcodes: String; var Disasm: String; var NextAddr: dword);   // Para compatibilidad con OCX
    function  GetEAX: DWORD;                     // Toma el valor del registro EAX
    function  GetEBX: DWORD;                     // Toma el valor del registro EBX
    function  GetECX: DWORD;                     // Toma el valor del registro ECX
    function  GetEDX: DWORD;                     // Toma el valor del registro EDX
    function  GetESI: DWORD;                     // Toma el valor del registro ESI
    function  GetEDI: DWORD;                     // Toma el valor del registro EDI
    function  GetESP: DWORD;                     // Toma el valor del registro ESP
    function  GetEBP: DWORD;                     // Toma el valor del registro EBP
    function  GetEIP: DWORD;                     // Toma el valor del registro EIP
    function  GetsegCS: DWORD;                   // Toma el valor del registro CS
    function  GetsegDS: DWORD;                   // Toma el valor del registro DS
    function  GetsegES: DWORD;                   // Toma el valor del registro ES
    function  GetsegFS: DWORD;                   // Toma el valor del registro FS
    function  GetsegGS: DWORD;                   // Toma el valor del registro GS
    function  GetsegSS: DWORD;                   // Toma el valor del registro SS
    function  GetDR0: DWORD;                     // Toma el valor del registro DR0
    function  GetDR1: DWORD;                     // Toma el valor del registro DR1
    function  GetDR2: DWORD;                     // Toma el valor del registro DR2
    function  GetDR3: DWORD;                     // Toma el valor del registro DR3
    function  GetDR6: DWORD;                     // Toma el valor del registro DR6
    function  GetDR7: DWORD;                     // Toma el valor del registro DR7
    function  GetEFlags: DWORD;                  // Toma el valor del registro EFlags
    procedure SetEAX(value: DWORD);              // Modifica el valor del registro EAX
    procedure SetEBX(value: DWORD);              // Modifica el valor del registro EBX
    procedure SetECX(value: DWORD);              // Modifica el valor del registro ECX
    procedure SetEDX(value: DWORD);              // Modifica el valor del registro EDX
    procedure SetESI(value: DWORD);              // Modifica el valor del registro ESI
    procedure SetEDI(value: DWORD);              // Modifica el valor del registro EDI
    procedure SetESP(value: DWORD);              // Modifica el valor del registro ESP
    procedure SetEBP(value: DWORD);              // Modifica el valor del registro EBP
    procedure SetEIP(value: DWORD);              // Modifica el valor del registro EIP
    procedure SetsegCS(value: DWORD);            // Modifica el valor del registro CS
    procedure SetsegDS(value: DWORD);            // Modifica el valor del registro DS
    procedure SetsegES(value: DWORD);            // Modifica el valor del registro ES
    procedure SetsegFS(value: DWORD);            // Modifica el valor del registro FS
    procedure SetsegGS(value: DWORD);            // Modifica el valor del registro GS
    procedure SetsegSS(value: DWORD);            // Modifica el valor del registro SS
    procedure SetDR0(value: DWORD);              // Modifica el valor del registro DR0
    procedure SetDR1(value: DWORD);              // Modifica el valor del registro DR1
    procedure SetDR2(value: DWORD);              // Modifica el valor del registro DR2
    procedure SetDR3(value: DWORD);              // Modifica el valor del registro DR3
    procedure SetDR6(value: DWORD);              // Modifica el valor del registro DR6
    procedure SetDR7(value: DWORD);              // Modifica el valor del registro DR7
    procedure SetEFlags(value: DWORD);           // Modifica el valor del registro EFlags
    procedure SetFlagsHideDebugger(value: DWORD);// Interface para fijar flags desde OCX
    procedure GetHProcess(var hProcess: DWORD; var hThread: DWORD);  // Para interface con OCX. Ver P_Info
    procedure GetIDProcess(var dwProcessId: DWORD; var dwThreadId: DWORD); // Para interface con OCX. Ver P_Info
    function  VProtect(Address: DWORD; Size: DWORD; Prot: DWORD; var OldProt): Boolean; // Modifica la proteccin de memoria virtual del depurado
    function  GetBaseDll(NameDll: String): dword;    // Funcion devuelve la direccin BaseAddress del mdulo dll pasado como parmetro
    function  GetSizeDll(NameDll: String): dword;    // Funcion devuelve el tamao del mdulo dll pasado como parmetro
    function  AsmAddr(Address: dword; source: String): Boolean;  //Ensambla codigo ASM
    function  AsmAddrFile(Address: dword; sFile: String): Boolean;  // Igual que la anterior pero source lo obtiene del archivo sFile
    function  GetInitIAT: dword;                 // Toma principio de la tabla de importaciones IAT
    function  GetEndIAT: dword;                  // Toma final de la tabla de importaciones IAT
    function  GetSizeIAT: dword;                 // Toma tamao de la tabla de importaciones IAT
    function  GetCountIAT: dword;                // Toma numero de entradas de la tabla de importaciones IAT
    function  GetLastException: dword;           // Toma el cdigo de la ltima excepcion sucedida.
    function  GetAddrInBPM: dword;               // Toma la direccin de acceso donde se produce la excepcin en BPM
    function  GetBaseOfImage: dword;             // Toma BaseOfImage (normalmente $400000)
    function  GetEntryPoint: dword;              // Toma la direccion del Entry Point
    function  GetLastAddr: dword;                // Toma la direccion en la que ocurri la ultima excepcin.
    function  GetLastEventCode: dword;           // Toma el cdigo del ltimo evento sucedido.
    function  GetModeInBPM: DWORD;               // Toma modo de acceso cuando se produce un BPM 0= Lectura; 1= Escritura
    function  GetRatioSize: Single;              // Toma la relacin entre VirtualSize/RawSize
    function  GetSizeOfImage: DWORD;             // Toma el tamao de la imagen
    function  GetVirtualOffsetCode: DWORD;       // Toma Virtual Offset de la seccion code
    function  GetVirtualSizeCode: DWORD;         // Toma Virtual Size de la seccion code
    function  Dettach: Boolean;

//    procedure Attach;

  published
    { Published declarations }
    property About: String read FAbout write FAbout;
    property ExeName: String read FExeName write FExeName;
    property Log: String read Flog write FLog;
    property IsLog: boolean read FIsLog write FIsLog default true;
    property IsLoopActive: Boolean read FIsLoopActive;
    property OverwriteLog: Boolean read FOverwriteLog write FOverwriteLog default true;
    property ExceptionInLog: Boolean read FExceptionInLog write FExceptionInLog;
    property FlagsHideDebugger: TSetHideDebugger read FFlagsHideDebugger write FFlagsHideDebugger;
    property ValueHideDbgForX: DWORD read FValueHideDbgForX  write FValueHideDbgForX;    // Utilizada para Interface con ActiveX
    property OnCreateProcEvent: TCreateProcEvent read FOnCreateProcEvent write FOnCreateProcEvent;
    property OnBreakBP: TBreakBPEvent read FOnBreakBP write FOnBreakBP;
    property OnBreakBPM: TBreakBPMEvent read FOnBreakBPM write FOnBreakBPM;
    property OnBreakHBP: TBreakHBPEvent read FOnBreakHBP write FOnBreakHBP;
    property OnExitEvent: TExitDebugEvent read FOnExitEvent write FOnExitEvent;
    property OnOtherEvents: TOtherEventsEvent read FOnOtherEvents write FOnOtherEvents;
    property OnOtherException: TOtherExceptionEvent read FOnOtherException write FOnOtherException;
    property OnBreakSystemBP: TBreakSystemBP read FOnBreakSystemBP write FOnBreakSystemBP;
    property OnTraceInto: TTraceInto read FOnTraceInto write FOnTraceInto;
    property OnBreakAccessHBP: TBreakAccessHBPEvent read FOnBreakAccessHBP write FOnBreakAccessHBP;
    property OnAllException: TBreakAllException read FOnAllException write FOnAllException;
    property OnWriteLog: TEventWriteLog read FOnWriteLog write FOnWriteLog;

  end;

function StrToHex(const S: string): string;
function GetOperatingSystem: Integer;
// function DebugSetProcessKillOnExit(KillOnExit: BOOL): BOOL; stdcall; external kernel32 name 'DebugSetProcessKillOnExit';
//function DebugActiveProcessStop(dwProcessId: DWORD): BOOL; stdcall;
// function GetMappedFileNameA(hProcess: THandle; lpv: Pointer; lpFilename: PAnsiChar;
//  nSize: DWORD): DWORD; stdcall; external 'psapi.dll' name 'GetMappedFileNameA';

//function Assemble(lpSource: PChar; lpMemory: PChar; cbMemorySize: dword; nPassesLimit: Integer; hDisplayPipe: hwnd): dword;  stdcall; external;

implementation

{$R 'DbgCLS.dcr'}

//xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
// Este procedimiento crea e inicializa el componente
//xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
constructor TDbgCLS.Create(AOwner : TComponent);
(*******************************************************************************)
begin
  inherited Create(AOwner);                      // Llama al constructor original (heredado)
  FAbout:= 'TDbgCLS V1.09 Por stzwei para CRACKSLATINOS 11/11/2009';
  FLog:= 'LogDbg.txt';                           // Damos el nombre del archivo Log por defecto
  FOverwriteLog:= True;//False;                         // Por defecto ponemos No sobreescribir Log
  FIsLog:= True;                                 // Por defecto ponemos Log activo
  FillChar(FS_Info, Sizeof(FS_Info), #0);        // Inicializamos la estructura STARTUPINFO
  FillChar(FP_Info, Sizeof(FP_Info), #0);        // Inicializamos la estructura PROCESS_INFORMATION
  FListBP:= TList.Create;                        // Creamos la lista de punteros a registros de tipo TRecBP
  FListHBP:= TList.Create;                       // Creamos la lista de punteros a registros de tipo TRecHBP
  FListDll:= TList.Create;                       // Creamos la lista de punteros a registros de tipo TSystem_Dll
  FListAPI:= TList.create;                       // Creamos la lista de punteros a registros de tipo TImportAPI
  FDelayClear:= False;
  FFlagsHideDebugger:= [fhIsDebuggerPresent,     // Inicializamos banderas antidebugger por defecto
                        fhNTGlobalFlag];
  FValueHideDbgForX:= 3;
end;


//xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
// Este procedimiento elimina el componente
//xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
destructor TDbgCLS.Destroy;
(*******************************************************************************)
var
  i: Integer;
begin

  for i:=0 to (FListHBP.Count - 1) do            // En este bucle liberamos todos los item de la lista
  begin
    FHBP := FListHBP.Items[i];                  // Recorre todos los punteros
    Dispose(FHBP);                              // Libera memoria dinmica asignada al puntero
  end;
  FListHBP.Free;                                 //  Libera la lista

  for i:=0 to (FListBP.Count - 1) do             // En este bucle liberamos todos los item de la lista
  begin
    FBP := FListBP.Items[i];                     // Recorre todos los punteros
    Dispose(FBP);                                // Libera memoria dinmica asignada al puntero
  end;
  FListBP.Free;                                  //  Libera la lista

  for i:=0 to (FListDll.Count - 1) do            // En este bucle liberamos todos los item de la lista
  begin
    FSDll := FListDll.Items[i];                  // Recorre todos los punteros
    Dispose(FSDll);                              // Libera memoria dinmica asignada al puntero
  end;
  FListDll.Free;                                 //  Libera la lista

  for i:=0 to (FListAPI.Count - 1) do            // En este bucle liberamos todos los item de la lista
  begin
    FfncAPI := FListAPI.Items[i];                // Recorre todos los punteros
    Dispose(FfncAPI);                            // Libera memoria dinmica asignada al puntero
  end;
  FListAPI.Free;                                 //  Libera la lista

  inherited destroy;                             // Llamamos al destructor original (heredado)
end;


//xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
// Este procedimiento crea el proceso que vamos a depurar
//xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
procedure TDbgCLS.InitDebug;
(*******************************************************************************)
var
  ret    : boolean;
  F      : TextFile;
  Reg    : TRegistry;
  sTemp  : String;

begin
  if IsLog then
  begin
    if ((Not FileExists(FLog)) or (FOverwriteLog)) then
    begin
      AssignFile(F, FLog);
      Rewrite(F);
      CloseFile(F);
    end;
    AssignFile(F, FLog);
    Append(F);
    Writeln(F,#13#10+'INICIADA DEPURACION');
    Writeln(F,'===================');
    CloseFile(F);
  end;                                           // Fin de IsLog
  FillChar(FS_Info, Sizeof(FS_Info), #0);        // Inicializamos la estructura STARTUPINFO
  FillChar(FP_Info, Sizeof(FP_Info), #0);        // Inicializamos la estructura PROCESS_INFORMATION
  FAddrSystemBP:= GetAddrAPI('ntdll.dll', 'DbgBreakPoint');     // Recogemos la direccin de la API ntdll.DbgBreakPoint
  FListBP.Clear;                                 // Borra la lista de BP's
  FListHBP.Clear;                                // Borra la lista de BP's
  FInfoIAT.valid:= False;                        // Inicializa estructura InfoIAT. Datos no vlidos;
  If not FileExists(FExeName) then               // Si no encuentra el exe en el path designado
  begin
    If FileExists(ExtractFilePath(Application.ExeName) + ExtractFileName(FExeName)) then     // Lo busca en la misma carpeta del programa
      FExeName:= ExtractFilePath(Application.ExeName) + ExtractFileName(FExeName)            // y si lo encuentra modifica la propiedad
    else
    begin                                        // Si tampoco lo encuentra sale y da error
      WriteLog('ERROR: Archivo ejecutable no encontrado');
      Application.Terminate;
    end;
  end;
//  if (Prot_NTGlobalFlag in FFlagsHideDebugger) then   // Oculta el debugger mediante entrada de registro
  if (fhNTGlobalFlag in FFlagsHideDebugger) then // Oculta el debugger mediante entrada de registro
  begin                                          // Ver http://www.securityfocus.com/infocus/1893?ref=oc
    try
      Reg:=TRegistry.Create;
      Reg.RootKey := HKEY_LOCAL_MACHINE;
      sTemp:= '\Software\Microsoft\Windows NT\CurrentVersion\Image File Execution Options\'+ ExtractFileName(FExeName);
      Reg.OpenKey(sTemp,True);
      Reg.WriteString('GlobalFlag','');
    finally
      Reg.CloseKey;
      Reg.Free;
    end;
  end;
//Creamos el proceso para cargar el programa
//******************************************
  ret := CreateProcess(
                  Pchar(FExeName),          // LPCTSTR lpApplicationName,	// pointer to name of executable module
                  nil,                      // LPTSTR lpCommandLine,	// pointer to command line string
                  nil,                      // LPSECURITY_ATTRIBUTES lpProcessAttributes,	// pointer to process security attributes
                  nil,                      // LPSECURITY_ATTRIBUTES lpThreadAttributes,	// pointer to thread security attributes
                  False,                    // BOOL bInheritHandles,	// handle inheritance flag
                  DEBUG_PROCESS+DEBUG_ONLY_THIS_PROCESS{+CREATE_SUSPENDED},  // DWORD dwCreationFlags,	// creation flags
//                  DEBUG_PROCESS,  // DWORD dwCreationFlags,	// creation flags
                  nil,                      // LPVOID lpEnvironment,	// pointer to new environment block
                  nil,                      // LPCTSTR lpCurrentDirectory,	// pointer to current directory name
                  FS_info,                  // LPSTARTUPINFO lpStartupInfo,	// pointer to STARTUPINFO
                  FP_info);                 // LPPROCESS_INFORMATION lpProcessInformation 	// pointer to PROCESS_INFORMATION
  if not ret then
  begin
    WriteLog('Error al crear el proceso  '+SysErrorMessage(GetLastError()));
    Exit;
  end;

  GetSystemInfo(FSys_Info);                 // Recoge Informacion del sistema (para leer dwPageSize para BPM)
  Application.ProcessMessages;
{
  if not DebugActiveProcess(FP_Info.dwProcessId) then
    WriteLog('Error al Attachear proceso.  '+SysErrorMessage(GetLastError()))
  else
    WriteLog('Attacheado al proceso '+ IntToHex(FP_Info.dwProcessId, 8));
  ResumeThread(FP_Info.hThread);
}  
end;



//xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
// Este procedimiento lanza el proceso creado y ejecuta el bucle de depuracin
// Aqui est el ncleo del loader/debugger.
// En este lazo se van recogiendo todos los eventos enviados por el programa depurado
// y se van manejando de acuerdo al tipo y a las funciones definidas por el usuario para
// cada evento.
//xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
procedure TDbgCLS.DebugLoop;
(*******************************************************************************)
var
  ret          : boolean;
  i            : Integer;
  CurrentIsLog : Boolean;
  dwTemp1      : DWORD;
  dwTemp2      : DWORD;
  sTemp        : String;
  LDT          : LDT_ENTRY;
  CStatus      : Integer;
//  StrBuffer    : pChar;
//  UniBuffer    : WideString;


begin
  // Bucle de Debugger con APIS WaitForDebugEvent -  ContinueDebugEvent
  FIsLoopActive:= True;                          // Activamos la bandera que indica que el bucle est activo
  FAddrOnBPSS:= 0; FAddrOnBPSS:= 0; FAddrOnBPMSS := 0;
  repeat
    WaitForDebugEvent(
                FD_info,                         // pDebugEvent,	// address of structure for event information
                $FFFFFFFF);                      // dwMilliseconds 	// number of milliseconds to wait for event
    FLastEventCode:= FD_info.dwDebugEventCode;
    FLastException:= FD_info.Exception.ExceptionRecord.ExceptionCode;
    FLastAddr:= DWORD(FD_info.Exception.ExceptionRecord.ExceptionAddress);
    if FLastEventCode <> 1 then                  // Loguea eventos que no sean Excepciones
      WriteLog('dwDebugEventCode = '+DecodeDEC(FD_info.dwDebugEventCode))
    else if FExceptionInLog and                  // No loguea excepciones EXCEPTION_SINGLE_STEP esperadas por BP, HBP y BPM
            ((FAddrOnBPSS or FAddrOnBPSS or FAddrOnBPMSS) = 0) then
      WriteLog('dwDebugEventCode = '+DecodeDEC(FD_info.dwDebugEventCode));

    FdwCStatus:= DBG_CONTINUE;
    // Estructura case encargada de recoger los posibles eventos recibidos desde el "debuggeado"
    case FD_info.dwDebugEventCode of

      EXCEPTION_DEBUG_EVENT:                // 1 = EXCEPTION_DEBUG_EVENT
//    ---------------------
      begin
        if assigned(FOnAllException) then       // Si est definida la funcin de usuario
          FOnAllException;
        case FD_info.Exception.ExceptionRecord.ExceptionCode of

          EXCEPTION_SINGLE_STEP:                 // 80000004 Hardware Breakpoints o ejecucin paso a paso Trap Flag = 1
//        ---------------------
          begin
            if (FAddrOnBPSS or FAddrOnHBPSS or FAddrOnBPMSS) <> 0 then
            begin                                // Se espera una excepcin EXCEPTION_SINGLE_STEP
              if FAddrOnBPMSS <> 0 then          // Se esparaba excepcin por BPM
              begin
                if FBPM.Address > 0 then         // Si BPM activo ...
                  EnableBPM;                     // ... lo habilita
                FAddrOnBPMSS:= 0;                // Resetea indicador de BPM pendiente de restaurar
                if FTrace.Active then            // Si hay trace activo vuelve a activar TRAP FLAG
                  StepTrace;
              end
              else                               // Si EXCEPTION_SINGLE_STEP no es por BPM ....
              if ExistsBP(FAddrOnBPSS,i) then    // Se esperaba una excepcin EXCEPTION_SINGLE_STEP por un BP
              begin
                CurrentIsLog:= IsLog;
                IsLog:= False;
                if FDelayClear then              // Si estaba pendiente de borrado ...
                  ClearBP(FAddrOnBPSS)           // lo borra definitivamente
                else
                  EnableBP(FAddrOnBPSS);         // Sino: vuelve a instalar el BP
                FAddrOnBPSS:= 0;                 // Resetea indicador de BP pendiente de restaurar
                FDelayClear:= False;             // Resetea indicador de borrado pendiente
                IsLog:= CurrentIsLog;            // Restaura bandera a su valor actual
                if FTrace.Active then            // Si hay trace activo vuelve a activar TRAP FLAG
                  StepTrace;
              end
              else                               // Si EXCEPTION_SINGLE_STEP no es por BPM ni BP ...
              if ExistsHBP(FAddrOnHBPSS,i) then
              begin                              // entonces puede ser por HBP
                EnableHBP(FAddrOnHBPSS);         // Vuelve a rehabilitar HBP una vez pasada la instruccim
                FAddrOnHBPSS:= 0;                // Resetea indicador de HBP pendiente de restaurar
                if FTrace.Active then            // Si hay trace activo vuelve a activar TRAP FLAG
                  StepTrace;
              end;                                // Fin de EXCEPTION_SINGLE_STEP esperada por HBP
              FAddrOnHBPSS:= 0;
            end                                  // Fin de Excepcin Single Step esperada
            else                                 // Si no se esperaba EXCEPTION_SINGLE_STEP
            if ExistsHBP(FLastAddr,i) then       // Si la excepcin la ha generado un HBP ...
            begin
              if assigned(FOnBreakHBP) then      // Si est definida la funcin de usuario
                FOnBreakHBP;                     // Ejecuta la funcion de ususario asociada
              GetContext;                        // Lee CONTEXT para conocer el valora actual de EIP
              if (ExistsHBP(FLastAddr,i) and     // Si no se ha borrado en la funcin de usuario ...
                 (FLastAddr = R.EIP)) then       // o no se ha modificado el EIP en la funcion de usuario
              begin
                FHBP:= FListHBP.Items[i];        // Puntero al registro que contiene el HBP
                if FHBP^.Mode > 0 then exit;     // Si no es en ejecucin, sale
                FAddrOnHBPSS:= FLastAddr;        // Activa indicador de HBP pendiente de pasar
                FModeHBPOnSS:= FHBP^.Mode;       // Reserva Modo de HBP para restaurarlo
                SetTrapFlag;                     // Activa modo paso a paso
                DisableHBP(FLastAddr);           // Borra el HBP temporalmente mientras se ejecuta la instruccin
              end;
            end
            else if ExistsHBPOnAccess(i) then    // Si no es un HBP en ejecucin puede ser por un HBP On Access
            begin
              FModeInBPM:= FD_info.Exception.ExceptionRecord.ExceptionInformation[1];    // Lee tipo de acceso
              FAddrInBPM:= FD_info.Exception.ExceptionRecord.ExceptionInformation[0];    // Lee direccion donde salto la excepcion
              WriteLog('Exception 80000004 EXCEPTION_SINGLE_STEP  en direccin '+IntToHex(FLastAddr,8)+' Por HBP en acceso/escritura?');
              if assigned(FOnBreakAccessHBP) then      // Si est definida la funcin de usuario
                FOnBreakAccessHBP;                     // Ejecuta la funcion de ususario asociada
            end
            else if (FTrace.Active) then          // Sino es por HBP on Access entonces puede ser por Trace
              StepTrace
            else                                 // Sino es por Trace entonces es desconocida o antidebugger INT1. Logueamos
            begin
              WriteLog('ExceptionCode: '+IntToHex(FLastException,8)+' en la direccin: '+IntToHex(FLastAddr,8));
//              if (Prot_INT1Break in FFlagsHideDebugger) then  // Si activa proteccin antidebugger por INT3 ...
              if (fhINT1Break in FFlagsHideDebugger) then  // Si activa proteccin antidebugger por INT3 ...
              begin
                FdwCStatus:= DBG_EXCEPTION_NOT_HANDLED;  // pasa la excepcion al programa
                WriteLog('La excepcin se ha ignorado y se ha pasado al programa con DBG_EXCEPTION_NOT_HANDLED');
              end;
            end;
          end;

          EXCEPTION_BREAKPOINT:                  // 80000003  Breakpoints normales o software (INT3)
//        --------------------
          begin
            if ExistsBP(FLastAddr,i) then        // Si el BP est registrado llama a la funcin asociada (si est definida en OnBreakBP)
            begin
              if (FLastAddr = FTrace.NextAddr) then
              begin
                 ClearBP(FTrace.NextAddr);
                 StepTrace;
              end;
              FAddrOnBPSS:= FLastAddr;           // Guarda la direccion para restaurar opcode INT3 en EXCEPTION_SINGLE_STEP
              DisableBP(FLastAddr);              // Deshablita el BP temporalmente para que se ejecute la instruccin original
              SetTrapFlag;                       // Activa modo paso a paso
              if assigned(FOnBreakBP) then       // Si est definida la funcin de usuario
                FOnBreakBP;                      // Ejecuta la funcion de ususario asociada
              if (fhAntiDelHBP in FFlagsHideDebugger) then   // Si est activa opcion proteccin anti HBP
              begin
                if FLastAddr = FAPIKiUserExceptionDispatcher then DisableAllHBP;
                if FLastAddr = FAPIZwContinue then
                begin
                  GetContext;
                  dwTemp1:= ReadMemoryDW((R.ESP)+4);
                  FAPIRetZwContinue:= ReadMemoryDW(dwTemp1+$0B8);    // Direccion de retorno de ZwContinue
                  SetBP(FAPIRetZwContinue);
                end;
                if FLastAddr = FAPIRetZwContinue then EnableAllHBP;
              end;
            end                                  // Fin de if ExistsBP(FLastAddr,i) => si est registrado el BP
            else                                 // Si no est registrada como BP entonces ...
            begin
              if FLastAddr = FAddrSystemBP then  // Si es un BP en ntdll.DbgBreakPoint
              begin
                HideDebugger;                    // Aprovecha este evento para activar antidebuggers
                if assigned(FOnBreakSystemBP) then    // Si est definida la funcin de usuario
                  FOnBreakSystemBP;                   // Ejecuta la funcion de ususario asociada
              end
              else                               // Si el BP no est registrado y no es SystemBP ...
              begin                              // Puede ser INT 3 como proteccion antidebugger
                WriteLog('ExceptionCode: '+IntToHex(FLastException,8)+' en la direccin: '+IntToHex(FLastAddr,8));
                if (fhINT3Break in FFlagsHideDebugger) then  // Si activa proteccin antidebugger por INT3 ...
                begin
                  FdwCStatus:= DBG_EXCEPTION_NOT_HANDLED;  // pasa la excepcion al programa
                  WriteLog('La excepcin se ha ignorado y se ha pasado al programa con DBG_EXCEPTION_NOT_HANDLED');
                end;
              end;                               // Fin de si es un BP en ntdll.DbgBreakPoint
            end;                                 // Fin de si no est registrado el BP
          end;                                   // Fin de EXCEPTION_BREAKPOINT
-------------------------------------------------------------------------------
          EXCEPTION_ACCESS_VIOLATION:            // C0000005 El thread intent leer o escribir a una direccin virtual a la cual no tiene acceso apropiado.
           //EN CONSTRUCCION
          if (FAddrOnBPMSS > 0) and (FBPM.Address > 0) and (FBPM.Enable = False) then
          begin

          end

          else
          begin
//              ExceptionInformation[0]=0 => Intento de lectura en zona protegida
//              ExceptionInformation[0]=1 => Intento de escribir en zona protegida
//              ExceptionInformation[1] => Direccin en la que se produjo la excepcin (no me funciona ???)
            GetContext;
            WriteLog('EIP = '+IntToHex(R.EIP,8));
            LogMemory(FD_info.Exception.ExceptionRecord.ExceptionInformation[1],48);
            if (FBPM.Address <> 0) and
               (FBPM.Enable) and
               (FLastAddr > FBPM.Address) and
               (FLastAddr < FBPM.Address + FBPM.Size) then
            begin
              if assigned(FOnBreakBPM) then
                FOnBreakBPM;
            end
            else
              WriteLog('ExceptionCode: '+IntToHex(FLastException,8)+' en la direccin: '+IntToHex(FLastAddr,8));
            FAddrOnBPMSS:= FLastAddr;
            //DisableBPM;
            SetTrapFlag;                     // Activa modo paso a paso
          end ;
//--------------------------------------------------------------------------------}

          EXCEPTION_GUARD_PAGE:                  // 80000001 Utilizada para los BPM
//        --------------------
          begin
            if FBPM.Address <> 0 then
            begin
              FModeInBPM:= FD_info.Exception.ExceptionRecord.ExceptionInformation[0];    // Lee tipo de acceso
              FAddrInBPM:= FD_info.Exception.ExceptionRecord.ExceptionInformation[1];    // Lee direccion donde salto la excepcion
              if FExceptionInLog then
              begin
                if FAddrInBPM = FLastAddr then sTemp:= 'ejecutar en'
                else if FModeInBPM = 0 then sTemp:= 'leer'
                else if FModeInBPM = 1 then sTemp:= 'escribir en';
                  WriteLogWD('Excepcion PAGE_GUARD en la direccin: '+IntToHex(FLastAddr,8)+' al '+sTemp+' la direccin: '+IntToHex(FAddrInBPM,8));
              end;
              if (FAddrInBPM >= FBPM.Address) and
                 (FAddrInBPM < FBPM.Address+DWORD(FBPM.Size)) then// and
//                 (DWORD(FM_Info.BaseAddress) = FBPM.BaseAddress) then
               begin
                if assigned(FOnBreakBPM) and                         // Si est definida la funcin de usuario ...
                  (((FAddrInBPM = FLastAddr) and (FBPM.Mode = 0)) or  // ... y est definido uno de los tres tipos de BPM
                   (FBPM.Mode = 1) or
                   ((FModeInBPM = 1) and (FBPM.Mode = 2))) then      // entonces ...
                  begin
                    FOnBreakBPM;                                    // Ejecuta la funcion de usuario asociada
                    if not FExceptionInLog then                     // Si no ha logueado
                    begin
                      if FAddrInBPM = FLastAddr then sTemp:= 'ejecutar en'
                      else if FModeInBPM = 0 then sTemp:= 'leer'
                      else if FModeInBPM = 1 then sTemp:= 'escribir en';
                      WriteLogWD('Excepcion PAGE_GUARD en la direccin: '+IntToHex(FLastAddr,8)+' al '+sTemp+' la direccin: '+IntToHex(FAddrInBPM,8));
                    end;
                  end;
              end;
              FAddrOnBPMSS:= FLastAddr;
              SetTrapFlag;                              // Activa modo paso a paso
            end
            else
            begin                                      // Gracias SPANDAU por el TIP
              FdwCStatus:= DBG_EXCEPTION_NOT_HANDLED;  // Excepcin EXCEPTION_GUARD_PAGE sin haber BPM. No la maneja
              WriteLog('ExceptionCode: '+IntToHex(FLastException,8)+' en la direccin: '+IntToHex(FLastAddr,8));
              WriteLog('La excepcin se ha ignorado y se ha pasado al programa con DBG_EXCEPTION_NOT_HANDLED');
            end;
          end;
          EXCEPTION_PRIV_INSTRUCTION:              // C0000096 El Thread intent ejecutar una instruccin privilegiada no permitida en el modo de ejecucin actual de la aplicacin
//        --------------------------
          begin

            begin
              FdwCStatus:= DBG_EXCEPTION_NOT_HANDLED;
              WriteLog('La excepcin se ha ignorado y se ha pasado al programa con DBG_EXCEPTION_NOT_HANDLED');
            end;
          end;                                   // Fin de EXCEPTION_PRIV_INSTRUCTION

//        OTRAS EXCEPCIONES                      // Cualquier otro tipo distinto de excepcion por ejemplo:
//        -----------------                      // EXCEPTION_INT_DIVIDE_BY_ZERO 0xc0000094 El thread intent dividir un valor entero entre 0.
                                                 // EXCEPTION_ILLEGAL_INSTRUCTION C000001D El Thread intent ejecutar una instruccin no vlida.
          else
          begin
            WriteLog('ExceptionCode: '+IntToHex(FLastException,8)+' en la direccin: '+IntToHex(FLastAddr,8));
            dwTemp1:= ReadMemoryDW(FLastAddr) and $0FFFF;  // Aisla instruccin para chequear INT 68
            if (dwTemp1 = $068CD) and                      // Se ha detectado excepcin por intruccion INT 68
              (fhINT68Break in FFlagsHideDebugger)  then     // Si est activa la bandera, parchea la instruccin
            begin
              WriteMemoryB(FLastAddr,$90);
              WriteMemoryB(FLastAddr+1,$90);
            end else                                       // Si no es INT 68
            begin
              CStatus:= 0;                                 // Por defecto asigna FdwCStatus = DBG_EXCEPTION_NOT_HANDLED
              if assigned(FOnOtherException) then          // Si est definida la funcin de usuario
                FOnOtherException(CStatus);                // Ejecuta la funcion de usuario asociada
              Case CStatus of                              // Modo continuacin de la excepcim
                0:                                         // CStatus = 0 => DBG_EXCEPTION_NOT_HANDLED
                begin
                  FdwCStatus:= DBG_EXCEPTION_NOT_HANDLED;
                  WriteLog('La excepcin se ha ignorado y se ha pasado al programa con DBG_EXCEPTION_NOT_HANDLED');
                end;
                1: FdwCStatus:= DBG_CONTINUE;              // CStatus = 1 => DBG_CONTINUE
              end;                               // Fin de Case CStatus
            end;                                 // Fin de if INT68Break
          end;                                   // Fin de otro tipo de excepcion
        end;                                     // Fin de Case ExceptionCode
      end;

      CREATE_PROCESS_DEBUG_EVENT:           // 3 = CREATE_PROCESS_DEBUG_EVENT
//    --------------------------
      begin
        FStartAddress:= DWORD(FD_Info.CreateProcessInfo.lpStartAddress);
        FBaseOfImage:= DWORD(FD_Info.CreateProcessInfo.lpBaseOfImage);
        GetContext;
        GetThreadSelectorEntry(FP_Info.hThread,R.segFS,LDT);
        asm
            PUSH EAX
            MOVZX EAX, BYTE PTR LDT.Basehi
            ROL EAX,8
            MOV AL, BYTE PTR LDT.BaseMid
            ROL EAX,$10
            MOV AX, WORD PTR LDT.BaseLow
            MOV dwTemp1,EAX
            POP EAX
        end;
        dwTemp2:= ReadMemoryDW(dwTemp1+$30);
        FTEB:= dwTemp1;                          // Apunta al TEB (Thread Environment Block)
        FPEB:= dwTemp2;                          // Apunta al PEB (Process Environment Block)
        LogInfoProcess;                          // Escribe informacin en el Log
        LogSections(FExeName);                   // Escribe informacin de las secciones del exe
        New(FSDll);                              // Crea un nuevo puntero
        InfoMemory(FStartAddress);               // Lee informacion para buscar AllocationBase de la region en la que est el ejecutable
        FSDll^.Base:= DWORD(FM_Info.AllocationBase);
        FSDll^.name:= ExtractFileName(FExeName); // Lee nombre del ejecutable
        FSDll^.path:= ExtractFilePath(FExeName); // Lee path del ejecutable
        FListDll.Add(FSDll);
        if assigned(FOnCreateProcEvent) then     // Si est definida la funcin de usuario
          FOnCreateProcEvent;                    // Ejecuta la funcion de ususario asociada
      end;

      EXIT_PROCESS_DEBUG_EVENT:             // 5 = EXIT_PROCESS_DEBUG_EVENT
//    ------------------------
      begin
        if assigned(FOnExitEvent) then           // Si est definida la funcin de usuario
          FOnExitEvent;                          // Ejecuta la funcion de ususario asociada
        FIsLoopActive:= False;                   // Desactiva la bandera de bucle activo
      end;
   (*
      OUTPUT_DEBUG_STRING_EVENT:            // 8 = OUTPUT_DEBUG_STRING_EVENT
//    ----------------------------
      begin
        if (FD_info.DebugString.fUnicode = 0) Then
          sTemp:= ReadMemoryStr(dword(FD_info.DebugString.lpDebugStringData),FD_info.DebugString.nDebugStringLength);
        end
        else
        begin
          sTemp:= ReadMemoryStr(dword(FD_info.DebugString.lpDebugStringData),FD_info.DebugString.nDebugStringLength);
          SetLength(UniBuffer, FD_info.DebugString.nDebugStringLength);
          ReadProcessMemory(FD_info.dwProcessId, FD_info.DebugString.lpDebugStringData, @UniBuffer[1], FD_info.DebugString.nDebugStringLength, dwTemp1);
          UniBuffer := Copy(UniBuffer, 1, dwTemp1);
          WriteLog(IntToStr(FD_info.DebugString.nDebugStringLength)+' - UNI - '{+UniBuffer});
        end;
      end;
     *)

//   CUALQUIER OTRO TIPO DE EVENTO
//   -----------------------------
      else                                         // Si no es un evento de los anteriores ...
        if assigned(FOnOtherEvents) then           // los agrupa en "otros" eventos ...
          FOnOtherEvents;                          // y llama a la funcion de usuario que las maneje
    end;

// Continua con la ejecucin del proceso Debuggeado
    ret:= ContinueDebugEvent(
                FD_info.dwProcessId,             // DWORD dwProcessId,	// process to continue
                FD_info.dwThreadId,              // DWORD dwThreadId,	// thread to continue
                FdwCStatus);                     // DWORD dwContinueStatus 	// continuation status
    if not ret then
    begin
      WriteLog('Error al ejecutar ContinueDebugEvent: '+SysErrorMessage(GetLastError()));
      break;
    end;
  until not FIsLoopActive;                       // Final de bucle
  WriteLog('Salimos de DebugLoop');
end;


//xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
// Este procedimiento finalizamos el proceso de depurado
//xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
procedure TDbgCLS.StopDebug;
(*******************************************************************************)
var
  ret: boolean;
begin
  if not FIsLoopActive then exit;           // Si el bucle de depuracion no est activo no hay nada que terminar
  ret:= TerminateThread(FP_info.hThread,0); // Finalizamos el hilo ppal. del proceso
  if not ret then
    WriteLog('Error al ejecutar TerminateThread: '+SysErrorMessage(GetLastError())+' '+IntTOHex(FP_info.hThread,4));
  ret:= TerminateProcess(FP_info.hProcess,0); // Finalizamos el proceso
  if not ret then
    WriteLog('Error al ejecutar TerminateProcess: '+SysErrorMessage(GetLastError()));

//  ret:= DebugActiveProcessStop(FP_info.hProcess,0); // Finalizamos el proceso
//  if not ret then
//    WriteLog('Error al ejecutar DebugActiveProcessStop: '+SysErrorMessage(GetLastError())+' '+IntTOHex(FP_info.hThread,4));
end;



//xxxxxxxxxxxxxxxxxxxxxxxxxxxxxdoxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
// Este procedimiento pone un Breakpoints Software BP en la direccin dada
//xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
function TDbgCLS.SetBP(address: dword): byte;
(******************************************************************************)
var
  i: Integer;
begin
  if ExistsBP(address,i) then
  begin                                          // Si ya existe un BP en esa direccin ...
    WriteLog('AVISO: Ests intentando poner un BP que ya existe en '+IntToHex(address,8));
//    LogBP;
    Result:= FBP^.bOrig;                         // Retorna el byte original reemplazado
  end
  else                                           // Si no existe entonces ...
  begin
    New(FBP);                                    // Crea un nuevo puntero
    FBP^.address := address;                     // Guarda la direccin en el registro
    FBP^.bOrig:= ReadMemoryB(address);           // Lee el byte original de la posicin de memoria y lo guarda en el registro
    if FAddrOnBPSS > 0 then
    begin
      FBP^.Module:= FDelModAPI;                  // Guarda el nombre de la dll
      FBP^.API:= FDelAddrAPI;                    // Guarda el nombre de la API
    end else
    begin
      FBP^.Module:= '';
      FBP^.API:= '';
    end;
    FBP^.TypeBP:= 'Soft';                         // Tipo de breakpoint
    FBP^.Mode:= 0;                                // En ejecucion
    WriteMemoryB(address,$0CC);                   // Escribe el Opcode INT3
    FListBP.Add(FBP);                             // Aade el nuevo BP
    Result:= FBP^.bOrig;                          // Retorna el byte original reemplazado
  end;
end;


//xxxxxxxxxxxxxxxxxxxxxxxxxxxxxdoxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
// Este procedimiento quita un Breakpoints Software BP en la direccin dada
//xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
function TDbgCLS.ClearBP(address: dword): byte;
(*******************************************************************************)
var
  i         : Integer;
begin
  Result:= 0;
  if ExistsBP(address,i) then                    // Si lo hemos encontrado, lo borramos
  begin
    if FAddrOnBPSS = address then                // Si el BP a borrar est pendiente de ejecucin ...
      FDelayClear:= True                         // Esto asegura que el BP sea borrado despues de llegar a la siguiente instruccin
    else                                         // Si no esta pendiente de ejecutar lo borra definitivamente
    begin
      FBP:= FListBP.Items[i];
      WriteMemoryB(address,FBP^.bOrig);          // Restaura el byte original
      Result:= FBP^.bOrig;
      FListBP.Delete(i);                         // Borra el BP
      FListBP.Pack;                              // Empaqueta punteros nulos
    end;
  end;
end;

//xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
// Este procedimiento lee un byte de la direccion de memoria especificada por el parametro
//xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
function TDbgCLS.SetApiBP(NameDll:String; NameAPI:String): DWORD;
(*******************************************************************************)
var
  Ret : DWORD;
  bOrg: byte;
begin
  Result:= 0;
  Ret:= GetAddrAPI(NameDll,NameAPI);
  if Ret <> 0 then
  begin
    bOrg:= ReadMemoryB(Ret);                       // Lee el byte original de la posicin de memoria y lo guarda en el registro
    if bOrg <> 0 then                              // Si el opcode leido es vlido ...
    begin
      New(FBP);                                    // Crea un nuevo puntero
      FBP^.address := Ret;                         // Guarda la direccin en el registro
      FBP^.bOrig:= bOrg;                           // Lee el byte original de la posicin de memoria y lo guarda en el registro
      FBP^.Module:= NameDLL;                       // Guarda el nombre de la dll
      FBP^.API:= NameAPI;                          // Guarda el nombre de la API
      FBP^.Mode:= 0;                               // En ejecucin
      FBP^.TypeBP:= 'Soft';                        // Tipo de breakpoint
      WriteMemoryB(Ret,$0CC);                      // Escribe el Opcode INT3
      FListBP.Add(FBP);                            // Aade el nuevo BP
      Result:= Ret;                                // Retorna la direccin de la API
    end
    else
      WriteLog('ERROR No se ha obtenido un opcode vlido en SetApiBP');
  end;
end;


//xxxxxxxxxxxxxxxxxxxxxxxxxxxxxdoxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
// Este procedimiento quita un Breakpoints Software BP de la API dada
//xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
function TDbgCLS.ClearApiBP(NameDll:String; NameAPI:String): byte;
(*******************************************************************************)
var
  i         : Integer;
  Address   : DWORD;
begin
  Result:= 0;
  Address:= GetAddrAPI(NameDll,NameAPI);
  if ExistsBP(Address,i) then                    // Si lo hemos encontrado, lo borramos
  begin
    FBP:= FListBP.Items[i];
    WriteMemoryB(address,FBP^.bOrig);            // Restaura el byte original
    Result:= FBP^.bOrig;
    FListBP.Delete(i);                           // Borra el BP
    FListBP.Pack;                                // Empaqueta punteros nulos
  end;
end;


//xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
//  Coloca un breakpoint Hardware en la direccin especificada.
//xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
procedure TDbgCLS.SetHBP(address: DWORD; Mode: Integer);
(*******************************************************************************)
var
  i : Integer;
  RD: array [0..3] of boolean;
//  Pi: PRecHBP;
begin
  if FListHBP.Count = 4 then
  begin
    WriteLog('ERROR: No es posible asignar ms HBP');
    LogBP;                                       // Loguea todos los BP instalados
    Exit;
  end;
  if ExistsHBP(address,i) then Exit;             // Si ya existe salimos
  GetContext;                                    // Lee estado y registros
  for i:= 0 to 3 do
    RD[i]:= False;                               // Inicializa array
  for i:= 0 to FListHBP.Count-1 do               // Comprueba que registros DR estn ocupados
  begin
    FHBP:= FListHBP.Items[i];
    RD[FHBP^.Reg]:= True;                        // Rellena elemento del array de boolean con indice igual al registro DR ocupado
  end;

  if not RD[0] then                              // Si DR0 est libre lo ocupa
  begin
    R.DR0:= address;                             // Pone la direccin del HBP en el registro DR
    Case Mode of
      0: R.DR7:= R.DR7 or DR0_EXECUTION;         // Si mode = 0 fija HBP en ejecucin
      1: R.DR7:= R.DR7 or DR0_RW;                // Si mode = 1 fija HBP en acceso
      2: R.DR7:= R.DR7 or DR0_W;                 // Si mode = 2 fija HBP en escritura
    end;
    R.DR7:= R.DR7 or
            DR0_LOCAL_EXACT_BPM_ENABLED or       // Activar punto de ruptura local para DR0
            LOCAL_EXACT_BPM_ENABLED or           // activar punto de ruptura local general
            DR0_LEN1;                            // Longitud 1 byte
    R.DR7:= R.DR7 or RESERVED_BIT10;             //
    New(FHBP);                                   // Crea un nuevo puntero
    FHBP^.address := address;                    // Guarda la direccin en el registro
    FHBP^.Mode:= Mode;                           // Lee el byte original de la posicin de memoria y lo guarda en el registro
    FHBP^.Reg:= 0;                               // Indica registro DR0;
    FHBP^.TypeBP:= 'Hard';                       // Tipo de breakpoint
    FListHBP.Add(FHBP);                          // Aade el nuevo HBP
  end else
  if not RD[1] then                              // Si DR1 est libre lo ocupa
  begin
    R.DR1:= address;                             // Pone la direccin del HBP en el registro DR
    Case Mode of
      0: R.DR7:= R.DR7 or DR1_EXECUTION;         // Si mode = 0 fija HBP en ejecucin
      1: R.DR7:= R.DR7 or DR1_RW;                // Si mode = 1 fija HBP en acceso
      2: R.DR7:= R.DR7 or DR1_W;                 // Si mode = 2 fija HBP en escritura
    end;
    R.DR7:= R.DR7 or
            DR1_LOCAL_EXACT_BPM_ENABLED or       // Activar punto de ruptura local para DR1
            LOCAL_EXACT_BPM_ENABLED or           // activar punto de ruptura local general
            DR1_LEN1;                            // Longitud 1 byte
 //   R.DR7:= R.DR7 or RESERVED_BIT10;             //
    New(FHBP);                                   // Crea un nuevo puntero
    FHBP^.address := address;                    // Guarda la direccin en el registro
    FHBP^.Mode:= Mode;                           // Lee el byte original de la posicin de memoria y lo guarda en el registro
    FHBP^.Reg:= 1;                               // Indica registro DR1;
    FHBP^.TypeBP:= 'Hard';                       // Tipo de breakpoint
    FListHBP.Add(FHBP);                          // Aade el nuevo HBP
  end else
  if not RD[2] then                               // Si DR2 est libre lo ocupa
  begin
    R.DR2:= address;                             // Pone la direccin del HBP en el registro DR
    Case Mode of
      0: R.DR7:= R.DR7 or DR2_EXECUTION;         // Si mode = 0 fija HBP en ejecucin
      1: R.DR7:= R.DR7 or DR2_RW;                // Si mode = 1 fija HBP en acceso
      2: R.DR7:= R.DR7 or DR2_W;                 // Si mode = 2 fija HBP en escritura
    end;
    R.DR7:= R.DR7 or
            DR2_LOCAL_EXACT_BPM_ENABLED or       // Activar punto de ruptura local para DR2
            LOCAL_EXACT_BPM_ENABLED or           // activar punto de ruptura local general
            DR2_LEN1;                            // Longitud 1 byte
//    R.DR7:= R.DR7 or RESERVED_BIT10;             //
    New(FHBP);                                   // Crea un nuevo puntero
    FHBP^.address := address;                    // Guarda la direccin en el registro
    FHBP^.Mode:= Mode;                           // Lee el byte original de la posicin de memoria y lo guarda en el registro
    FHBP^.Reg:= 2;                               // Indica registro DR2;
    FHBP^.TypeBP:= 'Hard';                       // Tipo de breakpoint
    FListHBP.Add(FHBP);                          // Aade el nuevo HBP
  end else
  if not RD[3] then                              // Si DR est libre lo ocupa
  begin
    R.DR3:= address;                             // Pone la direccin del HBP en el registro DR
    Case Mode of
      0: R.DR7:= R.DR7 or DR3_EXECUTION;         // Si mode = 0 fija HBP en ejecucin
      1: R.DR7:= R.DR7 or DR3_RW;                // Si mode = 1 fija HBP en acceso
      2: R.DR7:= R.DR7 or DR3_W;                 // Si mode = 2 fija HBP en escritura
    end;
    R.DR7:= R.DR7 or
            DR3_LOCAL_EXACT_BPM_ENABLED or       // Activar punto de ruptura local para DR0
            LOCAL_EXACT_BPM_ENABLED or           // activar punto de ruptura local general
            DR3_LEN1;                            // Longitud 1 byte
//    R.DR7:= R.DR7 or RESERVED_BIT10;             //
    New(FHBP);                                   // Crea un nuevo puntero
    FHBP^.address := address;                    // Guarda la direccin en el registro
    FHBP^.Mode:= Mode;                           // Lee el byte original de la posicin de memoria y lo guarda en el registro
    FHBP^.Reg:= 3;                               // Indica registro DR0;
    FHBP^.TypeBP:= 'Hard';                       // Tipo de breakpoint
    FListHBP.Add(FHBP);                          // Aade el nuevo HBP
  end else
    WriteLog('ERROR: Se ha intentado poner UN HBP pero no quedan disponibles');
  SetContext;                                    // Guarda las modificaciones de los registros
end;


//xxxxxxxxxxxxxxxxxxxxxxxxxxxxxdoxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
// Este procedimiento quita un Breakpoint Hardware HBP en la direccin dada
//xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
procedure TDbgCLS.ClearHBP(address: dword);
(*******************************************************************************)
var
  i         : Integer;
begin
  if ExistsHBP(address,i) then                    // Si lo hemos encontrado, lo borramos
  begin
    GetContext;
    FHBP:= FListHBP.Items[i];
    case FHBP^.Reg of
      0:
      begin
        R.DR0:= 0;
        R.DR7:= R.DR7 and CLEAR_DR0;             // borra bits correspondientes a DR0
      end;
      1:
      begin
        R.DR1:= 0;
        R.DR7:= R.DR7 and CLEAR_DR1;             // borra bits correspondientes a DR1
      end;
      2:
      begin
        R.DR2:= 0;
        R.DR7:= R.DR7 and CLEAR_DR2;             // borra bits correspondientes a DR2
      end;
      3:
      begin
        R.DR3:= 0;
        R.DR7:= R.DR7 and CLEAR_DR3;             // borra bits correspondientes a DR3
      end;
    end;
    FListHBP.Delete(i);                          // Borra el BP
    FListHBP.Pack;                               // Empaqueta punteros nulos
    SetContext;                                  // Acutaliza registros
    if FListHBP.Count = 0 then                   // Si no queda ningn HBP
      R.DR7:= 0;                                 // Borra bits generales
  end;
end;

// EN CONSTRUCCION
//  ESTE ES PRUEBA
//xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
// Pone un breakpoint de acceso a memoria en la direccin y tamao dado.
// Address: Direccion de memoria donde se colocar el BPM.
// Size:  Tamao de la zona de memoria a la que se coloca el BPM
// Mode:  Tipo de punto de ruptura:  0=Ejecucin, 1=Acceso, 2=Escritura.  Todavia sin implementar
// Codigo traducido de pydbg
// # PyDBG
// # Copyright (C) 2006 Pedram Amini <pedram.amini@gmail.com>
//xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
function TDbgCLS.SetBPM(Address: DWORD; Size: Integer; Mode: Integer): Boolean;
(*******************************************************************************)
var
  anterior: DWORD;
  ret     : Boolean;
//  PAddr   : Pointer;
  CurrPage: DWORD;
begin
  Result:= False;
  if not ExistsBPM(Address, Size) then           // Comprueba si ya existe BPM
  begin
    if FBPM.Address <> 0 then WriteLog('ATENCION: Modificado BPM');
    InfoMemory(Address);                         // Lee atributos de la pgina
    FBPM.BaseAddress:= DWORD(FM_Info.BaseAddress);
    CurrPage:= FBPM.BaseAddress;
    while CurrPage <= (Address + DWORD(Size)) do // Modifica proteccin de todas las pginas comprendidas ...
    begin
      ret:= VProtect(CurrPage,1,$140,anterior);   // ... en el intervalo del BPM
      if not ret then
      begin
        writeLog('Error al ejecutar VirtualProtectEx: '+SysErrorMessage(GetLastError()));
        exit;
      end;
      CurrPage:= CurrPage+FSys_Info.dwPageSize;  // Siguiente pgina si es menor del intervalo del BPM
    end;
    FBPM.address:= Address;                      // Guarda datos del BPM
    FBPM.Size:= Size;
    FBPM.OrgProtect:= anterior;
    FBPM.Enable:= True;
    FBPM.Mode:= Mode;
    Result:= True;
  end;
end;


//xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
// Este procedimiento borra el BPM actual
//xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
function TDbgCLS.ClearBPM: Boolean;
(*******************************************************************************)
var
  ret     : Boolean;
//  PAddr   : Pointer;
  CurrPage: DWORD;
  dwTemp  : DWORD;
begin
  Result:= false;
  CurrPage:= FBPM.BaseAddress;
  while CurrPage <= (FBPM.Address + DWORD(FBPM.Size)) do
  begin
    ret:= VProtect(CurrPage, 1, FBPM.OrgProtect, dwTemp);  // Cambia la proteccion de memoria
    if not ret then
    begin
      writeLog('Error al ejecutar VirtualProtectEx: '+SysErrorMessage(GetLastError()));
      exit;
    end;
    CurrPage:= CurrPage+FSys_Info.dwPageSize;
  end;
  FBPM.address:= 0;
  FBPM.Size:= 0;
  FBPM.OrgProtect:= 0;
  FBPM.Enable:= False;
  Result:= True;
end;


//xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
// Este procedimiento lee un byte de la direccion de memoria especificada por el parametro
//xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
function TDbgCLS.ReadMemoryB(address: dword): byte;
(*******************************************************************************)
var
  a        : byte;
  ret      : boolean;
  BufCnt   : DWORD;
  anterior : DWORD;
  dwTemp   : DWORD;
  PAddr    : Pointer;
begin
  PAddr:= Pointer(Address);
  ret:= VProtect(Address, 1, PAGE_READWRITE, anterior);    // Cambia la proteccion de memoria

  if not ret then writeLog('Error al ejecutar VirtualProtectEx en ReadMemoryB direccin '+IntToHex(address,8)+': '+SysErrorMessage(GetLastError()));

  ret:= ReadProcessMemory(
                FP_info.hProcess,                // HANDLE hProcess,	// handle to process whose memory is written to
                PAddr,//ptr(address),                    // LPVOID lpBaseAddress,	// address to start reading
                @a,                              // LPVOID lpBuffer,	// pointer to buffer to write data to
                1,                               // DWORD nSize,	// number of bytes to write
                BufCnt);                         // LPDWORD lpNumberOfBytesWritten 	// actual number of bytes written
  if not ret then WriteLog('Error: '+SysErrorMessage(GetLastError())+' al leer en direccin '+IntToHex(address,8));

  dwTemp := anterior;
  ret:= VProtect(address, 1, dwTemp, anterior);  // Cambia la proteccion de memoria

  if not ret then writeLog('Error al ejecutar VirtualProtectEx en ReadMemoryB direccin '+IntToHex(address,8)+': '+SysErrorMessage(GetLastError()));

  Result:= a;                                    // Retorna byte leido
end;


//xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
// Este procedimiento lee un dword de la direccion de memoria especificada por el parametro
//xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
(*******************************************************************************)
function TDbgCLS.ReadMemoryDW(address: dword): dword;
(*******************************************************************************)
  var
    a        : array[0..3] of byte;
    ret      : boolean;
    BufCnt   : DWORD;
    anterior : DWORD;
    dwTemp   : DWORD;
    PAddr    : Pointer;
  begin
    Paddr:= Pointer(Address);
    ret:= VProtect(address, 4, PAGE_READWRITE, anterior);  // Cambia la proteccion de memoria

    if not ret then writeLog('Error al ejecutar VirtualProtectEx en ReadMemoryDw direccin '+IntToHex(address,8)+': '+SysErrorMessage(GetLastError()));

    ret:= ReadProcessMemory(
                    FP_info.hProcess,              // HANDLE hProcess,	// handle to process whose memory is written to
                    PAddr,                         // LPVOID lpBaseAddress,	// address to start reading
                    @a,                            // LPVOID lpBuffer,	// pointer to buffer to write data to
                    4,                             // DWORD nSize,	// number of bytes to write
                    BufCnt);                       // LPDWORD lpNumberOfBytesWritten 	// actual number of bytes written
    if not ret then
    WriteLog('Error: '+SysErrorMessage(GetLastError())+' al leer en direccin '+IntToHex(address,8));

    dwTemp := anterior;
    ret:= VProtect(address, 4, dwTemp, anterior);  // Cambia la proteccion de memoria

    if not ret then writeLog('Error al ejecutar VirtualProtectEx en ReadMemoryDw direccin '+IntToHex(address,8)+': '+SysErrorMessage(GetLastError()));

    Result:= a[3]*16777216+a[2]*65536+a[1]*256+a[0];    // Convierte array a dword
end;


  //xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
// Este procedimiento lee un texto de la direccion de memoria especificada por el parametro
(*******************************************************************************)
function TDbgCLS.ReadMemoryStr(address: dword; Size: Integer): string;
(*******************************************************************************)
  var
    a        : array[0..2047] of Char;
    ret      : boolean;
    bufcnt   : dword;
    anterior : DWORD;
    dwTemp   : DWORD;
    PAddr    : Pointer;
    tam      : Integer;
  begin
    if Size > 2047 then
    begin
      writeLog('Error al ejecutar ReadMemoryStr. Tamao demasiado grande');
      exit;
    end;
    PAddr:= Pointer(Address);
    if Size = 0 then tam:= 255 else tam:= size;   // Tamao por defecto = 255 caracteres
    ret:= VProtect(address, tam, PAGE_READWRITE, anterior);     // Cambia la proteccion de memoria

    if not ret then writeLog('Error al ejecutar VirtualProtectEx en ReadMemoryStr direccin '+IntToHex(address,8)+': '+SysErrorMessage(GetLastError()));

    ret:= ReadProcessMemory(
                  FP_info.hProcess,              // HANDLE hProcess,	// handle to process whose memory is written to
                  PAddr,//ptr(address),                  // LPVOID lpBaseAddress,	// address to start reading
                  @a,                            // LPVOID lpBuffer,	// pointer to buffer to read data to
                  tam,                           // DWORD nSize,	// number of bytes to read
                  BufCnt);                       // LPDWORD lpNumberOfBytesWritten 	// actual number of bytes
    if not ret then WriteLog('Error: '+SysErrorMessage(GetLastError())+' al leer en direccin '+IntToHex(address,8));

    dwTemp := anterior;
    ret:= VProtect(address, tam, dwTemp, anterior);        // Cambia la proteccion de memoria

    if not ret then writeLog('Error al ejecutar VirtualProtectEx en ReadMemoryStr direccin '+IntToHex(address,8)+': '+SysErrorMessage(GetLastError()));

    Result:= StrPas(a);
  end;


//xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
// Este procedimiento actualiza el valor privado FCtx con los elementos de la variable publica R
//xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
procedure TDbgCLS.SetRegisters;
(*******************************************************************************)
begin
  FCtx.EAX:= R.EAX;
  FCtx.EBX:= R.EBX;
  FCtx.ECX:= R.ECX;
  FCtx.EDX:= R.EDX;
  FCtx.ESI:= R.ESI;
  FCtx.EDI:= R.EDI;
  FCtx.ESP:= R.ESP;
  FCtx.EBP:= R.EBP;
  FCtx.EIP:= R.EIP;
  FCtx.segCS := R.segCS;
  FCtx.segDS := R.segDS;
  FCtx.segES := R.segES;
  FCtx.segFS := R.segFS;
  FCtx.segGS := R.segGS;
  FCtx.segSS := R.segSS;
  FCtx.DR0:= R.DR0;
  FCtx.DR1:= R.DR1;
  FCtx.DR2:= R.DR2;
  FCtx.DR3:= R.DR3;
  FCtx.DR6:= R.DR6;
  FCtx.DR7:= R.DR7;
  FCtx.EFlags:= R.EFlags;
end;


//xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
// Este procedimiento actualiza los elementos de la variable publica R con el valor privado FCtx
//xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
procedure TDbgCLS.GetRegisters;
(*******************************************************************************)
begin
  R.EAX:= FCtx.EAX;
  R.EBX:= FCtx.EBX;
  R.ECX:= FCtx.ECX;
  R.EDX:= FCtx.EDX;
  R.ESI:= FCtx.ESI;
  R.EDI:= FCtx.EDI;
  R.ESP:= FCtx.ESP;
  R.EBP:= FCtx.EBP;
  R.EIP:= FCtx.EIP;
  R.segCS:= FCtx.segCS;
  R.segDS:= FCtx.segDS;
  R.segES:= FCtx.segES;
  R.segFS:= FCtx.segFS;
  R.segGS:= FCtx.segGS;
  R.segSS:= FCtx.segSS;
  R.DR0:= FCtx.DR0;
  R.DR1:= FCtx.DR1;
  R.DR2:= FCtx.DR2;
  R.DR3:= FCtx.DR3;
  R.DR6:= FCtx.DR6;
  R.DR7:= FCtx.DR7;
  R.EFlags:= FCtx.EFlags;
end;

//xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
// Este procedimiento devuelve el contenido de la estructura CONTEXT
//xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
procedure TDbgCLS.GetContext;
(*******************************************************************************)
var
  ret: Boolean;
begin
  FCtx.ContextFlags:=CONTEXT_FULL or CONTEXT_FLOATING_POINT or CONTEXT_DEBUG_REGISTERS;
  ret:= GetThreadContext(FP_info.hThread,FCtx);
  if not ret then WriteLog('Error al ejecutar GetThreadContext: '+SysErrorMessage(GetLastError()));
  GetRegisters;
end;


//xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
// Este procedimiento escribe el contenido de la estructura CONTEXT en el depurado
//xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
procedure TDbgCLS.SetContext;
(*******************************************************************************)
   var
     ret       : Boolean;
   begin
     SetRegisters;
     ret:= SetThreadContext(FP_info.hThread,FCtx);
      if not ret then WriteLog('Error al ejecutar SetThreadContext: '+SysErrorMessage(GetLastError()));
   end;

//xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
// Este procedimiento escribe un byte en memoria
(*******************************************************************************)
function TDbgCLS.WriteMemoryB(address: DWORD; value: byte): boolean;
(*******************************************************************************)
  var
    ret         : boolean;
    anterior    : dword;
    BufCnt      : dword;
    CurrentIsLog: Boolean;                       // Se utiliza para ocultar mensajes en el Log
    PAddr       : Pointer;
    dwTemp      : dword;
  begin
    Result:= False;
    PAddr:= Pointer(Address);
    CurrentIsLog := IsLog;                       // Reserva estado de bandera IsLog
    if FAddrOnBPSS > 0 then                      // Si estamos esperando EXCEPTION_SINGLE_STEP
      IsLog:= False;                             // Desactiva envio de comentarios al Log

    ret:= VProtect(address, 1, PAGE_EXECUTE_READWRITE, anterior);    // Cambia la proteccion de memoria

    if not ret then
    begin
      writeLog('Error al ejecutar VirtualProtectEx: '+SysErrorMessage(GetLastError()));
      exit;
    end else
    begin
      ret:= WriteProcessMemory (
                  FP_info.hProcess,              // HANDLE hProcess,	// handle to process whose memory is written to
                  PAddr,//ptr(address),                  // LPVOID lpBaseAddress,	// address to start writing to
                  @value,                        // LPVOID lpBuffer,	// pointer to buffer to write data to
                  1,                             // DWORD nSize,	// number of bytes to write
                  BufCnt);                       // LPDWORD lpNumberOfBytesWritten 	// actual number of bytes written
      if not ret then
      begin
        WriteLog('Error en WriteProcessMemory: '+SysErrorMessage(GetLastError()));
        exit;
      end else
      begin
 //       WriteLog('Escribe '+IntToHex(value,2)+' en '+IntToHex(address,8));

        dwTemp := anterior;
        ret:= VProtect(address, 1, dwTemp, anterior);      // Cambia la proteccion de memoria

        if not ret then
        begin
          WriteLog('Error al ejecutar VirtualProtectEx: '+SysErrorMessage(GetLastError()));
          exit;
        end else
          Result:= true;
      end;
    end;
    if FAddrOnBPSS > 0 then                      // Si estamos esperando EXCEPTION_SINGLE_STEP
      IsLog:= CurrentIsLog;                      // Restaura bandera
  end;


//xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
// Este procedimiento escribe un DWORD en memoria
(*******************************************************************************)
procedure TDbgCLS.WriteMemoryDW(address: DWORD; value: DWORD);
(*******************************************************************************)
  var
    a        : array[0..3] of byte;
    ret      : boolean;
    anterior : dword;
    BufCnt   : dword;
    dwTemp   : dword;
    PAddr    : Pointer;
  begin
    PAddr:= Pointer(Address);
    a[0]:= byte(value and $FF);                  // Convertimos DWORD a array de 4 bytes
    a[1]:= byte((value shr 8) and $FF);
    a[2]:= byte((value shr 16) and $FF);
    a[3]:= byte((value shr 24) and $FF);

    ret:= VProtect(address, 4, PAGE_EXECUTE_READWRITE, anterior);    // Cambia la proteccion de memoria

    if not ret then writeLog('Error al ejecutar VirtualProtectEx'+SysErrorMessage(GetLastError()));

    ret:= WriteProcessMemory (
                  FP_info.hProcess,              // HANDLE hProcess,	// handle to process whose memory is written to
                  PAddr,//ptr(address),                  // LPVOID lpBaseAddress,	// address to start writing to
                  @value,                        // LPVOID lpBuffer,	// pointer to buffer to write data to
                  4,                             // DWORD nSize,	// number of bytes to write
                  BufCnt);                       // LPDWORD lpNumberOfBytesWritten 	// actual number of bytes written
    if ret then WriteLog('Escribe '+IntToHex(value,2)+' en '+IntToHex(address,8))
    else        WriteLog('Error en WriteProcessMemory'+SysErrorMessage(GetLastError()));

    dwTemp := anterior;
    ret:= VProtect(address, 4, dwTemp, anterior);     // Cambia la proteccion de memoria

    if not ret then WriteLog('Error al ejecutar VirtualProtectEx'+SysErrorMessage(GetLastError()));
  end;


//xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
// Este procedimiento escribe un DWORD en memoria
(*******************************************************************************)
procedure TDbgCLS.WriteMemoryStr(address: DWORD; value: String);
(*******************************************************************************)
  var
    a        : PChar;
    L        : dword;
    ret      : boolean;
    anterior : dword;
    BufCnt   : dword;
    dwTemp   : dword;
    PAddr    : Pointer;
  begin
    PAddr:= Pointer(Address);
    a:= PChar(value+#0);                         // Convertimos la string a un puntero a cadena
    L:= Length(value)+1;                         // Ponemos longitud de la cadena
    ret:= VProtect(address, L, PAGE_EXECUTE_READWRITE, anterior);    // Cambia la proteccion de memoria

    if not ret then writeLog('Error al ejecutar VirtualProtectEx'+SysErrorMessage(GetLastError()));

    ret:= WriteProcessMemory (
                  FP_info.hProcess,              // HANDLE hProcess,	// handle to process whose memory is written to
                  PAddr,//ptr(address),                  // LPVOID lpBaseAddress,	// address to start writing to
                  a,                             // LPVOID lpBuffer,	// pointer to buffer to write data to
                  L,                             // DWORD nSize,	// number of bytes to write
                  BufCnt);                       // LPDWORD lpNumberOfBytesWritten 	// actual number of bytes written
    if ret then WriteLog('Escribe '+value+' en '+IntToHex(address,8))
    else        WriteLog('Error en WriteProcessMemoryStr '+SysErrorMessage(GetLastError())+' al escribir en '+IntToHex(address,8));

    dwTemp := anterior;
    ret:= VProtect(address, L, dwTemp, anterior);     // Cambia la proteccion de memoria

    if not ret then WriteLog('Error al ejecutar VirtualProtectEx'+SysErrorMessage(GetLastError()));
  end;


//xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
// Este procedimiento escribe informacion del proceso en el archivo Log
//xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
procedure TDbgCLS.LogInfoProcess;
(*******************************************************************************)
begin
  if FIsLog then
  begin
    InfoMemory(FStartAddress);
    WriteLog('INFORMACION DEL PROCESO'+#13#10+
             '                     ======================='+#13#10+
             '                     Nombre archivo:     '+FExeName+#13#10+
             '                     Image Base:         '+IntToHex(DWORD(FM_Info.AllocationBase),8)+#13#10+
             '                     Entry Point:        '+IntToHex(FStartAddress,8)+#13#10+
             '                     hProcess:           '+IntToHex(FP_info.hProcess,4)+#13#10+
             '                     hThread:            '+IntToHex(FP_info.hThread,4)+#13#10+
             '                     PID:                '+IntToHex(FP_info.dwProcessId,4)+#13#10+
             '                     ThreadId:           '+IntToHex(FP_info.dwThreadId,4)+#13#10+
             '                     TEB:                '+IntToHex(FTEB,8)+#13#10+
             '                     PEB:                '+IntToHex(FPEB,8));
  end;
end;

//xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
// Este procedimiento hace un volcado de memoria en el Log
// El mximo tamao es 2048 bytes
//xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
procedure TDbgCLS.LogMemory(address: DWORD; Size: Integer);
(*******************************************************************************)
var
  S      : String;
  sTemp  : String;
  a      : array[0..2047] of Char;
  ret    : boolean;
  bufcnt :dword;
  i      : Integer;
  Size16 : Integer;
  begin
  if Size < 16 then Size16:= 16
  else Size16:= Size + (Size mod 16);            // Redondea a mdulo 16 por exceso;
  ret:= ReadProcessMemory(
                  FP_info.hProcess,              // HANDLE hProcess,	// handle to process whose memory is written to
                  ptr(address),                  // LPVOID lpBaseAddress,	// address to start reading
                  @a,                            // LPVOID lpBuffer,	// pointer to buffer to read data to
                  Size16,                        // DWORD nSize,	// number of bytes to read
                  BufCnt);                       // LPDWORD lpNumberOfBytesWritten 	// actual number of bytes
  if not ret then WriteLog('Error al leer en direccin '+IntToHex(address,8));
  sTemp:= String(a);
  SetString(sTemp, a, Size16);
  S:= '';
  for i:= 0 to (Length(sTemp) div 16) do
    S:= S+IntToHex(Address+DWORD((i*16)),8)+': '+StrToHex(copy(sTemp,(i*16)+1,16));
  S:= Copy(S,1,Length(S)-14);
  WriteLog('VOLCADO DE MEMORIA'+#13#10+
             '                    =================='+#13#10+S+' ');
end;


//xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
// Este procedimiento escribe en el archivo Log
//xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
procedure TDbgCLS.LogRegisters;
(*******************************************************************************)
begin
  if FIsLog then
  begin
    GetContext;
    WriteLog('VOLCADO DE REGISTROS'+#13#10+
             '                     ===================='+#13#10+
             '                     EAX         '+IntToHex(R.EAX,8)+#13#10+
             '                     EBX         '+IntToHex(R.EBX,8)+#13#10+
             '                     ECX         '+IntToHex(R.ECX,8)+#13#10+
             '                     EDX         '+IntToHex(R.EDX,8)+#13#10+
             '                     ESI         '+IntToHex(R.ESI,8)+#13#10+
             '                     EDI         '+IntToHex(R.EDI,8)+#13#10+
             '                     ESP         '+IntToHex(R.ESP,8)+#13#10+
             '                     EBP         '+IntToHex(R.EBP,8)+#13#10+
             '                     EIP         '+IntToHex(R.EIP,8)+#13#10+
             '                     CS          '+IntToHex(R.SegCS ,8)+#13#10+
             '                     DS          '+IntToHex(R.SegDS ,8)+#13#10+
             '                     ES          '+IntToHex(R.SegES ,8)+#13#10+
             '                     FS          '+IntToHex(R.SegFS ,8)+#13#10+
             '                     GS          '+IntToHex(R.SegGS ,8)+#13#10+
             '                     SS          '+IntToHex(R.SegSS ,8)+#13#10+
             '                     DR0         '+IntToHex(R.DR0,8)+#13#10+
             '                     DR1         '+IntToHex(R.DR1,8)+#13#10+
             '                     DR2         '+IntToHex(R.DR2,8)+#13#10+
             '                     DR3         '+IntToHex(R.DR3,8)+#13#10+
             '                     DR6         '+IntToHex(R.DR6,8)+#13#10+
             '                     DR7         '+IntToHex(R.DR7,8)+#13#10+
             '                     EFlags      '+IntToHex(R.EFlags,8));
  end;
end;

//xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
// Este procedimiento hace un volcado de los BP instalados
//xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
procedure TDbgCLS.LogBP;
(*******************************************************************************)
var
  i: Integer;
  S: String;
begin
  if IsLog then
  begin
    S:= '';
    for i:= 0 to FListBP.Count-1 do              // Aqui lista los Breakpoint Software
    begin
      FBP:= FListBP.Items[i];
      S:= S+IntToHex(FBP^.Address,8)+'   '+
            IntToHex(FBP^.bOrig,2)+'      '+
            IntToStr(FBP^.Mode)+'     '+
            FBP^.TypeBP+'  -     '+
            FBP^.Module+'-'+FBP^.API+#13#10;
    end;
    for i:= 0 to FListHBP.Count-1 do             // Aqui lista los Breakpoint Hardware
    begin
      FHBP:= FListHBP.Items[i];
      S:= S+IntToHex(FHBP^.Address,8)+'   -       '+
            IntToStr(FHBP^.Mode)+'     '+
            FHBP^.TypeBP+'  '+
            'DR'+IntToStr(FHBP^.Reg)+'   -'+#13#10;
    end;
    WriteLog('BREAKPOINTS INSTALADOS ACTUALMENTE'+#13#10+
             '                    =================================='+#13#10+
             'DIRECCION  OPCODE  MODO  TIPO  REG.  API'+#13#10+
             '---------  ------  ----  ----  ----  ------------------'+#13#10+  S);
  end;
end;

//xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
// Este procedimiento hace lo mismo que la API GetProcAddress. Devuelve la direccin de la API
//xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
function TDbgCLS.GetAddrAPI(NameDll:String; NameAPI:String): DWORD;
(*******************************************************************************)
var
  Ret  : Pointer;
  hMod : THandle;
  NA   : Array[0..255] of Char;
begin
  Result:= 0;
  hMod:= GetModuleHandle(PChar(NameDll));
  if hMod = 0 then
  begin
    LoadLibrary(PChar(NameDll));        // Intentamos cargar la librera;
    hMod:= GetModuleHandle(PChar(NameDll));
  end;  
  if hMod = 0 then   WriteLog('Error al ejecutar GetModuleHandle: '+SysErrorMessage(GetLastError()))
  else
  begin
    ret:= GetProcAddress(hMod, StrPCopy(NA,NameAPI));
    if ret = Nil then WriteLog('Error al ejecutar GetProcAddress: '+SysErrorMessage(GetLastError()))
    else Result:= DWORD(Ret);
  end;

end;

//xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
// Este procedimiento escribe en el archivo Log
//xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
procedure TDbgCLS.WriteLog(Remark: String);
(*******************************************************************************)
var
  F     : TextFile;
begin
  if assigned(FOnWriteLog) then                  // Si est definida la funcin de usuario
    FOnWriteLog(DateTimeToStr(Now)+': '+Remark); // Llama a la funcion de usuario
  if FIsLog then                                 // Si est activado "loguea" en archivo.txt
  begin
    if Not FileExists(FLog) then
    begin
      AssignFile(F, FLog);
      Rewrite(F);
      CloseFile(F);
    end;
    AssignFile(F, FLog);
    Append(F);
    Writeln(F,DateTimeToStr(Now)+': '+Remark);
    CloseFile(F);
  end;
end;

//xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
// Lo mismo que WriteLog pero anteponiendo tantos saltos de lnea como indique el parmetro saltos
//xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
procedure TDbgCLS.WriteLogNL(Remark: String; Saltos: Integer);
(*******************************************************************************)
var
  F     : TextFile;
  i     : Integer;
  S     : String;
begin
  S:='';
  for i:= 1 to Saltos do
    S:= S+#13#10;
  if assigned(FOnWriteLog) then                  // Si est definida la funcin de usuario
    FOnWriteLog(S+DateTimeToStr(Now)+': '+Remark);    // Llama a la funcion de usuario
  if FIsLog then                                 // Si est activado "loguea" en archivo.txt
  begin
    if Not FileExists(FLog) then
    begin
      AssignFile(F, FLog);
      Rewrite(F);
      CloseFile(F);
    end;
    AssignFile(F, FLog);
    Append(F);
    Writeln(F,S+DateTimeToStr(Now)+': '+Remark);
    CloseFile(F);
  end;
end;

//xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
// Este procedimiento escribe en el archivo Log sin anteponer fecha
//xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
procedure TDbgCLS.WriteLogWD(Remark: String);
(*******************************************************************************)
var
  F     : TextFile;
begin
  if assigned(FOnWriteLog) then                  // Si est definida la funcin de usuario
    FOnWriteLog(Remark);                         // Llama a la funcion de usuario
  if FIsLog then                                 // Si est activado "loguea" en archivo.txt
  begin
    if Not FileExists(FLog) then
    begin
      AssignFile(F, FLog);
      Rewrite(F);
      CloseFile(F);
    end;
    AssignFile(F, FLog);
    Append(F);
    Writeln(F,Remark);
    CloseFile(F);
  end;
end;


//xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
// Este procedimiento privado decodifica el "dwDebugEventCode"
// Tambien se aprovecha para recoger informacin de mdulos
//xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
function TDbgCLS.DecodeDEC(DEC: DWORD): String;
(*******************************************************************************)
begin
  Result:= '';
  case DEC of
    1:
    if FExceptionInLog then
       Result:= '1 -> EXCEPTION '+IntToHex(FLastException,8)+' en direccin '+IntToHex(FLastAddr,8);
    2: Result:= '2 -> CREATE_THREAD';
    3: Result:= '3 -> CREATE_PROCESS';
    4: Result:= '4 -> EXIT_THREAD';
    5: Result:= '5 -> EXIT_PROCESS';
    6:
    begin
      AddDll(FD_info.LoadDll.hFile,DWORD(FD_info.LoadDll.LpBaseOfDll));
      Result:= '6 -> LOAD_DLL -> '+
                IntToHex(DWORD(FD_info.LoadDll.LpBaseOfDll),8)+
                ' -> '+GetNameDll(DWORD(FD_info.LoadDll.LpBaseOfDll));
    end;
    7: Result:= '7 -> UNLOAD_DLL';
    8:
    begin
      Result:= '8 -> OUTPUT_DEBUG_STRING = '+ ReadMemoryStr(dword(FD_info.DebugString.lpDebugStringData),FD_info.DebugString.nDebugStringLength);
    end;
    9: Result:= '9 -> RIP_INFO';
  end;
end;

//xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
// Este procedimiento privado decodifica el artibuto de proteccion de memoria
//xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
function TDbgCLS.DecodeProt(P: DWORD): String;
(*******************************************************************************)
begin
  Case P of
    $00000001: Result:= '    ';
    $00000002: Result:= 'R   ';
    $00000004: Result:= 'RW  ';
    $00000008: Result:= 'RW  ';
    $00000010: Result:= '  E ';
    $00000020: Result:= 'R E ';
    $00000040: Result:= 'RWE ';
    $00000080: Result:= 'RWE ';
    $00000102: Result:= 'R  G';
    $00000104: Result:= 'RW G';
    $00000108: Result:= 'RW G';
    $00000110: Result:= '  EG';
    $00000120: Result:= 'R EG';
    $00000140: Result:= 'RWEG';
    $00000180: Result:= 'RWEG';
  end;
end;


//xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
// Esta funcion comprueba si existe un BP en la direccin dada
//xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
function TDbgCLS.ExistsBP(address: DWORD; var indice: Integer): Boolean;
(*******************************************************************************)
var
  i         : Integer;
  bActual   : Byte;
begin
  Result:= false;
  if address = 0 then exit;
  bActual:= ReadMemoryB(Address);
  for i:= 0 to FListBP.Count-1 do                // bucle para buscar si ya existe un BP en la lista
  begin
    FBP:= FListBP.Items[i];
    if ((FBP^.address = address) and ((bActual = FBP^.bOrig)  or(bActual = $0CC)) ) then
    begin
      Result:= true;                             // encontrado
      indice:= i;                                // Retorna el indice de la lista
      break;                                     // salimos del bucle
    end
  end;
end;


//xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
// Esta funcion comprueba si existe un HBP en la direccin dada
//xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
function TDbgCLS.ExistsHBP(address: DWORD; var indice: Integer): Boolean;
(*******************************************************************************)
var
  i         : Integer;
begin
  Result:= False;
  for i:= 0 to FListHBP.Count-1 do               // bucle para buscar si ya existe un HBP en la lista
  begin
    FHBP:= FListHBP.Items[i];
    if (FHBP^.address = address) then
    begin
      Result:= true;                             // encontrado
      indice:= i;                                // Retorna el indice de la lista
      break;                                     // salimos del bucle
    end
  end;
end;

//xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
// Esta funcion comprueba si existe un HBP en modo acceso o escritura
//xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
function TDbgCLS.ExistsHBPOnAccess(var indice: Integer): Boolean;
(*******************************************************************************)
var
  i: Integer;
begin
  Result:= False;
  for i:= 0 to FListHBP.Count-1 do               // bucle para buscar si ya existe un HBP en la lista
  begin
    FHBP:= FListHBP.Items[i];
    if (FHBP^.Mode <> 0) then                    // Modo distinto de HBP en ejecucin
    begin
      Result:= true;                             // encontrado
      indice:= i;                                // Retorna el indice de la lista
      break;                                     // salimos del bucle
    end
  end;
end;


//xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
// Esta funcion comprueba si existe un BPM
//xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
function TDbgCLS.ExistsBPM(Address: DWORD; Size: Integer): Boolean;
(*******************************************************************************)
begin
  if (FBPM.Address = Address) and
     (FBPM.Size = Size) then
    Result:= true
  else
    Result:= False;
end;

//xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
// Esta funcin se usa para restaurar el BPM despues de una excepcin PAGE_GUARD
//xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
function TDbgCLS.EnableBPM: Boolean;
(*******************************************************************************)
var
  Address  : DWORD;
  CurrPage : DWORD;
  Size     : Integer;
//  PAddr    : Pointer;
  anterior : DWORD;
  ret      : Boolean;
begin
  Address:= FBPM.Address;
  CurrPage:= FBPM.BaseAddress;
  Size:= FBPM.Size;
  Result:= False;
  while CurrPage <= (Address + DWORD(Size)) do
  begin
    ret:= VProtect(CurrPage, 1, $140, anterior);  // Cambia la proteccion de memoria

    if not ret then
    begin
      writeLog('Error al ejecutar VirtualProtectEx: '+SysErrorMessage(GetLastError()));
      exit;
    end;
    CurrPage:= CurrPage+FSys_Info.dwPageSize;
  end;
  Result:= True;
end;


//xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
// Esta funcin privada se usa para restaurar el opcode 0CCh eliminado temporalmente
// mientras se ejecuta la instruccin original
//xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
function TDbgCLS.EnableBP(Address: DWORD): Boolean;
(*******************************************************************************)
var
  i: Integer;
begin
  Result:= False;
  if ExistsBP(address,i) then               // Si lo hemos encontrado, lo habilitamos
  begin
    FBP:= FListBP.Items[i];
    WriteMemoryB(address,$0CC);             // Restaura el opcode INT3
    FBP^.Enable:= True;
    Result:= True;
  end;
end;


//xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
// Esta funcin privada se usa para restaurar el opcode original y asi poder ejecutar
// la instruccin original
//xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
function TDbgCLS.DisableBP(Address: DWORD): Boolean;
var
  i: Integer;
begin
  Result:= False;
  if ExistsBP(address,i) then               // Si lo hemos encontrado, lo borramos
  begin
    FBP:= FListBP.Items[i];
    WriteMemoryB(address,FBP^.bOrig);       // Restaura el opcode original
    FBP^.Enable:= False;
    Result:= True;
  end;
end;


//xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
// Esta funcin privada se usa para restaurar el HBP deshabilitado temporalmente
// mientras se ejecuta la instruccin
//xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
function TDbgCLS.EnableHBP(Address: DWORD): Boolean;
var
  i: Integer;
begin
  Result:= False;
  if ExistsHBP(address,i) then                   // Si lo hemos encontrado, lo borramos
  begin
    FHBP:= FListHBP.Items[i];
    GetContext;
    case FHBP^.Reg of
      0: R.DR0:= Address;                        // Restaura registro DR0
      1: R.DR1:= Address;                        // Restaura registro DR1
      2: R.DR2:= Address;                        // Restaura registro DR2
      3: R.DR3:= Address;                        // Restaura registro DR3
    end;
//    R.DR6:= 0;
    SetContext;
    Result:= True;
  end;
end;

//xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
// Esta funcin privada se usa para restaurar todos los HBP deshabilitados temporalmente
// Se usa para eludir la proteccin anti Hardware Breakpoints
//xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
procedure TDbgCLS.EnableAllHBP;
var
  i: Integer;
begin
  for i:= 0 to FListHBP.Count-1 do               // bucle para buscar si ya existe un HBP en la lista
  begin
    FHBP:= FListHBP.Items[i];
    EnableHBP(FHBP.Address);
  end;
  ClearBP(FAPIRetZwContinue);
  GetContext;
end;


//xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
// Esta funcin privada se usa para deshabilitar el HBP temporalmente
// mientras se ejecuta la instruccin que provoc la interrupcin
//xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
function TDbgCLS.DisableHBP(Address: DWORD): Boolean;
(*******************************************************************************)
var
  i: Integer;
begin
  Result:= False;
  if ExistsHBP(address,i) then                   // Si lo hemos encontrado, lo deshabilitamos
  begin
    FHBP:= FListHBP.Items[i];
    GetContext;
    case FHBP^.Reg of
      0: R.DR0:= 0;                              // Restaura registro DR0
      1: R.DR1:= 0;                              // Restaura registro DR1
      2: R.DR2:= 0;                              // Restaura registro DR2
      3: R.DR3:= 0;                              // Restaura registro DR3
    end;
    SetContext;
    Result:= True;
  end;
end;


//xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
// Esta funcin privada se usa para deshabilitar todos los HBP temporalmente
// Se usa para eludir la proteccin anti Hardware Breakpoints
//xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
procedure TDbgCLS.DisableAllHBP;
(*******************************************************************************)
var
  i: Integer;
begin
  for i:= 0 to FListHBP.Count-1 do               // bucle para buscar si ya existe un HBP en la lista
  begin
    FHBP:= FListHBP.Items[i];
    DisableHBP(FHBP.Address);
  end;
end;

//xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
// Esta funcin privada se usa para deshabilitar todos los BP
// Se usa antes de desattachear el proceso para que no queden INT3 colocados en el cdigo
//xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
procedure TDbgCLS.DisableAllBP;
(*******************************************************************************)
var
  i: Integer;
begin
  for i:= 0 to FListBP.Count-1 do              // bucle para buscar si ya existe un BP en la lista
  begin
    FBP:= FListBP.Items[i];
    DisableBP(FBP.Address);
  end;
end;

//xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
// Esta funcin privada se usa para ocultar el componente de trucos antidebugger
// Fuente de informacin: http://www.securityfocus.com/infocus/1893?ref=oc
//                        https://www.blackhat.com/presentations/bh-usa-07/Yason/Presentation/bh-usa-07-yason.pdf
////xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
procedure TDbgCLS.HideDebugger;
(*******************************************************************************)
var
  addr_API: DWORD;
  PdwTemp: ^DWORD;
  dwTemp: DWORD;
  sTemp: String;
  Reg: TRegistry;
  buffer: Array[0..255] of Char;
  Patch: Array[0..14] of byte;
  i: Integer;
  CurrentIsLog: Boolean;
//  OSVersion: Integer;
begin
  CurrentIsLog := IsLog;                         // Reserva estado de bandera IsLog
  IsLog:= False;                                 // Desactiva envio de comentarios al Log
//  OSVersion:= GetOperatingSystem;

  if (fhIsDebuggerPresent in FFlagsHideDebugger) then
    WriteMemoryB(FPEB+2,0);                      // Escribe en PEB+2 (BeingDebugged) un 0

  if (fhNTGlobalFlag in FFlagsHideDebugger) then
  begin
    try
      Reg:=TRegistry.Create;
      Reg.RootKey := HKEY_LOCAL_MACHINE;
      sTemp:= '\Software\Microsoft\Windows NT\CurrentVersion\Image File Execution Options\'+ ExtractFileName(FExeName);
      Reg.OpenKey(sTemp,True);
      Reg.DeleteValue('GlobalFlag');
      Reg.DeleteKey(sTemp);
    finally
      Reg.CloseKey;
      Reg.Free;
    end;
  end;

  if (fhZwQueryInformationProcess in FFlagsHideDebugger) and
     ((GetOperatingSystem = cOsWin2000) or
     (GetOperatingSystem = cOsXP)) then
  begin
    Addr_API:= GetAddrAPI('NTDLL.DLL','ZwQueryInformationProcess');
    PdwTemp:= VirtualAllocEx(
                 FP_Info.hProcess,         // HANDLE hProcess,	// process within which to allocate memory
                 NIL,                      // LPVOID lpAddress,	// desired starting address of allocation
                 $1000,                    // DWORD dwSize,	// size, in bytes, of region to allocate
                 MEM_COMMIT,               // DWORD flAllocationType,	// type of allocation
                 PAGE_EXECUTE_READWRITE);  // DWORD flProtect 	// type of access protection
    if Addr_API <> 0 then
    begin
      for i:= 0 to 14 do
        Patch[i]:= ReadMemoryB(Addr_API+DWORD(i));
      for i:= 0 to 5 do
        buffer[i]:= Char(patch1ZwQIP[i]);
      dwTemp:= DWORD(PdwTemp);
      buffer[4]:= Char(dwTemp shr 24);
      buffer[3]:= Char((dwTemp and $00FF0000) shr 16);
      buffer[2]:= Char((dwTemp and $0000FF00) shr 8);
      buffer[1]:= Char(dwTemp and $0000FF00);
      SetString(sTemp, buffer, 6);
      WriteMemoryStr(Addr_API,sTemp);
      for i:= 0 to 63 do                         // Copia parche en memoria alocada
        buffer[i]:= Char(patch2ZwQIP[i]);
      SetString(sTemp, buffer, 64);
      WriteMemoryStr(dwTemp,sTemp);
      for i:= 0 to 14 do                         // Copia rutina original a continuacion
        buffer[i]:= Char(patch[i]);
      SetString(sTemp, buffer, 14);
      WriteMemoryStr(dwTemp+7,sTemp);
    end else
    begin
      if CurrentIsLog then
      begin
        IsLog:= True;
        WriteLog('ERROR en VirtualAllocEx '+SysErrorMessage(GetLastError())+' en HideDebugger');
      end;
    end;
  end;                                           // Fin de if FFlagsHideDebugger.Prot_ZwQueryInformationProcess

  if (fhZwSetInformationThread in FFlagsHideDebugger) and
     ((GetOperatingSystem = cOsWin2000) or
     (GetOperatingSystem = cOsXP)) then
  begin
    Addr_API:= GetAddrAPI('NTDLL.DLL','ZwSetInformationThread');
    PdwTemp:= VirtualAllocEx(
                 FP_Info.hProcess,         // HANDLE hProcess,	// process within which to allocate memory
                 NIL,                      // LPVOID lpAddress,	// desired starting address of allocation
                 $1000,                    // DWORD dwSize,	// size, in bytes, of region to allocate
                 MEM_COMMIT,               // DWORD flAllocationType,	// type of allocation
                 PAGE_EXECUTE_READWRITE);  // DWORD flProtect 	// type of access protection
    if Addr_API <> 0 then
    begin
      for i:= 0 to 14 do                         // Copia codigo de la API original
        Patch[i]:= ReadMemoryB(Addr_API+DWORD(i));
      for i:= 0 to 5 do
        buffer[i]:= Char(patch1ZwQIP[i]);
      dwTemp:= DWORD(PdwTemp);
      buffer[4]:= Char(dwTemp shr 24);
      buffer[3]:= Char((dwTemp and $00FF0000) shr 16);
      buffer[2]:= Char((dwTemp and $0000FF00) shr 8);
      buffer[1]:= Char(dwTemp and $0000FF00);
      SetString(sTemp, buffer, 6);
      WriteMemoryStr(Addr_API,sTemp);            // Copia parche en API original con desvo a memoria alocada
      for i:= 0 to 24 do
        buffer[i]:= Char(patch1ZwSIT[i]);
      SetString(sTemp, buffer, 25);
      WriteMemoryStr(dwTemp,sTemp);              // Copia parche en memoria alocada
      for i:= 0 to 14 do                         // Copia rutina original a continuacion
        buffer[i]:= Char(patch[i]);
      SetString(sTemp, buffer, 14);
      WriteMemoryStr(dwTemp+10,sTemp);
    end else
    begin
      if CurrentIsLog then
      begin
        IsLog:= True;
        WriteLog('ERROR en VirtualAllocEx '+SysErrorMessage(GetLastError())+' en HideDebugger');
      end;
    end;
  end;                                           // Fin de if FFlagsHideDebugger.Prot_ZwSetInformationThread

  if (fhGetTickCount in FFlagsHideDebugger) then
  begin
    Addr_API:= GetAddrAPI('kernel32.DLL','GetTickCount');
    for i:= 0 to 4 do
      buffer[i]:= Char(patch1GTC[i]);
    SetString(sTemp, buffer, 5);
    WriteMemoryStr(Addr_API,sTemp);              // Parchea API
  end;                                           // Fin de if FFlagsHideDebugger.Prot_GetTickCount

  if (fhProcess32Next in FFlagsHideDebugger) then
  begin
    Addr_API:= GetAddrAPI('Kernel32.dll','Process32NextW');
    for i:= 0 to 4 do
      buffer[i]:= Char(Patch1P32N[i]);
    SetString(sTemp, buffer, 5);
    WriteMemoryStr(Addr_API,sTemp);              // Parchea API
  end;                                           // Fin de if FFlagsHideDebugger.Prot_Process32Next

  if (fhAntiDelHBP in FFlagsHideDebugger) then
  begin
    FAPIKiUserExceptionDispatcher:= GetAddrAPI('ntdll.dll','KiUserExceptionDispatcher');
    SetBP(FAPIKiUserExceptionDispatcher);
    FAPIZwContinue:= GetAddrAPI('ntdll.dll','ZwContinue');
    SetBP(FAPIZwContinue);
  end;
  IsLog:= CurrentIsLog;                          // Restaura valor original de IsLog
end;


//xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
// Esta funcin busca un array de bytes en la zona de memoria requerida
// Utiliza la funcin FastStrPos gentileza de Arapumk
//xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
function  TDbgCLS.Find(Address: DWORD; Size: Integer; Pattern: String): DWORD;   // Busca en memoria
//function  TDbgCLS.Find(Address: DWORD; Size: Integer; Pattern: PChar): DWORD;   // Busca en memoria
(*******************************************************************************)
var
   PdwTemp: Pointer;
   PAddr  : Pointer;
   ret    : Boolean;
   BufCnt : DWORD;
   L      : Integer;
   sError : String;
begin
  PdwTemp:= NIL;
  try
    PAddr:= Pointer(Address);
//   WriteLog('Address antes de virtualAlloc: '+IntToHex(Address,8));
    PdwTemp:= VirtualAlloc(
                 NIL,                      // LPVOID lpAddress,	// desired starting address of allocation
                 DWORD(Size),              // DWORD dwSize,	// size, in bytes, of region to allocate
                 MEM_COMMIT,               // DWORD flAllocationType,	// type of allocation
                 PAGE_EXECUTE_READWRITE);  // DWORD flProtect 	// type of access protection
    if PdwTemp = NIL then
    begin
      sError:= 'Error: '+SysErrorMessage(GetLastError())+' en VirtualAlloc ';
      WriteLog(sError);
      MSG(sError);
    end;
//    WriteLog('PdwTemp despues de virtualAlloc: '+IntToHex(DWORD(PdwTemp),8));
    ret:= ReadProcessMemory(
                 FP_info.hProcess,              // HANDLE hProcess,	// handle to process whose memory is written to
                 PAddr,                         // LPVOID lpBaseAddress,	// address to start reading
                 PdwTemp,                       // LPVOID lpBuffer,	// pointer to buffer to write data to
                 Size,                          // DWORD nSize,	// number of bytes to write
                 BufCnt);                       // LPDWORD lpNumberOfBytesWritten 	// actual number of bytes written
    if not ret then
    begin
      WriteLog('Error: '+SysErrorMessage(GetLastError())+' al leer en direccin '+IntToHex(address,8));
      Result:= $FFFFFFFF;
      exit;
    end;
    L:= Length(Pattern);
//    L:= Length(String(Pattern));
    Result:= FastStrPos(PdwTemp, PChar(Pattern) ,Size, L);
    if Result <> $FFFFFFFF then
      Result:= Result+Address;
  finally
//    ret:= VirtualFree(PdwTemp,Size,MEM_DECOMMIT);
    ret:= VirtualFree(PdwTemp,0,MEM_RELEASE);
    if not ret then WriteLog('Error: '+SysErrorMessage(GetLastError())+' en VirtualFree ');
  end;
end;

//xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
// Esta funcin es auxiliar para conocer la proteccion de una zona de memoria
// El resultado lo pone en la variable global FM_Info
//xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
procedure TDbgCLS.InfoMemory(Address: DWORD);
(*******************************************************************************)
var
  PAddr: Pointer;
begin
  PAddr:= Pointer(Address);
//  VirtualQueryEx(h2, memstart, memInfo, SizeOf(MEMORY_BASIC_INFORMATION)
  VirtualQueryEx(
                  FP_info.hProcess,              // HANDLE hProcess,	// handle of process
                  PAddr,                         // LPVOID lpAddress,	// address of region of committed pages
                  FM_Info,                       // PMEMORY_BASIC_INFORMATION lpBuffer,
                  Sizeof(MEMORY_BASIC_INFORMATION));  // DWORD nSize,	// number of bytes to read
end;


//xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
// Este procedimiento ejecuta N instrucciones paso a paso.
// Debe codificarse despues de un BP, o HBP
//xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
procedure  TDbgCLS.Trace(N: Integer);
(*******************************************************************************)
begin
  FTrace.Active:= True;
  FTrace.AddrIni:= FLastAddr;
  FTrace.NIns:= N;
  SetTrapFlag;                     // Activa modo paso a paso
  Move(FCtx,FTrace.CtxIni,Sizeof(FTrace.CtxIni));  // Copia Contexto inicial
//  WriteLog('TRACE:');
end;


//xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
// Esta funcin sirve para loguear las caracteristicas de una zona de memoria
//xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
procedure TDbgCLS.LogInfoMemory(Address: DWORD);
(*******************************************************************************)
begin
  InfoMemory(address);
  WriteLog('INFORMACION DE LA PAGINA DE MEMORIA'+#13#10+
           '                    ==================================='+#13#10+
           '                   Module:            '+GetNameDll(Address)+#13#10+
           '                   BaseAddress:       '+IntToHex(dword(FM_Info.BaseAddress),8)+#13#10+
           '                   AllocationBase:    '+IntToHex(dword(FM_Info.AllocationBase),8)+#13#10+
           '                   AllocationProtect: '+IntToHex(FM_Info.AllocationProtect,8)+#13#10+
           '                   RegionSize:        '+IntToHex(FM_Info.RegionSize,8)+#13#10+
           '                   State:             '+IntToHex(FM_Info.State,8)+#13#10+
           '                   Protect:           '+IntToHex(FM_Info.Protect,8)+#13#10+
           '                   Type:              '+IntToHex(FM_Info.Type_9,8)+#13#10);
end;


//xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
// Esta funcin sirve para loguear el "stack pointer"
//xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
procedure TDbgCLS.LogStack;
(*******************************************************************************)
var
  S: String;
  Stack: DWORD;
  i: Integer;
begin
  GetContext;
  Stack:= R.ESP;
  S:= '';
  For i:= 4 downto 1 do
    S:= S+'                    ESP-'+IntToHex(i*4,2)+'  '+IntToHex(ReadMemoryDW(Stack-DWORD(i*4)),8)+#13#10; //+'  '+ReadMemoryStr(ReadMemoryDW(Stack-i*4))
  S:= S+'          STACK ==> '+IntToHex(Stack,6)+'  '+IntToHex(ReadMemoryDW(Stack),8)+#13#10;
  For i:= 1 to 6 do
    S:= S+'                    ESP+'+IntToHex(i*4,2)+'  '+IntToHex(ReadMemoryDW(Stack+DWORD(i*4)),8)+#13#10; //+'  '+ReadMemoryStr(ReadMemoryDW(Stack+i*4))
  WriteLog('INFORMACION DEL CONTENIDO DEL STACK'+#13#10+
           '                    ==================================='+#13#10+S);
end;



//xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
// Este procedimiento loguea el mapa de memoria
//xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
procedure TDbgCLS.LogMapMemory;
(*******************************************************************************)
var
  Dir: DWORD;
  dwBaseAddr: DWORD;
  dwAllocBase: DWORD;
  dwRSize: DWORD;
  S: String;
  sTipo: String;
  sProt1: String;
  sProt2: String;
begin
  Dir:= 0;
  while Dir < $7FFE0000 do                       // Recorre las pginas de memoria desde 0 hasta 7FFE0000
  begin
    InfoMemory(Dir);                             // Lee informacion de la region de memoria
    if (FM_Info.Type_9 <> 0) then                // Si Type_9 = 0 entonces no est asignada esa region de memoria
    begin                                        // Region encontrada
      while (FM_Info.Type_9 <> 0) do             // Bucle para extraer todas las zonas de esta regin de memoria
      begin
        if Dir > $7FFE0000 then break;           // Aunque est alocada, si sobrepasa 7FFE0000 sale
        dwBaseAddr:= DWORD(FM_Info.BaseAddress); // Copia BaseAddress de esta zona
        dwAllocBase:= DWORD(FM_Info.AllocationBase);  // Copia AllocationBase de esta regin
        dwRSize:= FM_Info.RegionSize;            // Copia tamao de esta regin
                                                 // Escribe caracteristicas de esta zona en el Log
        Case FM_Info.Type_9 of                   // Decodifica FM_Info.RegionSize
          $00020000: sTipo := 'Priv';
          $00040000: sTipo := 'Map ';
          $01000000: sTipo := 'Imag';
        end;
        sProt1:= DecodeProt(FM_Info.Protect);    // Decodifica proteccion de zona de memoria
        sProt2:= DecodeProt(FM_Info.AllocationProtect);    // Decodifica proteccion al alocar
        S:= S+'                     '+IntToHex(dwBaseAddr,8)+'  '+
                                     IntToHex(dwRSize,8)+'  '+
                                     sTipo+'  '+
                                     sProt1+'  '+
                                     sProt2+'  '+GetNameDll(dwAllocBase)+#13#10;
        Dir:= dwBaseAddr+dwRSize;                // Pasa a la siguiente region de memoria
        InfoMemory(Dir);                         // Lee informacion de la region de memoria
      end;
    end else
    Dir:= Dir+FM_Info.RegionSize;                // Pasa a la siguiente region de memoria
  end;                                           // de while  Dir < $7FFF0000
  WriteLog('MAPA DE MEMORIA'+#13#10+
           '                     ==============='+#13#10+
           '                     Address   Size      Type  Prot  Initial   '+#13#10+S);
end;
{
//xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
// Este procedimiento loguea el mapa de memoria
//xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
procedure TDbgCLS.LogMapMemory;
(*******************************************************************************)
var
  Dir: DWORD;
  DirAnt: DWORD;
  S: String;
  sTipo: String;
  sProt1: String;
  sProt2: String;
begin
  S:= '';
  Dir:= 0;
  DirAnt:= 0;
  while Dir < $7FFF0000 do                       // Busca la primera region alocada
//  while Dir < $1FFF0000 do
  begin
    InfoMemory(Dir);
    if (FM_Info.Type_9 <> 0) and
       (DirAnt <> DWORD(FM_Info.AllocationBase))  then
    begin
      DirAnt:= DWORD(FM_Info.AllocationBase);
      Case FM_Info.Type_9 of
        $00020000: sTipo := 'Priv';
        $00040000: sTipo := 'Map ';
        $01000000: sTipo := 'Imag';
      end;
      sProt1:= DecodeProt(FM_Info.Protect);
      sProt2:= DecodeProt(FM_Info.AllocationProtect);
      S:= S+'                     '+IntToHex(DirAnt,8)+'  '+
                                   IntToHex(FM_Info.RegionSize,8)+'  '+
                                   sTipo+'  '+
                                   sProt1+'  '+
                                   sProt2+'  '+GetNameDll(DWORD(FM_Info.AllocationBase))+#13#10;
      while (FM_Info.Type_9 <> 0) do
      begin
        Dir:= Dir+FM_Info.RegionSize;
        InfoMemory(Dir);
        if (FM_Info.Type_9 = 0) or (Dir >= $7FFE0000) then
          break;
        DirAnt:= DWORD(FM_Info.BaseAddress);
        Case FM_Info.Type_9 of
          $00020000: sTipo := 'Priv';
          $00040000: sTipo := 'Map ';
          $01000000: sTipo := 'Imag';
        end;
        sProt1:= DecodeProt(FM_Info.Protect);
        sProt2:= DecodeProt(FM_Info.AllocationProtect);
        S:= S+'                     '+IntToHex(DirAnt,8)+'  '+
                                     IntToHex(FM_Info.RegionSize,8)+'  '+
                                     sTipo+'  '+
                                     sProt1+'  '+
                                     sProt2+'  '+GetNameDll(DWORD(FM_Info.AllocationBase))+#13#10;
      end;
    end
    else
      Dir:= Dir+FSys_Info.dwPageSize;
  end;
  WriteLog('MAPA DE MEMORIA'+#13#10+
           '                     ==============='+#13#10+
           '                     Address   Size      Type  Prot  Initial   '+#13#10+S);
end;
 }

//xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
// Este procedimiento muestra un MsgBox en pantalla.
// Solo simplifica la llamada a la API MessageBox
//xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
procedure TDbgCLS.MSG(text: String);
(*******************************************************************************)
begin
  MessageBoxA(0, PAnsiChar(text), PAnsiChar('Informacin de DbgCLS'), MB_OK or MB_ICONINFORMATION);
end;


//xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
// Funcion privada que devuelve una string con la linea traceada
// Es auxiliar del mtodo trace
// La lnea muestra (la direccin y) los registros modificados en cada paso
//xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
function TDbgCLS.strTrace: String;
(*******************************************************************************)
var
  S    : String;
//  sCode: String;
begin
//  S:= IntToHex(FTrace.AddrIni,8)+'  ';
  GetContext;
  if FCtx.EAX <> FTrace.CtxIni.EAX then S:= S+'EAX='+IntToHex(R.EAX,8)+'  ';
  if FCtx.EBX <> FTrace.CtxIni.EBX then S:= S+'EBX='+IntToHex(R.EBX,8)+'  ';
  if FCtx.ECX <> FTrace.CtxIni.ECX then S:= S+'ECX='+IntToHex(R.ECX,8)+'  ';
  if FCtx.EDX <> FTrace.CtxIni.EDX then S:= S+'EDX='+IntToHex(R.EDX,8)+'  ';
  if FCtx.ESI <> FTrace.CtxIni.ESI then S:= S+'ESI='+IntToHex(R.ESI,8)+'  ';
  if FCtx.EDI <> FTrace.CtxIni.EDI then S:= S+'EDI='+IntToHex(R.EDI,8)+'  ';
  if FCtx.ESP <> FTrace.CtxIni.ESP then S:= S+'ESP='+IntToHex(R.ESP,8)+'  ';
  if FCtx.EBP <> FTrace.CtxIni.EBP then S:= S+'EBP='+IntToHex(R.EBP,8)+'  ';
  if FCtx.EFlags <> FTrace.CtxIni.EFlags then S:= S+'EFlags='+IntToHex(R.EFlags,8);
//  FTrace.AddrIni:= FLastAddr;
  Move(FCtx,FTrace.CtxIni,Sizeof(FTrace.CtxIni));
  Result:= S;
end;


//xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
// Este procedimiento privado pone el bit TRAP FLAG a 1 para habilitar modo pasoa paso
//xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
procedure TDbgCLS.SetTrapFlag;
(*******************************************************************************)
begin
  GetContext;                      // Lee CONTEXT para activar TRAP FLAG
  R.EFlags:= R.EFlags or $100;     // Pone bit 8 de regFlag a 1 => activar TRAP FLAG se ejecutar una instruccin
  R.EIP:= FLastAddr;
  SetContext;
end;


//xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
// Funcion privada auxiliar para almacenar la informacin de los mdulos cargados
//xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
procedure TDbgCLS.AddDll(handle: hWnd; BaseAdd: DWORD);
(*******************************************************************************)
var
  hiSize: DWORD;
  FileMap: hWnd;
  PMapViewFile: ^DWORD;
  nameDll: Array[0..1024] of AnsiChar;
begin

  PMapViewFile:= NIL;
  New(FSDll);                                    // Crea un nuevo puntero
  FSDll^.handle:= handle;
  FSDll^.Base:= BaseAdd;
  FSDll^.size:= GetFileSize(handle,@hiSize);
  FileMap:= CreateFileMappingA(handle, NIL, PAGE_READONLY, 0, 1, NIL);
  if FileMap <> 0 then
    PMApViewFile:= MapViewOfFile(FileMap, FILE_MAP_READ, 0, 0, 1);
    if PMApViewFile <> NIL then
    begin
      GetMappedFileNameA
      (GetCurrentProcess, PMApViewFile , nameDll, 1024);
      FSDll^.name:= ExtractFileName(String(NameDll));
      FSDll^.path:= ExtractFilePath(String(NameDll));
      FListDll.Add(FSDll);
    end;
  UnmapViewOfFile(PMapViewFile);
  CloseHandle(FileMap);
end;

//xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
// Funcion devuelve el nombre del mdulo de la direccin especificada, si existe
//xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
function TDbgCLS.GetNameDll(Address: DWORD): String;
(*******************************************************************************)
var
  i: Integer;
begin
  Result:= '';
  InfoMemory(Address);
  for i:= 0 to FListDll.Count-1 do                // bucle para buscar la base del mdulo
  begin
    FSDll:= FListDll.Items[i];
    if (FSDll^.Base = DWORD(FM_Info.AllocationBase)) then
    begin
      Result:= FSDll^.Name;                      // encontrado; Devuelve nombre
      break;                                     // salimos del bucle
    end
  end;
end;

//xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
// Funcion devuelve la direccin BaseAddress del mdulo dll pasado como parmetro
//xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
function TDbgCLS.GetBaseDll(NameDll: String): dword;
(*******************************************************************************)
var
  i: Integer;
begin
  Result:= 0;
  for i:= 0 to FListDll.Count-1 do                // bucle para buscar la base del mdulo
  begin
    FSDll:= FListDll.Items[i];
    if uppercase(FSDll^.Name) = uppercase(NameDll) then
    begin
      Result:= FSDll^.base;                      // encontrado; Devuelve base
      break;                                     // salimos del bucle
    end
  end;
end;


//xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
// Funcion devuelve el tamao en bytes del mdulo dll pasado como parmetro
//xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
function TDbgCLS.GetSizeDll(NameDll: String): dword;
(*******************************************************************************)
var
  i: Integer;
begin
  Result:= 0;
  for i:= 0 to FListDll.Count-1 do                // bucle para buscar la base del mdulo
  begin
    FSDll:= FListDll.Items[i];
    if uppercase(FSDll^.Name) = uppercase(NameDll) then
    begin
      Result:= FSDll^.size;                      // encontrado; Devuelve tamao
      break;                                     // salimos del bucle
    end
  end;
end;


// Pone a 1 Flag de registro de estado
// Valores posibles del parmetro Flag:
// C=Carry; P=Parity; A=Adjust; Z=Zero; S=Sign; T=Trap; I=Interrupt; D=Direction; O=Overflow
// Gracias SPANDAU por la idea
//xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
procedure TDbgCLS.SetFlag(Flag: Char);
//xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
begin
  GetContext;
  Case Flag of
    'C': R.EFlags:= R.EFlags or MSK_CF;
    'P': R.EFlags:= R.EFlags or MSK_PF;
    'A': R.EFlags:= R.EFlags or MSK_AF;
    'Z': R.EFlags:= R.EFlags or MSK_ZF;
    'S': R.EFlags:= R.EFlags or MSK_SF;
    'T': R.EFlags:= R.EFlags or MSK_TF;
    'I': R.EFlags:= R.EFlags or MSK_IF;
    'D': R.EFlags:= R.EFlags or MSK_DF;
    'O': R.EFlags:= R.EFlags or MSK_CF;
  end;
  SetContext;
end;

//xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
// Pone a 1 Flag de registro de estado
// Valores posibles del parmetro Flag:
// C=Carry; P=Parity; A=Adjust; Z=Zero; S=Sign; T=Trap; I=Interrupt; D=Direction; O=Overflow
// Gracias SPANDAU por la idea
//xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
procedure TDbgCLS.ClearFlag(Flag: Char);
//xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
begin
  GetContext;
  Case Flag of
    'C': R.EFlags:= R.EFlags and N_MSK_CF;
    'P': R.EFlags:= R.EFlags and N_MSK_PF;
    'A': R.EFlags:= R.EFlags and N_MSK_AF;
    'Z': R.EFlags:= R.EFlags and N_MSK_ZF;
    'S': R.EFlags:= R.EFlags and N_MSK_SF;
    'T': R.EFlags:= R.EFlags and N_MSK_TF;
    'I': R.EFlags:= R.EFlags and N_MSK_IF;
    'D': R.EFlags:= R.EFlags and N_MSK_DF;
    'O': R.EFlags:= R.EFlags and N_MSK_CF;
  end;
  SetContext;
end;


//xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
// Pone un Breakpoint Software en en Entry Point
//xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
procedure TDbgCLS.SetBreakOnEP;
(*******************************************************************************)
begin
  SetBP(FStartAddress);
end;


//xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
// Ejecuta una instruccin y llama a la funcin asociada al evento OnTraceInto
//xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
procedure TDbgCLS.StepTrace;
(*******************************************************************************)
var
  strTemp  : String;
  strTemp2 : STring;
  LenOp    : Integer;
  i        : Integer;
begin
//  FTrace.TraceOver:= true;
  strTemp:= '';
  LenOp:= GetSizeOfCode(FTrace.AddrIni);
  FTrace.NextAddr:= FTrace.AddrIni;
  for i:= 0 to LenOp-1 do
    strTemp:= strTemp + IntToHex(ReadMemoryB(FTrace.AddrIni+i),2);// + ' ';
// Copia y almacena opcodes a longitud fija de 21 caracteres
  strTemp2:= strTemp+StringOfChar(' ',21-Length(strTemp));
  FTrace.Opcodes:= ' ' + strTemp2;
// Almacena registros modificados
  FTrace.ModifiedReg:= strTrace;
  strTemp2:= Copy(DisAsmAddr(FTrace.AddrIni),32,256);
// Copia y almacena ASM ajustada a longitud fija de 32 caracteres
  FTrace.Disasm:= strTemp2+StringOfChar(' ',32-Length(strTemp2));
  if assigned(FOnTraceInto) then      // Si est definida la funcin de usuario
    FOnTraceInto(FTrace)
  else                                // Si no esta definida muestra formato por defecto
  begin                               // (Direccion y registros modificados)
    strTemp:={ IntToHex(FTrace.AddrIni,8) + '  ' + FTrace.Opcodes +} FTrace.Disasm + ' ' + FTrace.ModifiedReg;
    WriteLogWD(strTemp);
  end;
  Dec(FTrace.NIns);
  FTrace.AddrIni:= FLastAddr;
  if FTrace.NIns > 0 then
  begin
    if not FTrace.TraceOver then
      SetTrapFlag                      // Activa modo paso a paso
    else
    begin
//      if Pos('CALL',FTrace.Disasm) <> 0 then
//      begin
//        FTrace.NextAddr:= FTrace.NextAddr+LenOP;
//        SetBP(FTrace.NextAddr);
//      end
//      else
        SetTrapFlag                    // Activa modo paso a paso
    end;
  end;
end;


//xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
// Devuelve la longitud del opcode apuntado por la direccin Address
// Hace uso del cdigo original:
// Hacker Disassembler Engine 32 0.11 de Veacheslav Patkov adaptado por in4matics - AT4RE Team Forum
//xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
function  TDbgCLS.GetSizeOfCode(Address: DWORD): DWORD;
(*******************************************************************************)
var
  a      : array[0..29] of byte;
  ret    : boolean;
  bufcnt : dword;
  PAddr  : Pointer;
  HDE    : HDEinstruction;                       // Estructura definida en HDEngine.pas
begin
  PAddr:= Pointer(Address);
  ret:= ReadProcessMemory(
                  FP_info.hProcess,              // HANDLE hProcess,	// handle to process whose memory is written to
                  PAddr,//ptr(address),          // LPVOID lpBaseAddress,	// address to start reading
                  @a,                            // LPVOID lpBuffer,	// pointer to buffer to read data to
                  30,                            // DWORD nSize,	// number of bytes to read
                  BufCnt);                       // LPDWORD lpNumberOfBytesWritten 	// actual number of bytes
  if not ret then WriteLog('Error: '+SysErrorMessage(GetLastError())+' al leer en direccin '+IntToHex(address,8));

  PAddr:= @a;
  hdeDisasm(PAddr,HDE);
  Result:= HDE.len;
end;


//xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
// Devuelve la longitud de la funcin apuntada por la direccin Address
//xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
function  TDbgCLS.GetSizeOfProc(Address: DWORD): DWORD;
(*******************************************************************************)
var
  dwTemp: DWORD;
begin
  dwTemp:= GetRetOfProc(Address);
  Result:= dwTemp-Address;
end;


//xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
// Devuelve la direccion de retorno del procedimiento especificado por la direccin Address
// Hace uso del cdigo original:
// Hacker Disassembler Engine 32 0.11 de Veacheslav Patkov adaptado por in4matics - AT4RE Team Forum
//xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
function  TDbgCLS.GetRetOfProc(Address: DWORD): DWORD;
(*******************************************************************************)
var
  S: String;
  ins: TDasm;
begin
  Result:= 0;
  ins.AddrIni:= Address;
  repeat
    GetDisAsm(ins);
    S:= ins.Disasm;
    if Pos('RET',S) <> 0 then
      Result:= ins.AddrIni;
    ins.AddrIni:= ins.NextAddr;
  until Result <> 0;
end;

//xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
// Muestra informacin de las secciones del ejecutable
//xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
procedure TDbgCLS.LogSections(FFile: String);
(*******************************************************************************)
const
  INVALID_SET_FILE_POINTER = DWORD(-1);
type
  PImageSectionHeaders = ^TImageSectionHeaders;
  TImageSectionHeaders = array [Word] of TImageSectionHeader;
var
  FileHandle    : THandle;
  BytesRead     : DWORD;
  ImageDosHeader: TImageDosHeader;
  ImageNtHeaders: TImageNtHeaders;
  SectionHeaders: PImageSectionHeaders;
  p             : pchar;
  i,c           : Integer;
  sName         : String;
  S             : AnsiString;
begin
  // Abre el archivo en modo lectura
  FileHandle := CreateFile(PChar(FFile), GENERIC_READ, FILE_SHARE_READ, nil, OPEN_EXISTING, 0, 0);
  if (FileHandle <> INVALID_HANDLE_VALUE) then
  try
    // Lee la cabecera MS-DOS header para tomar el offset de la cabecera PE32
    if not ReadFile(FileHandle, ImageDosHeader, SizeOf(TImageDosHeader), BytesRead, nil) or
                   (BytesRead <> SizeOf(TImageDosHeader)) or
                   (ImageDosHeader.e_magic <> IMAGE_DOS_SIGNATURE) then
    begin
      ImageDosHeader._lfanew := 0;
    end;
    // Lee la cabecera PE32 (incluyendo la cabecera opcional
    if (SetFilePointer(FileHandle, ImageDosHeader._lfanew, nil, FILE_BEGIN) = INVALID_SET_FILE_POINTER) then
      Exit;                                      // Sale si puntero a la cabecera no vlido
    if not(ReadFile(FileHandle, ImageNtHeaders, SizeOf(TImageNtHeaders), BytesRead, nil) and
          (BytesRead = SizeOf(TImageNtHeaders))) then
      Exit;                                      // Sale si la lectura no fue correcta
    // Valida la cabecera PE32
    if (ImageNtHeaders.Signature <> IMAGE_NT_SIGNATURE) then
      Exit;
    with ImageNtHeaders, FileHeader, OptionalHeader do
    begin
      if (SizeOfOptionalHeader < IMAGE_SIZEOF_NT_OPTIONAL_HEADER) or
         (Magic <> IMAGE_NT_OPTIONAL_HDR_MAGIC) then
        Exit;                                    // Sale si cabecera opcional no vlida
      FSizeOfImage:= SizeOfImage;                // Aqui lee
      // Lee cabeceras de cada seccin
      SectionHeaders := GetMemory(NumberOfSections * SizeOf(TImageSectionHeader));
      if Assigned(SectionHeaders) then
      try
        if (SetFilePointer(FileHandle, SizeOfOptionalHeader - IMAGE_SIZEOF_NT_OPTIONAL_HEADER, nil, FILE_CURRENT) = INVALID_SET_FILE_POINTER) then
          Exit;                                 // Sale si puntero a cabecera no vlido
        if not(ReadFile(FileHandle, SectionHeaders^, NumberOfSections *
               SizeOf(TImageSectionHeader), BytesRead, nil) and (BytesRead =
               NumberOfSections * SizeOf(TImageSectionHeader))) then
          Exit;                                 // Sale si lectura de cabecera erronea
        S:='';
        p:= pointer(SectionHeaders);
        for i := 1 to NumberOfSections do
        begin
          with PImageSectionHeader(p)^ do
          begin
            if i = 1 then
            begin
              FVirtualOffsetCode:= VirtualAddress;    // Guarda Virtual Offset de la primera seccin (normalmente code)
              FVirtualSizeCode:= Misc.VirtualSize;    // Guarda Virtual Size de la primera seccin
              FRatioSize:= 0;
              if SizeOfRawData > 0 then
                FRatioSize:= FVirtualSizeCode /SizeOfRawData;
            end;
            sName:= '';
            For c:= 0 to 7 do
            begin
              if PImageSectionHeader(p).Name[c] = 0 then break;
              sName:= sName+Char(PImageSectionHeader(p).Name[c]);
            end;
            sName:= StringOfChar(' ',21)+Copy(sName,1,8)+StringOfChar(' ',8-Length(sName));
            S:= S+sName+' '+IntToHex(VirtualAddress,8)+'  '+
                            IntToHex(Misc.VirtualSize,8)+'  '+
                            IntToHex(PointerToRawData,8)+'  '+
                            IntToHex(SizeOfRawData,8)+'  '+
                            IntToHex(Characteristics,8)+#13#10;
  //          PointerToRawData:= VirtualAddress;
  //          SizeOfRawData:= Misc.VirtualSize;
            inc(p, sizeof(TImageSectionHeader));
          end;
        end;
         WriteLog('INFORMACION DE SECCIONES'+#13#10+
                 '                     ======================='+#13#10+
                 '                     Name     V.Offset  V.Size    R.Offset  R.Size    Flags   '+#13#10+
                 '                     -------- --------  --------  --------  --------  ---------- '+#13#10+S);
      finally
        FreeMemory(SectionHeaders);
      end;
    end;
  finally
    CloseHandle(FileHandle);
  end;
end;


//xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
// Funcion auxiliar para convertir una string en cadena hexadecimal separada por espacios
//xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
function StrToHex(const S: string): string;
(*******************************************************************************)
var
  i     : Integer;
  sTemp : String;
begin
  sTemp := '';
  for i := 1 to Length(S) do
    sTemp := sTemp + IntToHex(Ord(S[i]), 2) + ' ';
  Result:= sTemp+' '+S+' '+#13#10
end;


//xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
// Funcion para dumpear el proceso activo
// Gracias Arapumk
//xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
function TDbgCLS.DumpProc: Boolean;
(*******************************************************************************)
var
  proceso          : Thandle;   // Manejador del proceso
  inicio           : DWORD;
  tam              : DWORD;
//  bien             : boolean ;
  Buffer           : Pchar;
  fhandle          : Thandle;    // manejador del fichero;
  ret              : boolean;
  BufCnt           : DWORD;
  anterior         : DWORD;
  dwTemp           : DWORD;
  PAddr            : Pointer;
begin
  Result:= false;
  proceso:= FP_info.hProcess;
  WriteLog('Proceso: '+IntToHex(proceso,4));
  inicio:= FBaseOfImage;
  WriteLog('BaseOfImage: '+IntToHex(inicio,8));
  tam:= FSizeOfImage;
  WriteLog('Tamao: '+IntToHex(tam,8));
  try
    GetMem(Buffer, Tam);
    PAddr:= Pointer(Inicio);
    ret:= VProtect(Inicio, tam, PAGE_EXECUTE_READWRITE, anterior); // Cambia la proteccion de memoria
    if not ret then writeLog('Error al ejecutar VirtualProtectEx en ReadMemoryB direccin '+IntToHex(Inicio,8)+': '+SysErrorMessage(GetLastError()))
    else
    begin
      ret:= ReadProcessMemory(
                FP_info.hProcess,                // HANDLE hProcess,	// handle to process whose memory is written to
                PAddr,                           // LPVOID lpBaseAddress,	// address to start reading
                buffer,                          // LPVOID lpBuffer,	// pointer to buffer to write data to
                tam,                             // DWORD nSize,	// number of bytes to write
                BufCnt);                         // LPDWORD lpNumberOfBytesWritten 	// actual number of bytes written
      if not ret then WriteLog('Error: '+SysErrorMessage(GetLastError())+' al leer en direccin '+IntToHex(Inicio,8))
      else
      begin
        // dwTemp := anterior;
        // dejamos la proteccion de memoria como PAGE_EXECUTE_READWRITE
        // ret:= VProtect(Inicio, tam, PAGE_EXECUTE_READWRITE, anterior); // Cambia la proteccion de memoria
        // if not ret then writeLog('Error al ejecutar VirtualProtectEx en DumpProc direccin '+IntToHex(inicio,8)+': '+SysErrorMessage(GetLastError()))
        // else
        // begin
          Fhandle:=FileCreate(ExtractFilePath(FExeName)+NAME_DUMP);
          FileSeek(Fhandle,0,0);
          FileWrite(Fhandle,buffer[0],tam);
          Result:= true;
        // end;
      end;
    end;  
  finally
    freeMem(buffer);
    FileClose(Fhandle);
    CloseHandle(Proceso);
  end;
end;

//xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
 // Recoge la direccion del ultimo SEH (Structured Exception Handler) instalado
//xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
 function TDbgCLS.GetLastSEH: DWORD;
(*******************************************************************************)
var
  dwTemp: DWORD;
begin
  dwTemp:= ReadMemoryDW(FTEB);
  Result:= ReadMemoryDW(dwTemp+4);
//  WriteLog('SEH = '+IntToHex(Result,8));
end;

//xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
// Corrige RawSize y RawOffset de cada seccin del dumpeado
//xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
function TDbgCLS.FixDump(OEP: DWORD; Raw_Virtual: Boolean): boolean;
(*******************************************************************************)
const
  INVALID_SET_FILE_POINTER = DWORD(-1);
type
  PImageSectionHeaders = ^TImageSectionHeaders;
  TImageSectionHeaders = array [Word] of TImageSectionHeader;
var
  FileHandleR   : THandle;
  FileHandleW   : THandle;
  BytesRead     : DWORD;
  ImageDosHeader: TImageDosHeader;
  ImageNtHeaders: TImageNtHeaders;
  SectionHeaders: PImageSectionHeaders;
  p             : pchar;
  i             : Integer;
  S             : AnsiString;
begin
  Result:= False;
  // Abre el ejecutable en modo lectura
  FileHandleR := CreateFile(PChar(FExeName), GENERIC_READ, FILE_SHARE_READ, nil, OPEN_EXISTING, 0, 0);
  if (FileHandleR <> INVALID_HANDLE_VALUE) then
  // Abre el dumpeado en modo escritura
  FileHandleW := CreateFile(PChar(ExtractFilePath(FExeName)+NAME_DUMP), GENERIC_WRITE, FILE_SHARE_READ, nil, OPEN_EXISTING, 0, 0);
  if (FileHandleW <> INVALID_HANDLE_VALUE) then
  try
    // Lee la cabecera MS-DOS header para tomar el offset de la cabecera PE32
    if not ReadFile(FileHandleR, ImageDosHeader, SizeOf(TImageDosHeader), BytesRead, nil) or
                   (BytesRead <> SizeOf(TImageDosHeader)) or
                   (ImageDosHeader.e_magic <> IMAGE_DOS_SIGNATURE) then
    begin
      ImageDosHeader._lfanew := 0;
    end;
    // Se situa en el principio de la cabecera PE32
    if (SetFilePointer(FileHandleR, ImageDosHeader._lfanew, nil, FILE_BEGIN) = INVALID_SET_FILE_POINTER) then
      Exit;                                      // Sale si puntero a la cabecera no vlido
   if (SetFilePointer(FileHandleW, ImageDosHeader._lfanew, nil, FILE_BEGIN) = INVALID_SET_FILE_POINTER) then
      Exit;                                      // Sale si puntero a la cabecera no vlido
    // Lee la cabecera PE32 (incluyendo la cabecera opcional
    if not(ReadFile(FileHandleR, ImageNtHeaders, SizeOf(TImageNtHeaders), BytesRead, nil) and
          (BytesRead = SizeOf(TImageNtHeaders))) then
      Exit;
    // Valida la cabecera PE32
    if (ImageNtHeaders.Signature <> IMAGE_NT_SIGNATURE) then
      Exit;
    ImageNtHeaders.OptionalHeader.AddressOfEntryPoint:= OEP-FBaseOfImage;    // Aqui modificamos el OEP;
    // Escribe la cabecera modificada
    if not(WriteFile(FileHandleW, ImageNtHeaders, SizeOf(TImageNtHeaders), BytesRead, nil) and
      (BytesRead = SizeOf(TImageNtHeaders))) then
      Exit;                                      // Sale si la escritura no fue correcta
    if Raw_Virtual then                          // Si el parametro es true iguala RawSize/Offset a Virtual Size/Offset
    begin
      with ImageNtHeaders, FileHeader, OptionalHeader do
      begin
        if (SizeOfOptionalHeader < IMAGE_SIZEOF_NT_OPTIONAL_HEADER) or
           (Magic <> IMAGE_NT_OPTIONAL_HDR_MAGIC) then
          Exit;                                    // Sale si cabecera opcional no vlida
        // Lee cabeceras de cada seccin
        SectionHeaders := GetMemory(NumberOfSections * SizeOf(TImageSectionHeader));
        if Assigned(SectionHeaders) then
        try
          if (SetFilePointer(FileHandleR, SizeOfOptionalHeader - IMAGE_SIZEOF_NT_OPTIONAL_HEADER, nil, FILE_CURRENT) = INVALID_SET_FILE_POINTER) then
            Exit;                                 // Sale si puntero a cabecera no vlido
          if not(ReadFile(FileHandleR, SectionHeaders^, NumberOfSections *
                 SizeOf(TImageSectionHeader), BytesRead, nil) and (BytesRead =
                NumberOfSections * SizeOf(TImageSectionHeader))) then
            Exit;                                 // Sale si lectura de cabecera erronea
          S:='';
          p:= pointer(SectionHeaders);
          for i := 1 to NumberOfSections do
          begin
            with PImageSectionHeader(p)^ do
            begin
              PointerToRawData:= VirtualAddress;        // Aqui iguala RawOffset = VirtualOffset
              SizeOfRawData:= Misc.VirtualSize;         // Aqui iguala RawSize = VirtualSize
              inc(p, sizeof(TImageSectionHeader));
            end;
          end;
          if (SetFilePointer(FileHandleW, SizeOfOptionalHeader - IMAGE_SIZEOF_NT_OPTIONAL_HEADER, nil, FILE_CURRENT) = INVALID_SET_FILE_POINTER) then
            Exit;                                       // Sale si puntero a cabecera no vlido
          if not(WriteFile(FileHandleW, SectionHeaders^, NumberOfSections *
                 SizeOf(TImageSectionHeader), BytesRead, nil) and (BytesRead =
                 NumberOfSections * SizeOf(TImageSectionHeader))) then
            Exit                                       // Sale si lectura de cabecera erronea
          else
            Result:= True;
        finally
          FreeMemory(SectionHeaders);
        end;
      end;                                             // de with
    end;                                               // de if Raw_Virtual
  finally
    CloseHandle(FileHandleR);
    CloseHandle(FileHandleW);
  end
  else
    WriteLog('Error en FixDump');
end;


//xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
// Muestra todas las APIS importadas
// Cdigo extraido de http://www.sunshine2k.de/
// Iczelion's PE tutorial 6 for Delphi
//xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
procedure TDbgCLS.LogImports;
(*******************************************************************************)
type
  IMAGE_FILE_HEADER = packed record
    Machine              : WORD;
    NumberOfSections     : WORD;
    TimeDateStamp        : DWORD;
    PointerToSymbolTable : DWORD;
    NumberOfSymbols      : DWORD;
    SizeOfOptionalHeader : WORD;
    Characteristics      : WORD;
  end;
  PIMAGE_FILE_HEADER = ^IMAGE_FILE_HEADER;

  type
  IMAGE_DOS_HEADER = packed record               { DOS .EXE header }
    e_magic         : WORD;                      { Magic number }
    e_cblp          : WORD;                      { Bytes on last page of file }
    e_cp            : WORD;                      { Pages in file }
    e_crlc          : WORD;                      { Relocations }
    e_cparhdr       : WORD;                      { Size of header in paragraphs }
    e_minalloc      : WORD;                      { Minimum extra paragraphs needed }
    e_maxalloc      : WORD;                      { Maximum extra paragraphs needed }
    e_ss            : WORD;                      { Initial (relative) SS value }
    e_sp            : WORD;                      { Initial SP value }
    e_csum          : WORD;                      { Checksum }
    e_ip            : WORD;                      { Initial IP value }
    e_cs            : WORD;                      { Initial (relative) CS value }
    e_lfarlc        : WORD;                      { File address of relocation table }
    e_ovno          : WORD;                      { Overlay number }
    e_res           : packed array [0..3] of WORD; { Reserved words }
    e_oemid         : WORD;                      { OEM identifier (for e_oeminfo) }
    e_oeminfo       : WORD;                      { OEM information; e_oemid specific }
    e_res2          : packed array [0..9] of WORD; { Reserved words }
    e_lfanew        : Longint;                   { File address of new exe header }
  end;
  PIMAGE_DOS_HEADER = ^IMAGE_DOS_HEADER;

  IMAGE_NT_HEADERS = packed record
    Signature       : DWORD;
    FileHeader      : IMAGE_FILE_HEADER;
    OptionalHeader  : IMAGE_OPTIONAL_HEADER;
  end;
  PIMAGE_NT_HEADERS = ^IMAGE_NT_HEADERS;

 IMAGE_IMAGE_IMPORT_DESCRIPTOR  = packed record
    OriginalFirstThunk  : DWORD;
    TimeDateStamp       : DWORD;
    ForwarderChain      : DWORD;
    Name1               : DWORD;
    FirstThunk          : DWORD;
  end;
  PIMAGE_IMAGE_IMPORT_DESCRIPTOR =^IMAGE_IMAGE_IMPORT_DESCRIPTOR;

  IMAGE_IMPORT_BY_NAME  = packed record
    Hint                : WORD;
    Name1               : array [1..150] of char;
  end;
  PIMAGE_IMPORT_BY_NAME = ^IMAGE_IMPORT_BY_NAME;

  IMAGE_SECTION_HEADER = packed record
    Name                 : packed array [0..IMAGE_SIZEOF_SHORT_NAME-1] of Char;
    PhysicalAddress      : DWORD;                // or VirtualSize (union);
    VirtualAddress       : DWORD;
    SizeOfRawData        : DWORD;
    PointerToRawData     : DWORD;
    PointerToRelocations : DWORD;
    PointerToLinenumbers : DWORD;
    NumberOfRelocations  : WORD;
    NumberOfLinenumbers  : WORD;
    Characteristics      : DWORD;
  end;
  PIMAGE_SECTION_HEADER = ^IMAGE_SECTION_HEADER;

var
  dwTemp            : DWORD;
  hFile             : THandle;
  hmapping          : THandle;
  pmapping          : Pointer;
  Pdosh             : PIMAGE_DOS_HEADER;
  peh               : PIMAGE_NT_HEADERS;
  IID               : PIMAGE_IMAGE_IMPORT_DESCRIPTOR;
  IIDRva, IIDOffset : DWORD;
  ThunksOffset      : DWORD;
  Importname        : PIMAGE_IMPORT_BY_NAME;
  Rvafunction       : DWORD;
  S                 : String;
  i                 : Integer;
  sTemp             : String;

  function RVA2Offset(Rva : DWORD; pmap : Pointer) : DWORD;
  var
    sectionh      : PIMAGE_SECTION_HEADER;
    section_count : Integer;
    i             : Integer;
  begin
    section_count := peh.FileHeader.NumberOfSections;
    //Sectiontable
    sectionh := PIMAGE_SECTION_HEADER(LongWord(peh) + Longword(sizeof(IMAGE_NT_HEADERS)));
    for i := 1 to section_count do   // bucle para cada seccion
    begin
      If (Rva >= Sectionh.VirtualAddress) and (RVA < Sectionh.VirtualAddress + Sectionh.SizeofRawData{PhysicalAddress}) then
      begin
         result := Sectionh.PointerToRawData + (RVA - Sectionh.VirtualAddress);
      end;
      sectionh := PIMAGE_SECTION_HEADER(Longword(sectionh) + longword(sizeof(IMAGE_SECTION_HEADER)));
    end;
  end;

begin
  // Obtiene manejador hFile al archivo que queremos proyectar
  hFile := CreateFileA(PAnsiChar(FExeName),
                       GENERIC_READ,
                       FILE_SHARE_READ,
                       nil,
                       OPEN_EXISTING, FILE_ATTRIBUTE_NORMAL,
                       0);
  if hFile = INVALID_HANDLE_VALUE then
  begin
    WriteLog('ERROR: No se ha podido abrir el archivo');
    exit;
  end;

  // Obtiene un manejador hmapping al archivo creado con CreateFileMapping
  // Esta funcin crea un archivo proyectado a partir del archivo abierto por CreateFile.
  hmapping := CreateFileMapping(hFile, nil, PAGE_READONLY, 0, 0, nil);
  if hmapping = 0 then
  begin
    WriteLog('ERROR: No se ha podido crear el archivo proyectado');
    exit;
  end;

  // Esta funcin regresa un puntero al primer byte de la regin proyectada del archivo.
  pmapping := MapViewOfFile(hMapping, FILE_MAP_READ, 0, 0, 0);
  if DWORD(pmapping) = 0 then
  begin
    WriteLog('ERROR No puedo mapear el archivo');
    exit;
  end;

  PDosh := PIMAGE_DOS_HEADER(pmapping);           // Puntero a estructura IMAGE_DOS_HEADER
  Peh := PIMAGE_NT_HEADERS(LongWord(PDosh) + LongWord(PDosh.e_lfanew)); // Puntero a estructura IMAGE_NT_HEADERS
  if (pdosh.e_magic = IMAGE_DOS_SIGNATURE) and (peh.Signature = IMAGE_NT_SIGNATURE)
  then                                           // Si es un archivo PE vlido continua
  // Aqui lee la Tabla de Importaciones
  begin
    dwTemp := peh.Optionalheader.DataDirectory[1].VirtualAddress;
    if dwTemp = 0 then
    begin
      WriteLog('No se ha encontrado la Tabla de Importacin');
      exit;
    end;

    // Obtiene la direccin de la IT (DataDirectory[1].VirtualAddress
    IIDRva := Peh.OptionalHeader.DataDirectory[1].VirtualAddress;
    // Obtiene el offset de la IT dentro del archivo
    IIDoffset := RVA2Offset(IIDRva,pmapping);
    // Obtiene la direccin de la IID dentro del archivo mapeado
    IID := PIMAGE_IMAGE_IMPORT_DESCRIPTOR(Longword(pmapping) + IIDOffset);
    S:= '';
    while (IID.FirstThunk <> 0) do    // Hasta que no terminen funciones actual DLL
    begin                             // Datos de la DLL
      S:= S+ '                     ---------------------------------- '+#13#10+
             '                     Original FirstThunk = '+IntToHex(IID.OriginalFirstthunk,8)+#13#10+
             '                     TimeDateStamp       = '+IntToHex(IID.TimeDateStamp,8)+#13#10+
             '                     ForwarderChain      = '+IntToHex(IID.ForwarderChain,8)+#13#10+
             '                     Dll Name            = '+Pchar(DWORD(pmapping) + Rva2offset(IID.Name1,pmapping))+#13#10+
             '                     FirstThunk          = '+IntToHex(IID.FirstThunk,8)+#13#10+
             '                     ---------------------------------- '+#13#10;
      // Funciones de la DLL
      if IID.OriginalFirstThunk = 0 then
         ThunksOffset := RVA2Offset(IID.Firstthunk,pmapping)
      else
         ThunksOffset := RVA2Offset(IID.OriginalFirstthunk,pmapping);
      // Va leyendo todos los "Thunks" de cada DLL
      while (PDWORD(DWORD(pmapping) + DWORD(Thunksoffset))^<>0) do
      begin
        RvaFunction := RVA2offset(PDWORD(DWORD(pmapping) + DWORD(Thunksoffset))^,pmapping);
        if (PDWORD(DWORD(pmapping) + DWORD(Thunksoffset))^ and $80000000 = 0) then
        begin                                          //ImportbyName
          importName := PIMAGE_IMPORT_BY_NAME(RvaFunction+DWORD(pmapping));
 //         h := WORD(importname.hint);
          sTemp:= ''; i:= 1;
          while importname.name1[i] <> #0 do
          begin
            sTemp:= sTemp + importname.name1[i];
            inc(i);
          end;
          S:= S +'                     '+ sTemp+#13#10;
        end
        else
          S:= S +'                     '+ IntToHex(DWORD(PDWORD(DWORD(pmapping) + DWORD(Thunksoffset))^ and $FFFF),4)+#13#10;
        inc(ThunksOffset,4);
      end;

      IID := PIMAGE_IMAGE_IMPORT_DESCRIPTOR(Longword(IID) + longword(sizeof(IMAGE_IMAGE_IMPORT_DESCRIPTOR)));
    end;
    WriteLog('FUNCIONES IMPORTADAS'+#13#10+
             '                     ===================='+#13#10+S);
  end
  else
    WriteLog('ERROR No es un archivo PE vlido');
  UnmapViewofFile(pmapping);
  CloseHandle(hmapping);
  CloseHandle(hFile);
end;


//xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
// Funcion auxiliar para comprobar el sistema operativo
// Tomada de http://www.swissdelphicenter.ch/torry/showcode.php?id=316
// Autor: Chris Stoner
//xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
function GetOperatingSystem: Integer;
(*******************************************************************************)
var
  osVerInfo: TOSVersionInfo;
  majorVer, minorVer: Integer;
begin
  { set operating system type flag }
  osVerInfo.dwOSVersionInfoSize := SizeOf(TOSVersionInfo);
  if GetVersionEx(osVerInfo) then
  begin
    majorVer := osVerInfo.dwMajorVersion;
    minorVer := osVerInfo.dwMinorVersion;
    case osVerInfo.dwPlatformId of
      VER_PLATFORM_WIN32_NT: { Windows NT/2000 }
        begin
          if majorVer <= 4 then
            Result := cOsWinNT
          else if (majorVer = 5) and (minorVer = 0) then
            Result := cOsWin2000
          else if (majorVer = 5) and (minorVer = 1) then
            Result := cOsXP
          else if (majorVer = 6) and (minorVer = 1) then
            Result := cOsXP
          else
            Result := cOsUnknown;
        end;
      VER_PLATFORM_WIN32_WINDOWS:  { Windows 9x/ME }
        begin
          if (majorVer = 4) and (minorVer = 0) then
            Result := cOsWin95
          else if (majorVer = 4) and (minorVer = 10) then
          begin
            if osVerInfo.szCSDVersion[1] = 'A' then
              Result := cOsWin98SE
            else
              Result := cOsWin98;
          end
          else if (majorVer = 4) and (minorVer = 90) then
            Result := cOsWinME
          else
            Result := cOsUnknown;
        end;
      else
        Result := cOsUnknown;
    end;
  end
  else
    Result := cOsUnknown;
end;


//xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
// Busca la IAT en el proceso cargado en memoria
//xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
function TDbgCLS.FindIAT(var InfoIAT: TInfoIAT): Boolean;
(*******************************************************************************)
var
  buffer      : array [0..255] of Char;          // Utilizado para contener los Opcodes que vamos a buscar
  dwInicio    : DWORD;                           // Direccin de inicio de la bsqueda
  dwFinal     : DWORD;                           // Direccion final de la bsqueda
  dwTam       : DWORD;                           // Tamao del rango de bsqueda
  dwDir       : DWORD;                           // Direccin del Opcode encontrado
  dwCount     : DWORD;                           // Contador de direcciones IAT vlidas
  dwMaximo    : DWORD;                           // Auxiliar para conocer la direccin mas alta de la IAT
  dwMinimo    : DWORD;                           // Auxiliar para conocer la direccin mas baja de la IAT
  dwTemp      : DWORD;                           // Auxiliar utilizada para leer la direccion de la IAT
  dwTemp2     : DWORD;                           // Auxiliar utilizada para leer la direccion de la API
//  CurrentIsLog: Boolean;                         // Boolean para guardar flag de IsLog
begin
  buffer:= Char($FF)+Char($25);                  // Busca la instruccin JMP DWORD PTR DS:[<API>]
  dwInicio:= FVirtualOffsetCode+ FBaseOfImage;   // dwInicio = Direccion inicio seccin Code
  dwFinal:= FBaseOfImage+FSizeOfImage;           // dwFinal = Direccin final de todas las secciones
  dwTam:= dwFinal-dwInicio;                      // dwTam = diferencia
  dwMinimo:= $FFFFFFFF;                          // Coloca valor inicial
  dwMaximo:= 0;                                  // Coloca valor inicial
  dwDir:= 0;                                     // Coloca valor inicial
  dwCount:= 0;                                   // Coloca valor inicial
  while dwDir <> $FFFFFFFF do                    // Bucle mientras encuentre opcodes buscados
  begin
    dwDir:= Find(dwInicio,dwTam,buffer);         // Aqui hace la bsqueda. DDDDDDDD JMP DWORD PTR DS:[<API>] dwDir = DDDDDDDD
    if dwDir <> $FFFFFFFF then
    begin
      dwTemp:= ReadMemoryDW(dwDir+2);            // dwTemp = XXXXXXXX operando del salto indirecto
      dwTemp2:= ReadMemoryDW(dwTemp);            // dwTemp2 = [XXXXXXXX] = <API>
    end;
    if (dwDir <> $FFFFFFFF) and                                           // Opcode encontrado => dwDIR <> $FFFFFFFF
       (dwTemp > FVirtualOffsetCode+ FBaseOfImage) and                    // dwTemp por encima de la seccion de cdigo
       (dwTemp < FBaseOfImage+FSizeOfImage) and                           // dwTemp por debajo del espacio de memoria de la imagen
//       (dwTemp > FVirtualOffsetCode+FBaseOfImage+FVirtualSizeCode) and    // dwTemp por encima de la seccion de cdigo
       (dwTemp2 > FVirtualOffsetCode+FBaseOfImage+FVirtualSizeCode)then   // dwTemp2 por encima de la ImageBase
    begin                                        // Si es una direccin vlida comprueba inicio y final de IAT
      if dwTemp > dwMaximo then dwMaximo := dwTemp;   // Actualiza final de la API
      if dwTemp < dwMinimo then dwMinimo := dwTemp;   // Actualiza inicio de la API
      inc(dwCount);                                   // Actualiza contador de entradas en API
      WriteLog('Encontrado en: '+IntToHex(dwDir,8)+' valor: '+IntToHex(dwtemp,8)+' API: '+IntToHex(dwTemp2,8));
      New(FFncAPI);                              // Crea un nuevo puntero
      FFncAPI^.AddrAPI := dwTemp2;               // Lee la direccion de la API
      FFncAPI^.AddrIAT:= dwTemp;                 // Lee la direccion de la entrada en la IAT
      FListAPI.Add(FFncAPI);                     // Aade el nuevo puntero a registro TImportAPI
    end;
//    if dwMinimo < $FFFFFFFF then
    if (dwMinimo < $FFFFFFFF) and (dwMinimo > dwFinal) then
      dwFinal:= dwMinimo;                        // Ajusta dwFinal del rango por debajo del inicio de la IAT
    dwTam:= dwFinal-dwDir-2;                     // Calcula tamao del rango
    if dwDir <> $FFFFFFFF then
      dwInicio:= dwDir+1;                        // Ajusta dwInicio del rango por encima de la ltima bsqueda
//    WriteLog('1 dwDir='+IntToHex(dwDir,8)+' dwInicio='+IntToHex(dwInicio,8)+ ' dwFinal='+IntToHex(dwFinal,8)+' dwMaximo='+IntToHex(dwMaximo,8)+' dwMinimo='+IntToHex(dwMinimo,8)+' Tamao: '+IntToStr(dwTam));
  end;
  // Aqui repite la bsqueda pero ahora con los CALL indirectos
  buffer:= Char($FF)+Char($15);                  // Busca la instruccin CALL DWORD PTR DS:[<API>]
  dwInicio:= FVirtualOffsetCode+ FBaseOfImage;   // dwInicio = Direccion inicio seccin Code
  dwFinal:= FBaseOfImage+FSizeOfImage;           // dwFinal = Direccin final de todas las secciones
  dwTam:= dwFinal-dwInicio;                      // dwTam = diferencia
  dwDir:= 0;                                     // Coloca valor inicial
  while dwDir <> $FFFFFFFF do                    // Bucle mientras encuentre opcodes buscados
  begin
    dwDir:= Find(dwInicio,dwTam,buffer);         // Aqui hace la bsqueda. DDDDDDDD CALL DWORD PTR DS:[XXXXXXX] dwDir = DDDDDDDD
    if dwDir <> $FFFFFFFF then
    begin
      dwTemp:= ReadMemoryDW(dwDir+2);            // dwTemp = XXXXXXXX operando del call indirecto
      dwTemp2:= ReadMemoryDW(dwTemp);            // dwTemp2 = [XXXXXXXX] = <API>
    end;
    if (dwDir <> $FFFFFFFF) and                                           // Opcode encontrado => dwDIR <> $FFFFFFFF
       (dwTemp > FVirtualOffsetCode+ FBaseOfImage) and
       (dwTemp < FBaseOfImage+FSizeOfImage) and                           // dwTemp por debajo del espacio de memoria de la imagen
//       (dwTemp > FVirtualOffsetCode+FBaseOfImage+FVirtualSizeCode) and    // dwTemp por encima de la seccion de cdigo
       (dwTemp2 > FVirtualOffsetCode+FBaseOfImage+FVirtualSizeCode)then   // dwTemp2 por encima de la ImageBase
    begin                                        // Si es una direccin vlida comprueba inicio y final de IAT
      if dwTemp > dwMaximo then dwMaximo := dwTemp;   // Actualiza final de la API
      if dwTemp < dwMinimo then dwMinimo := dwTemp;   // Actualiza inicio de la API
      inc(dwCount);                                   // Actualiza contador de entradas en API
      WriteLog('Encontrado en: '+IntToHex(dwDir,8)+' valor: '+IntToHex(dwtemp,8)+' API: '+IntToHex(dwTemp2,8));
      New(FFncAPI);                              // Crea un nuevo puntero
      FFncAPI^.AddrAPI := dwTemp2;               // Lee la direccion de la API
      FFncAPI^.AddrIAT:= dwTemp;                 // Lee la direccion de la entrada en la IAT
      FListAPI.Add(FFncAPI);                     // Aade el nuevo puntero a registro TImportAPI
    end;
    if (dwMinimo < $FFFFFFFF) and (dwMinimo > dwFinal) then
      dwFinal:= dwMinimo;                        // Ajusta dwFinal del rango por debajo del inicio de la IAT
    dwTam:= dwFinal-dwDir-2;                     // Calcula tamao del rango
    dwInicio:= dwDir+1;                          // Ajusta dwInicio del rango por encima de la ltima bsqueda
//    WriteLog('2 dwInicio='+IntToHex(dwInicio,8)+ ' dwFinal='+IntToHex(dwFinal,8)+' dwMaximo='+IntToHex(dwMaximo,8)+' dwMinimo='+IntToHex(dwMinimo,8)+' Tamao: '+IntToStr(dwTam));
  end;
  if (dwMinimo = $FFFFFFFF) or                   // Si no ha encontrado ninguna direccion de la IAT vlida
     (dwMaximo = 0) then
  Result:= False                                 // Retorna False
  else
  begin                                          // Si ha encontrado valores vlidos carga la estructura InfoIAT
    InfoIAT.InitIAT:= dwMinimo;
    InfoIAT.EndIAT:= dwMaximo+4;
    InfoIAT.SizeIAT:= dwMaximo+4-dwMinimo;
    InfoIAT.CountIAT:= dwCount;
    WriteLog('Inicio IAT: '+IntToHex(dwMinimo,8));    // Loguea resultados
    WriteLog('Final IAT: '+IntToHex(dwMaximo,8));
    WriteLog('Tamao: '+IntToHex(dwMaximo-dwMinimo,8));
    WriteLog('Entradas en la IAT: '+IntToStr(dwCount));
    InfoIAT.valid:= True;
    Result:= True;
  end;
end;


//xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
// Devuelve un array con los 512 primeros bytes desde el OEP pasado como parmetro
//xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
function TDbgCLS.GetSignatureOEP(OEP: DWORD): String;
(*******************************************************************************)
var
  i: Integer;
  S: String;
begin
  S:= '';
  for i:= 0 to 511 do
  begin
//    S:= S+' '+IntToHex(ReadMemoryB(OEP+i),2);
    S:= S+IntToHex(ReadMemoryB(OEP+i),2);
  end;
  Result:= Copy(S,1,512);
end;


//xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
// Devuelve un string con la instruccion en asm desensamblada en la direccin pasada
// como parmetro.
//xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
function TDbgCLS.DisAsmAddr(Address: DWORD): String;
(*******************************************************************************)
var
  buffer : Array[0..15] of byte;
  i      : Integer;
  P      : Pointer;
  HDE    : HDEinstruction;                       // Estructura definida en HDEngine.pas
  sTemp  : String;
begin
  for i:= 0 to 15 do                             // Carga los 15 primeros opcodes para desensamblar
  begin
    buffer[i]:= ReadMemoryB(Address+i);
  end;
  P:= Addr(buffer);
  hdeDisasm(P,HDE);                              // Llama a HDEngine y devuelve la estructura HDE
  for i:= 0 to HDE.len-1 do
    sTemp:= sTemp + IntToHex(buffer[i],2);
  Result:= IntToHex(Address,8) + '  ';
  Result:= Result + sTemp+StringOfChar(' ', 21-Length(sTemp));  // Cadena con codigo
  sTemp:= DisAsmCLS(Address,HDE);                               // Aqui desensambla
  Result:= Result + sTemp+StringOfChar(' ',32-Length(sTemp));   // Cadena con asm
end;


//xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
// Devuelve una estructura TDasm con informacion de la instruccion desensamblada.
// La direccin inicial se pasa con el elemento AddrIni de la estructura.
//xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
procedure TDbgCLS.GetDisAsm( Var I: TDasm);
(*******************************************************************************)
var
  buffer : Array[0..15] of byte;
  j      : Integer;
  P      : Pointer;
  HDE    : HDEinstruction;                       // Estructura definida en HDEngine.pas
  sTemp  : String;
begin
  for j:= 0 to 15 do                             // Carga los 15 primeros opcodes para desensamblar
  begin
    buffer[j]:= ReadMemoryB(I.AddrIni+j);
  end;
  P:= Addr(buffer);
  hdeDisasm(P,HDE);                              // Llama a HDEngine y devuelve la estructura HDE
  sTemp:= '';
  for j:= 0 to HDE.len-1 do
    sTemp:= sTemp + IntToHex(buffer[j],2);
  I.Opcodes:= sTemp+StringOfChar(' ', 21-Length(sTemp));   // Cadena con codigo
  sTemp:= DisAsmCLS(I.AddrIni,HDE);                        // Aqui desensambla
  I.Disasm:= sTemp+StringOfChar(' ',32-Length(sTemp));     // Cadena con asm
  I.NextAddr:= I.AddrIni + HDE.len;
end;


//xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
// Esta mtodo se proporciona como interface con OCX del metodo GetDisAsm
//xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
procedure TDbgCLS.GetDisAsmX(AddrIni: dword; var Opcodes: String; var DisAsm: String; var NextAddr: dword);   // Para compatibilidad con OCX
(*******************************************************************************)
var
  I: TDasm;
begin
  I.AddrIni:= AddrIni;
  GetDisAsm(I);
  Opcodes:= I.Opcodes;
  DisAsm:= I.Disasm;
  NextAddr:= I.NextAddr;
end;


//xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
// Devuelve el contenido del registro EAX.
//xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
function  TDbgCLS.GetEAX: DWORD;
(*******************************************************************************)
begin
  GetContext;
  Result:= R.EAX;
end;

//xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
// Devuelve el contenido del registro EBX.
//xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
function  TDbgCLS.GetEBX: DWORD;
(*******************************************************************************)
begin
  GetContext;
  Result:= R.EBX;
end;

//xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
// Devuelve el contenido del registro ECX.
//xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
function  TDbgCLS.GetECX: DWORD;
(*******************************************************************************)
begin
  GetContext;
  Result:= R.ECX;
end;

//xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
// Devuelve el contenido del registro EDX.
//xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
function  TDbgCLS.GetEDX: DWORD;
(*******************************************************************************)
begin
  GetContext;
  Result:= R.EDX;
end;

//xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
// Devuelve el contenido del registro ESI.
//xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
function  TDbgCLS.GetESI: DWORD;
(*******************************************************************************)
begin
  GetContext;
  Result:= R.ESI;
end;

//xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
// Devuelve el contenido del registro EDI.
//xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
function  TDbgCLS.GetEDI: DWORD;
(*******************************************************************************)
begin
  GetContext;
  Result:= R.EDI;
end;

//xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
// Devuelve el contenido del registro ESP.
//xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
function  TDbgCLS.GetESP: DWORD;
(*******************************************************************************)
begin
  GetContext;
  Result:= R.ESP;
end;

//xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
// Devuelve el contenido del registro EBP.
//xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
function  TDbgCLS.GetEBP: DWORD;
(*******************************************************************************)
begin
  GetContext;
  Result:= R.EBP;
end;

//xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
// Devuelve el contenido del registro EIP.
//xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
function  TDbgCLS.GetEIP: DWORD;
(*******************************************************************************)
begin
  GetContext;
  Result:= R.EIP;
end;

//xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
// Devuelve el contenido del registro CS.
//xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
function  TDbgCLS.GetsegCS: DWORD;
(*******************************************************************************)
begin
  GetContext;
  Result:= R.segCS;
end;

//xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
// Devuelve el contenido del registro DS.
//xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
function  TDbgCLS.GetsegDS: DWORD;
(*******************************************************************************)
begin
  GetContext;
  Result:= R.segDS;
end;

//xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
// Devuelve el contenido del registro ES.
//xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
function  TDbgCLS.GetsegES: DWORD;
(*******************************************************************************)
begin
  GetContext;
  Result:= R.segES;
end;

//xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
// Devuelve el contenido del registro FS.
//xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
function  TDbgCLS.GetsegFS: DWORD;
(*******************************************************************************)
begin
  GetContext;
  Result:= R.segFS;
end;

//xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
// Devuelve el contenido del registro GS.
//xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
function  TDbgCLS.GetsegGS: DWORD;
(*******************************************************************************)
begin
  GetContext;
  Result:= R.segGS;
end;

//xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
// Devuelve el contenido del registro SS.
//xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
function  TDbgCLS.GetsegSS: DWORD;
(*******************************************************************************)
begin
  GetContext;
  Result:= R.segSS;
end;

//xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
// Devuelve el contenido del registro DR0.
//xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
function  TDbgCLS.GetDR0: DWORD;
(*******************************************************************************)
begin
  GetContext;
  Result:= R.DR0;
end;

//xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
// Devuelve el contenido del registro DR1.
//xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
function  TDbgCLS.GetDR1: DWORD;
(*******************************************************************************)
begin
  GetContext;
  Result:= R.DR1;
end;

//xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
// Devuelve el contenido del registro DR2.
//xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
function  TDbgCLS.GetDR2: DWORD;
(*******************************************************************************)
begin
  GetContext;
  Result:= R.DR2;
end;

//xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
// Devuelve el contenido del registro DR3.
//xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
function  TDbgCLS.GetDR3: DWORD;
(*******************************************************************************)
begin
  GetContext;
  Result:= R.DR3;
end;

//xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
// Devuelve el contenido del registro DR6.
//xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
function  TDbgCLS.GetDR6: DWORD;
(*******************************************************************************)
begin
  GetContext;
  Result:= R.DR6;
end;

//xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
// Devuelve el contenido del registro DR7.
//xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
function  TDbgCLS.GetDR7: DWORD;
(*******************************************************************************)
begin
  GetContext;
  Result:= R.DR7;
end;

//xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
// Devuelve el contenido del registro EFGlags.
//xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
function  TDbgCLS.GetEFlags: DWORD;
(*******************************************************************************)
begin
  GetContext;
  Result:= R.EFlags;
end;

//xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
// Modifica el contenido del registro EAX.
//xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
procedure  TDbgCLS.SetEAX(Value: DWORD);
(*******************************************************************************)
begin
  GetContext;
  R.EAX:= Value;
  SetContext;
end;

//xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
// Modifica el contenido del registro EBX.
//xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
procedure  TDbgCLS.SetEBX(Value: DWORD);
(*******************************************************************************)
begin
  GetContext;
  R.EBX:= Value;
  SetContext;
end;

//xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
// Modifica el contenido del registro ECX.
//xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
procedure  TDbgCLS.SetECX(Value: DWORD);
(*******************************************************************************)
begin
  GetContext;
  R.ECX:= Value;
  SetContext;
end;

//xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
// Modifica el contenido del registro EDX.
//xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
procedure  TDbgCLS.SetEDX(Value: DWORD);
(*******************************************************************************)
begin
  GetContext;
  R.EDX:= Value;
  SetContext;
end;

//xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
// Modifica el contenido del registro ESI.
//xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
procedure  TDbgCLS.SetESI(Value: DWORD);
(*******************************************************************************)
begin
  GetContext;
  R.ESI:= Value;
  SetContext;
end;

//xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
// Modifica el contenido del registro EDI.
//xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
procedure  TDbgCLS.SetEDI(Value: DWORD);
(*******************************************************************************)
begin
  GetContext;
  R.EDI:= Value;
  SetContext;
end;

//xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
// Modifica el contenido del registro ESP.
//xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
procedure  TDbgCLS.SetESP(Value: DWORD);
(*******************************************************************************)
begin
  GetContext;
  R.ESP:= Value;
  SetContext;
end;

//xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
// Modifica el contenido del registro EBP.
//xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
procedure  TDbgCLS.SetEBP(Value: DWORD);
(*******************************************************************************)
begin
  GetContext;
  R.EBP:= Value;
  SetContext;
end;

//xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
// Modifica el contenido del registro EIP.
//xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
procedure  TDbgCLS.SetEIP(Value: DWORD);
(*******************************************************************************)
begin
  GetContext;
  R.EIP:= Value;
  SetContext;
end;

//xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
// Modifica el contenido del registro CS.
//xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
procedure  TDbgCLS.SetsegCS(Value: DWORD);
(*******************************************************************************)
begin
  GetContext;
  R.segCS:= Value;
  SetContext;
end;

//xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
// Modifica el contenido del registro DS.
//xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
procedure  TDbgCLS.SetsegDS(Value: DWORD);
(*******************************************************************************)
begin
  GetContext;
  R.segDS:= Value;
  SetContext;
end;

//xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
// Modifica el contenido del registro ES.
//xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
procedure  TDbgCLS.SetsegES(Value: DWORD);
(*******************************************************************************)
begin
  GetContext;
  R.segES:= Value;
  SetContext;
end;

//xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
// Modifica el contenido del registro FS.
//xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
procedure  TDbgCLS.SetsegFS(Value: DWORD);
(*******************************************************************************)
begin
  GetContext;
  R.segFS:= Value;
  SetContext;
end;

//xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
// Modifica el contenido del registro GS.
//xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
procedure  TDbgCLS.SetsegGS(Value: DWORD);
(*******************************************************************************)
begin
  GetContext;
  R.segGS:= Value;
  SetContext;
end;

//xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
// Modifica el contenido del registro SS.
//xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
procedure  TDbgCLS.SetsegSS(Value: DWORD);
(*******************************************************************************)
begin
  GetContext;
  R.segSS:= Value;
  SetContext;
end;

//xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
// Modifica el contenido del registro DR0.
//xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
procedure  TDbgCLS.SetDR0(Value: DWORD);
(*******************************************************************************)
begin
  GetContext;
  R.DR0:= Value;
  SetContext;
end;

//xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
// Modifica el contenido del registro DR1.
//xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
procedure  TDbgCLS.SetDR1(Value: DWORD);
(*******************************************************************************)
begin
  GetContext;
  R.DR1:= Value;
  SetContext;
end;

//xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
// Modifica el contenido del registro DR2.
//xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
procedure  TDbgCLS.SetDR2(Value: DWORD);
(*******************************************************************************)
begin
  GetContext;
  R.DR2:= Value;
  SetContext;
end;

//xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
// Modifica el contenido del registro DR3.
//xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
procedure  TDbgCLS.SetDR3(Value: DWORD);
(*******************************************************************************)
begin
  GetContext;
  R.DR3:= Value;
  SetContext;
end;

//xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
// Modifica el contenido del registro DR6.
//xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
procedure  TDbgCLS.SetDR6(Value: DWORD);
(*******************************************************************************)
begin
  GetContext;
  R.DR6:= Value;
  SetContext;
end;

//xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
// Modifica el contenido del registro DR7.
//xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
procedure  TDbgCLS.SetDR7(Value: DWORD);
(*******************************************************************************)
begin
  GetContext;
  R.DR7:= Value;
  SetContext;
end;


//xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
// Modifica el contenido del registro EFlags.
//xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
procedure  TDbgCLS.SetEFlags(Value: DWORD);
(*******************************************************************************)
begin
  GetContext;
  R.EFlags:= Value;
  SetContext;
end;

//xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
// Este mtodo se proporciona para hacer de interface entre el componente y el
// activeX
//xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
//    fhIsDebuggerPresent,               // $1
//    fhNTGlobalFlag,                    // $2
//    fhZwQueryInformationProcess,       // $4
//    fhZwSetInformationThread,          // $8
//    fhGetTickCount,                    // $10
//    fhINT3Break,                       // $20
//    fhINT1Break,                       // $40
//    fhINT68Break,                      // $80
//    fhProcess32Next,                   // $100
//    fhAntiDelHBP                       // $200
//xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
procedure TDbgCLS.SetFlagsHideDebugger(value: DWORD);
(*******************************************************************************)
begin
  if (value and $1) > 0 then FFlagsHideDebugger:= FFlagsHideDebugger+[fhIsDebuggerPresent]
  else FFlagsHideDebugger:= FFlagsHideDebugger-[fhNTGlobalFlag];
  if (value and $2) > 0 then FFlagsHideDebugger:= FFlagsHideDebugger+[fhNTGlobalFlag]
  else FFlagsHideDebugger:= FFlagsHideDebugger-[fhNTGlobalFlag];
  if (value and $4) > 0 then FFlagsHideDebugger:= FFlagsHideDebugger+[fhZwQueryInformationProcess]
  else FFlagsHideDebugger:= FFlagsHideDebugger-[fhZwQueryInformationProcess];
  if (value and $8) > 0 then FFlagsHideDebugger:= FFlagsHideDebugger+[fhZwSetInformationThread]
  else FFlagsHideDebugger:= FFlagsHideDebugger-[fhZwSetInformationThread];
  if (value and $10) > 0 then FFlagsHideDebugger:= FFlagsHideDebugger+[fhGetTickCount]
  else FFlagsHideDebugger:= FFlagsHideDebugger-[fhGetTickCount];
  if (value and $20) > 0 then FFlagsHideDebugger:= FFlagsHideDebugger+[fhINT3Break]
  else FFlagsHideDebugger:= FFlagsHideDebugger-[fhINT3Break];
  if (value and $40) > 0 then FFlagsHideDebugger:= FFlagsHideDebugger+[fhINT1Break]
  else FFlagsHideDebugger:= FFlagsHideDebugger-[fhINT1Break];
  if (value and $80) > 0 then FFlagsHideDebugger:= FFlagsHideDebugger+[fhINT68Break]
  else FFlagsHideDebugger:= FFlagsHideDebugger-[fhINT68Break];
  if (value and $100) > 0 then FFlagsHideDebugger:= FFlagsHideDebugger+[fhProcess32Next]
  else FFlagsHideDebugger:= FFlagsHideDebugger-[fhProcess32Next];
  if (value and $200) > 0 then FFlagsHideDebugger:= FFlagsHideDebugger+[fhAntiDelHBP]
  else FFlagsHideDebugger:= FFlagsHideDebugger-[fhAntiDelHBP];
  FValueHideDbgForX:= Value;
//  MSG('Actualizado a: '+IntToStr(Value));
end;


//xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
// Este mtodo se proporciona handle del proceso  el thread creados. Se usa para interface
// entre el componente y el OCX.
// Ver variable P_Info
//xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
procedure TDbgCLS.GetHProcess(var hProcess: DWORD; var hThread: DWORD);
(*******************************************************************************)
begin
  hProcess:= FP_Info.hProcess;
  hThread:= FP_Info.hThread;
end;

//xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
// Este mtodo se proporciona handle del proceso  el thread creados. Se usa para interface
// entre el componente y el OCX.
// Ver variable P_Info
//xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
procedure TDbgCLS.GetIDProcess(var dwProcessId: DWORD; var dwThreadId: DWORD);
(*******************************************************************************)
begin
  dwProcessId:= FP_Info.dwProcessId;
  dwThreadId:= FP_Info.dwThreadId;
end;

//xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
// Este mtodo privado modifica la memoria virtual del proceso depurado
//xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
function TDbgCLS.VProtect(Address: DWORD; Size: DWORD; Prot: DWORD; var OldProt): Boolean;
(*******************************************************************************)
var
  PAddr    : Pointer;
begin
  PAddr:= Pointer(Address);
  result:= VirtualProtectEx(
                  FP_info.hProcess,              // HANDLE hProcess,	// handle of process
                  PAddr,//@address,              // LPVOID lpAddress,	// address of region of committed pages
                  Size,                          // DWORD dwSize,	// size of region
                  Prot,                          // DWORD flNewProtect,	// desired access protection
                  @OldProt);                     // PDWORD lpflOldProtect 	// address of variable to get old protection
end;

//xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
// Este mtodo escribe cdigo ensamblado en la direccin Address.
// El cdigo ASM se pasa como parametro en el texto source
// Utiliza el ensamblador FASM version 1.67 Copyright (c) 1999-2009, Tomasz Grysztar.
//xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
function TDbgCLS.AsmAddr(Address: DWORD; source: String): Boolean;
(*******************************************************************************)
var
  fs          : TextFile;                        // Archivo de salida con source ASM para que lo recoja Fasm
  DirTemp     : String;

begin
  DirTemp:= GetEnvironmentVariable('TEMP');      // Directorio temporal de windows
  AssignFile(fs,DirTemp+'\ASM_IN.ASM');          // Crea archivo con source
  Rewrite(fs);                                   // Escribe source en archivo
  Writeln(fs, 'use32'+#13#10+'org '+IntToHex(Address,8)+'h'+#13#10+source);
  CloseFile(fs);
  Result:= AsmAddrFile(Address, DirTemp+'\ASM_IN.ASM');   // Ensambla source escrito en ASM_IN.ASM
end;


//xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
// Este mtodo escribe cdigo ensamblado en la direccin Address.
// El cdigo ASM se pasa como parametro en el el archivo sFile
// Utiliza el ensamblador FASM version 1.67 Copyright (c) 1999-2009, Tomasz Grysztar.
//xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
function TDbgCLS.AsmAddrFile(Address: DWORD; sFile: String): Boolean;
(*******************************************************************************)
var
  fs          : TextFile;                        // Archivo de salida con source ASM para que lo recoja Fasm
  fe          : TextFile;                        // Archivo de entrada con opcodes ensmblados por Fasm
  zAppName    : array[0..512] of char;           // Ruta y nombre del ensamblador
//  zCurDir     : array[0..255] of char;

  StartupInfo : TStartupInfo;                    // Estructura necesaria para CreateProcess
  ProcessInfo : TProcessInformation;             // Estructura necesaria para CreateProcess
  Resultado   : dword;                           // Resultado de CreateProcess
//   Opcode    : Array[0..4096] of Char;
  ContaBytes  : dword;                           // Numero de opcodes ensamblados
  Ch          : Char;
  S           : String;
  DirTemp     : String;
  //  WorkDir     : String;
begin
  Result:= False;                                // Inicializar resultado de la funcin
  DirTemp:= GetEnvironmentVariable('TEMP');      // Directorio temporal de windows
  deleteFile(DirTemp+'\CODE_OUT.BIN');           // borra ensamblados anteriores
  deleteFile(ExtractFilePath(Application.ExeName)+'ASM_ERRORR.ASM');      // borra archivos de error anteriores
  if Not FileExists(ExtractFilePath(Application.ExeName)+'FASM.EXE') then
  begin
    MSG('No se ha encontrado FASM.EXE'+#13#10+
        'FASM Copyright (c) 1999-2009, Tomasz Grysztar.'+#13#10+
        'se utiliza para ensamblar en lnea.');
    exit;
  end;
  deleteFile(DirTemp+'\CODE_OUT.BIN');           // borra ensamblados anteriores
                                                 // Prepara comando para ejecutar Fasm
  StrPCopy(zAppName, 'FASM.EXE '+sFile+' '+DirTemp+'\CODE_OUT.BIN ');// C:\~Mensajes.txt');
//  GetDir(0,WorkDir);
//  StrPCopy(zCurDir,WorkDir);
  FillChar(StartupInfo,Sizeof(StartupInfo),#0);  // Inicializa estructuras
  StartupInfo.cb := Sizeof(StartupInfo);
  StartupInfo.dwFlags := STARTF_USESHOWWINDOW;
  StartupInfo.wShowWindow := SW_SHOWMINNOACTIVE;
  if not CreateProcess(nil,
     zAppName,                                   { pointer to command line string }
     nil,                                        { pointer to process security attributes}
     nil,                                        { pointer to thread security attributes}
     false,                                      { handle inheritance flag }
     CREATE_NEW_CONSOLE or                       { creation flags }
     NORMAL_PRIORITY_CLASS,
     nil,                                        { pointer to new environment block }
     nil,                                        { pointer to current directory name }
     StartupInfo,                                { pointer to STARTUPINFO }
     ProcessInfo) then Result := False           { pointer to PROCESS_INF }
  else begin
    WaitforSingleObject(ProcessInfo.hProcess,INFINITE);    // Espera a que el proceso termine
    GetExitCodeProcess(ProcessInfo.hProcess,Resultado);    // Recoge resultado del proceso
    if Resultado <> 0 then
    begin
       AssignFile(fs,DirTemp+'\ASM_IN.ASM');          // Abre archivo con source
       Reset(fs);
       WriteLog('ENSAMBLADO CON ERROR:');
       while not eof(fs) do
       begin
          Readln(fs, S);
          WriteLogWD(S);                         // Escribe source en el LOG
       end;
       CloseFile(fs);                            // Copia codigo erroneo en archivo directorio de trabajo
       CopyFile(PChar(DirTemp+'\ASM_IN.ASM'),PChar(ExtractFilePath(Application.ExeName)+'ASM_ERROR.ASM'),False);
       Result:= False                            // Si falla ensablado retorna False
    end
    else                                         // Si ensamblado OK
    begin
      AssignFile(fe, DirTemp+'\CODE_OUT.BIN');   // Abre archivo binario de entrada
      reset(fe);
      ContaBytes:= 0;
      S:= '';
      while not eof(fe) do                       // Lee opcodes desde archivo .BIN
      begin
        Read(fe, Ch);
        S:= S+IntToHex(byte(Ch),2);
        WriteMemoryB(Address+ContaBytes,byte(Ch));    // Escribe opcodes en memoria virtual del depurado
        inc(ContaBytes);
      end;
      CloseFile(fe);
      WriteLog('Ensamblados opcodes: '+S+' en la direccin '+IntToHex(Address,8));
      Result:= True;
    end;
  end;
end;

//xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
// Carga el inicio de la IAT.
// Si la estructura FInfoIAT no tiene valores vlidos, llama al metodo privado FindIAT
//xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
function TDbgCLS.GetInitIAT: DWORD;
(*******************************************************************************)
begin
  if FInfoIAT.valid then Result:= FInfoIAT.InitIAT
  else
  begin
    FindIAT(FInfoIAT);
    Result:= FInfoIAT.InitIAT;
  end;
end;


//xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
// Carga el fin de la IAT.
// Si la estructura FInfoIAT no tiene valores vlidos, llama al metodo privado FindIAT
//xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
function TDbgCLS.GetEndIAT: DWORD;
(*******************************************************************************)
begin
  if FInfoIAT.valid then Result:= FInfoIAT.EndIAT
  else
  begin
    FindIAT(FInfoIAT);
    Result:= FInfoIAT.EndIAT;
  end;
end;

//xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
// Carga el tamao de la IAT.
// Si la estructura FInfoIAT no tiene valores vlidos, llama al metodo privado FindIAT
//xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
function TDbgCLS.GetSizeIAT: DWORD;
(*******************************************************************************)
begin
  if FInfoIAT.valid then Result:= FInfoIAT.SizeIAT
  else
  begin
    FindIAT(FInfoIAT);
    Result:= FInfoIAT.SizeIAT;
  end;
end;

//xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
// Carga el numero de entradas en la IAT.
// Si la estructura FInfoIAT no tiene valores vlidos, llama al metodo privado FindIAT
//xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
function TDbgCLS.GetCountIAT: DWORD;
(*******************************************************************************)
begin
  if FInfoIAT.valid then Result:= FInfoIAT.CountIAT
  else
  begin
    FindIAT(FInfoIAT);
    Result:= FInfoIAT.CountIAT;
  end;
end;

//xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
// Toma el cdigo de la ltima excepcion sucedida.
//xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
function TDbgCLS.GetLastException: DWORD;
(*******************************************************************************)
begin
  Result:= FLastException;
end;

//xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
// Toma la direccin de acceso donde se produce la excepcin en BPM
//xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
function TDbgCLS.GetAddrInBPM: DWORD;
(*******************************************************************************)
begin
  Result:= FAddrInBPM;
end;

//xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
// Toma BaseOfImage (normalmente $400000)
//xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
function TDbgCLS.GetBaseOfImage: DWORD;
(*******************************************************************************)
begin
  Result:= FBaseOfImage;
end;

//xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
// Toma la direccion del Entry Point
//xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
function TDbgCLS.GetEntryPoint: DWORD;
(*******************************************************************************)
begin
  Result:= FStartAddress;
end;

//xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
// Toma la direccion en la que ocurri la ultima excepcin.
//xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
function TDbgCLS.GetLastAddr: DWORD;
(*******************************************************************************)
begin
  Result:= FLastAddr;
end;

//xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
// Toma el cdigo del ltimo evento sucedido.
//xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
function TDbgCLS.GetLastEventCode: DWORD;
(*******************************************************************************)
begin
  Result:= FLastEventCode;
end;

//xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
// Toma modo de acceso cuando se produce un BPM 0= Lectura; 1= Escritura
//xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
function TDbgCLS.GetModeInBPM: DWORD;
(*******************************************************************************)
begin
  Result:= FModeInBPM;
end;

//xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
// Relacin entre VirtualSize/RawSize
//xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
function TDbgCLS.GetRatioSize: Single;
(*******************************************************************************)
begin
  Result:= FRatioSize;
end;

//xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
// Toma el tamao de la imagen
//xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
function TDbgCLS.GetSizeOfImage: DWORD;
(*******************************************************************************)
begin
  Result:= FSizeOfImage;
end;

//xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
// Toma Virtual Offset de la seccion code
//xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
function TDbgCLS.GetVirtualOffsetCode: DWORD;
(*******************************************************************************)
begin
  Result:= FVirtualOffsetCode;
end;


//xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
// Toma Virtual Size de la seccion code
//xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
function TDbgCLS.GetVirtualSizeCode: DWORD;
(*******************************************************************************)
begin
  Result:= FVirtualSizeCode;
end;


//xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
// Esta funcin desattachea el debugger del proceso debuggeado
// Solo est disponible para XP
// La API DebugSetProcessKillOnExit se carga dinmicamente si es posible
// Gracias a Gerardo Richarte por la idea y por el cdigo
//xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
function TDbgCLS.Dettach: Boolean;
var
   DebugSetProcessKillOnExit: TDebugSetProcessKillOnExit;
   hlib: Thandle;

begin
  DebugSetProcessKillOnExit:= nil;
  hlib := GetModuleHandle('kernel32.dll');            // Carga librera para API
  if hlib <= HINSTANCE_ERROR then
  begin
    WriteLog('Error al cargar kernel32.dll');
    Result := False;
  end
  else
  begin                                               // Busca direccin de la API
    @DebugSetProcessKillOnExit := GetProcAddress(hlib, 'DebugSetProcessKillOnExit');
    if not Assigned(DebugSetProcessKillOnExit) then
    begin                                             // Falla al buscar API. No disponible para W2000
      Result := False;
      WriteLog('Error al desconectar. No encontrada API. Solo disponible para XP');
    end
    else                                              // Si est disponible ejecuta la API para "desattachear"
    begin
      if not DebugSetProcessKillOnExit(false) then
      begin
        WriteLog('Error al desconectar del proceso '+SysErrorMessage(GetLastError()));
        Result:= False;
      end
      else
      begin
        WriteLog('Desconectado del proceso correctamente');
        Result:= True;
      end;
      DisableAllHBP;                                  // Deshabilita todos los HBP
      DisableAllBP;                                   // Deshabilita todos los BP
      ClearBPM;                                       // Deshabilita BPM
      GetContext;                                     // Lee CONTEXT para desactivar TRAP FLAG
      R.EFlags:= R.EFlags and N_MSK_TF;               // Pone bit 8 de regFlag a 0 => desactivar TRAP FLAG
      SetContext;                                     // Guarda contexto
      FIsLoopActive:= False;                          // Pone flag a false para salir del bucle de depuracion
    end;
  end;
end;

end.



